<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// adminfilter.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-admin' ;
	$tran = 'admin' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("Choose Admin Action to Perform :") ,
				'lang_criteria'	=> exapi_lang("Admin Parameters") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Action") ,
				'lang_add'	=> exapi_lang("Done") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$chartlist1 = exapi_lang('1 -- Default Chart of Accounts') ;
	$chartlist2 = exapi_lang('2 -- Chart of Accounts for Non-profit Org (School Band)') ;
	$chartlist3 = exapi_lang('3 -- Chart of Accounts for Property Management Org') ;
	$chartlist =	"<OPTION value='1'>$chartlist1</OPTION>" ;
	$chartlist.=	"<OPTION value='2'>$chartlist2</OPTION>" ;
	$chartlist.=	"<OPTION value='3'>$chartlist3</OPTION>" ;
	$instestenv = exapi_lang('Install Test Environment') ;
	$insprodenv = exapi_lang('Install Production Environment') ;
	$convertchi = exapi_lang('Convert big5/gb18030 to utf-8') ;
	$note_chart1 = exapi_lang("Generate chosen Chart of Accounts, tax and other essential data.") ;
	$note_chart2 = exapi_lang("It is most likely that you will have to adjust these master data to meet your local requirements.");
	$warning1 = exapi_lang("For use by Chinese eGroupWare Users only");
	$warning2 = exapi_lang("You need to allow Apache to write to your script folders") ;
	$warning3 = exapi_lang("Restore the script folders original access right afterwards") ;
	$warning4 = exapi_lang("If you are not Chinese eGroupWare user, you should terminate immediately") ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Which Action') ,
				type		=>	'select' ,
				selectlist	=>	"" ,
				varname		=>	'actnum' ,
				defval		=>	'' ,
				note		=>	exapi_lang('If wrong action chosen, click [Admin/Setup] to restart'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Which Chart') ,
				type		=>	'select' ,
				selectlist	=>	$chartlist ,
				varname		=>	'chart' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Select the target Chart of Account to install'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Explanatory Message'),
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	exapi_lang('[No Input Required]') ,
				note		=>	$instestenv					);

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Explanatory Message'),
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	exapi_lang('[No Input Required]') ,
				note		=>	$insprodenv					);

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Explanatory Message'),
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	exapi_lang('[No Input Required]') ,
				note		=>	"<b>$warning1.  $warning2.  $warning3.<br>$warning4.</b>"	);
	
	$act1 = "1 -- $instestenv" ;
	$act2 = "2 -- $insprodenv" ;
	$act3 = "3 -- $convertchi" ;
	$ckapi[filter][actlist] = array (	1=>	"<OPTION value='1'>$act1</OPTION>",
						2=>	"<OPTION value='2'>$act2</OPTION>",
						3=>	"<OPTION value='3'>$act3</OPTION>"	) ;

	$ckapi[filter][actstring] = array(	"0",		/* first entry	*/
						"02",		/* Action 1	*/
						"013",		/* Action 2	*/
						"04",		/* Action 3	*/		) ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_filter() ;
	exapi_footer() ;

?>
