<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.ck_log.inc.php 0.13.1 2005/06/15 C K Wu

    class ck_log {

//---- Update Log

    function update_log($script,$op,$parents,$children,$timestamp,$trans_id,$logid) {
	global $ckapi,$pre,$adodb ;

	$db_type = $ckapi[hostsys][dbtype] ;
	$app = $ckapi[params][app] ;
	$ip =($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'] ;
	$user = $ckapi[hostsys][username];
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$adodb->query($sql);

	$table = $parents[0] ;
	if ($db_type=="mysql")	$sql = "SELECT a.* FROM $table a LEFT JOIN ${pre}log b ON a.id=b.id WHERE b.id IS NULL" ;
	  else	$sql = "SELECT * FROM $table EXCEPT (SELECT a.* FROM $table a, ${pre}log b WHERE a.id=b.id)" ;
	if ($trans_id<>"")	$sql = "SELECT * FROM $table WHERE id='$trans_id'" ;
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$idarr[$i] = $rs['id'] ;
		$header[$i][$table] = $rs;
		}
	foreach ($parents as $key => $value) {
		if ($key==0)	continue ;
		For ($i=1;isset($idarr[$i]);$i++) {
			$result = $adodb->query("SELECT * FROM $value WHERE id = $idarr[$i]");
			$header[$i][$value] = $result->fetchRow() ;
			}
		}
	if (is_array($children)) {
		foreach ($children as $key => $value) {
			For ($i=1;isset($idarr[$i]);$i++) {
				$result = $adodb->query("SELECT * FROM $key WHERE $value = '$idarr[$i]'");
				For ($j=1;$rs=$result->fetchRow();$j++)	$detail[$i][$key][$j] = $rs ;
				}
			}
		}
	For ($i=1;isset($idarr[$i]);$i++) {
		$id = $idarr[$i] ;
		$lid = ($logid=='') ? $id : $logid ;
		$iptime = "$ip=$timestamp=$script=$id" ;
		$headerarr = addslashes(serialize($header[$i]));
		$detailarr = ( is_array($detail[$i]) ) ? addslashes(serialize($detail[$i])) : '' ;
		$sql= "INSERT INTO ${pre}log (id,trans_id,app,script,ip,userid,op,timestamp,header,detail,iptime) ";
		$sql.= "VALUES ('$lid','$id','$app','$script','$ip','$user','$op','$timestamp','$headerarr','$detailarr','$iptime')";
		$adodb->query($sql);
		}

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$adodb->query($sql);

	}

//---- Write Log Detail

    function log_write(&$t, $l) {
	global $ckapi ;

	$th_bg = $ckapi[hostsys][th_bg] ;
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('th_bg',$th_bg);
	$t->set_var('lang_id',exapi_lang('Audit / LogTable ID'));
	$t->set_var('lang_timestamp',exapi_lang('Timestamp'));
	$t->set_var('lang_date',exapi_lang('Date(y/m/d)'));
	$t->set_var('lang_time',exapi_lang('Time'));
	$t->set_var('lang_iptime',exapi_lang('IPTime'));
	$t->set_var('lang_trans_id',exapi_lang('Transaction ID'));
	$t->set_var('lang_app',exapi_lang('Application'));
	$t->set_var('lang_op',exapi_lang('Operation'));
	$t->set_var('lang_script',exapi_lang('Script'));
	$t->set_var('lang_ip',exapi_lang('IP'));
	$t->set_var('lang_user',exapi_lang('User'));
	$t->set_var('lang_detail_id',exapi_lang('Detail Record ID'));
	$t->set_var('lang_table',exapi_lang('Table Name'));
	$t->set_var('lang_field',exapi_lang('Field Name'));
	$t->set_var('lang_value',exapi_lang('Value'));
	$op = $l[op] ;
	switch ($op) :
		case "new" :	$desc = exapi_lang("Post-insert image") ;	break ;
		case "edit" :	$desc = exapi_lang("Post-edit image") ;	break ;
		case "delete" :	$desc = exapi_lang("Pre-delete image") ;	break ;
		case "clear" :	$desc = exapi_lang("Pre-clear image") ;	break ;
		case "approve":	$desc = exapi_lang("Post-approve image") ;	break ;
		case "cancel":	$desc = exapi_lang("Post-cancel image") ;	break ;
		case "reject":	$desc = exapi_lang("Post-reject image") ;	break ;
		endswitch ;
	$t->set_var('lang_header',exapi_lang('Header Record')." [$desc]");
	$t->set_var('lang_detail',exapi_lang('Detail Records')." [$desc]");

	$timestamp = $l[timestamp] ;
	$t->set_var('id',$l[id]);
	$t->set_var('timestamp',$timestamp);
	$t->set_var('year',date("Y",$timestamp));
	$t->set_var('month',date("m",$timestamp));
	$t->set_var('day',date("d",$timestamp));
	$t->set_var('time',date("H:i:s",$timestamp));
	$t->set_var('trans_id',$l[trans_id]);
	$t->set_var('app',$l[app]);
	$t->set_var('op',$op);
	$t->set_var('script',$l[script]);
	$t->set_var('ip',$l[ip]);
	$t->set_var('iptime',$l[iptime]);
	$t->set_var('user',$l[userid]);

	if ($l[header]<>"") {
		$header = unserialize($l[header]) ;
		foreach ($header as $hdrkey => $hdrvalue) {
			$t->set_var('table',$hdrkey);
			if (is_array($hdrvalue)) {
				foreach ($hdrvalue as $key => $value)
					if (!is_numeric($key)) {
						$t->set_var('field',$key);
						$t->set_var('value',$value);
						$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
						$t->set_var('tr_color',$tr_color) ;
						$t->parse('header_section','header', True);
						}
				$t->set_var('table',"");
				$t->set_var('field',"");
				$t->set_var('value',"");
				$t->set_var('tr_color',$th_bg) ;
				$t->parse('header_section','header', True);
				}
			else if (!is_numeric($hdrkey)) {
				$t->set_var('field',$hdrkey);
				$t->set_var('value',$hdrvalue);
				$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
				$t->set_var('tr_color',$tr_color) ;
				$t->parse('header_section','header', True);
				}
			}
		}
	   else $t->set_var('header_section','') ;
	if ($l[detail]<>"") {
		$detail = unserialize($l[detail]) ;
		foreach ($detail as $detkey => $detail_i) {
			foreach ($detail_i as $key_i => $val_i) {
				$t->set_var('table',$detkey);
				$detail_id = $val_i['id'] ;
				if (is_array($val_i)) {
					foreach ($val_i as $key => $value)
						if (!is_numeric($key)) {
							$t->set_var('detail_id',$detail_id);
							$t->set_var('field',$key);
							$t->set_var('value',$value);
							$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
							$t->set_var('tr_color',$tr_color) ;
							$t->parse('detail_section','detail', True);
							}
					}
				$t->set_var('table',"");
				$t->set_var('detail_id',"");
				$t->set_var('field',"");
				$t->set_var('value',"");
				$t->set_var('tr_color',$th_bg) ;
				$t->parse('detail_section','detail', True);
				}
			}
		}
	   else $t->set_var('detail_section','') ;
	}

    }

?>
