<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// loglist.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-admin' ;
	$class = 'ck_log' ;
	$tran = 'log' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$return = ($_GET["return"]) ? $_GET["return"] : $_POST["return"] ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$logfilter = ($_GET["logfilter"]) ? $_GET["logfilter"] : $_POST["logfilter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = urldecode(stripslashes($logfilter)) ;

	$proc = newobj('ck-api','process') ;
	$where = $proc->decode_where($where) ;

	$t = ckapi_tpl($app);
	$t->set_file(array('report' => "${tran}list.tpl", 'detail' => "${tran}list.tpl"));
	$t->set_block('detail','detail_row','detail_section');

//---------------------------- list variable template-declarations -------------------------

	$user = $ckapi[hostsys][username];
	$sql = "SELECT rolecode FROM ${pre}role a, ${pre}employee b, ${pre}empperson c " ;
	$sql.= "WHERE c.username='$user' and b.id=a.empid and c.id=b.contactid" ;
	$result = $adodb->query($sql);
	$allowaccess = False ;
	While ($rs=$result->fetchRow()) {
		$role = $rs['rolecode'] ;
		if ($role=='Auditor' or $role=='AudMgr') {$allowaccess=True;	break;}
		}
	if (!$allowaccess) {
		echo exapi_lang("You are not authorised to access the requested information.") ;
		exit() ;
		}

$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
$tr_color2 = $ckapi[hostsys][tr_color2] ;
$t->set_var('lang_title',exapi_lang('List of log entries'));
$t->set_var('lang_sorthead',exapi_lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',exapi_lang('done'));
if (!$return)	$return = "/$app/${tran}filter.php" ;
$t->set_var('add_action',exapi_link($return,"filter=$filter"));
$t->set_var('lang_year',exapi_lang('Year'));
$t->set_var('lang_month',exapi_lang('Month'));
$t->set_var('lang_day',exapi_lang('Day'));
$t->set_var('lang_time',exapi_lang('Time'));
$t->set_var('lang_view',exapi_lang('View'));

$getstr = "return=$return&logid=$logid&logfilter=$logfilter" ;
if (isset($id))	$getstr = "id=$id&filter=$filter&$getstr" ;
$script = "/$app/${tran}list.php" ;

$t->set_var('sort_timestamp',$proc->sortlink(exapi_lang('Timestamp'),$script,'timestamp',$sort,$getstr));
$t->set_var('sort_trans_id',$proc->sortlink(exapi_lang('Transaction ID'),$script,'trans_id',$sort,$getstr));
$t->set_var('sort_app',$proc->sortlink(exapi_lang('Application'),$script,'app',$sort,$getstr));
$t->set_var('sort_op',$proc->sortlink(exapi_lang('Operation'),$script,'op',$sort,$getstr));
$t->set_var('sort_script',$proc->sortlink(exapi_lang('Script'),$script,'script',$sort,$getstr));
$t->set_var('sort_ip',$proc->sortlink(exapi_lang('IP'),$script,'ip',$sort,$getstr));
$t->set_var('sort_userid',$proc->sortlink(exapi_lang('User'),$script,'userid',$sort,$getstr));
$t->set_var('sort_id',$proc->sortlink(exapi_lang('Log Table Id'),$script,'id',$sort,$getstr));
$t->set_var('lang_view',exapi_lang('View'));

if (!$order)	$order = "timestamp" ;
if (!$sort)	$sort = "ASC" ;
if ($id)	$where = " trans_id = $id " ;
$result = $adodb->query("SELECT * from ${pre}log WHERE $where order by $order $sort");

// -------------------------------- end declaration -----------------------------------------

if ($result->RecordCount()==0) {
	$t->set_var(array('timestamp'	=> exapi_lang("No Matching Item Found"),
			'year'	=> "",
			'month'	=> "",
			'day'	=> "",
			'time'	=> "",
			'trans_id'	=> "",
			'app'	=> "",
			'op'	=> "",
			'script'=> "",
			'ip'	=> "",
			'userid'=> "",
			'id'	=> "",
			'view'	=> "",
				 ));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail_row',True);
	}
While ($rs=$result->fetchRow()) {
	$logid = $rs['id'] ;
	$timestamp = $rs['timestamp'] ;
	$op = $rs['op'] ;
	$getstr = "return=$return&logid=$logid&logfilter=$logfilter" ;
	if (isset($id))	$getstr = "id=$id&filter=$filter&$getstr" ;
	switch ($op) :
		case "new" :	$lang_op = exapi_lang("new");		break;
		case "edit" :	$lang_op = exapi_lang("edit");	break;
		case "delete" :	$lang_op = exapi_lang("delete");	break;
		case "marker" :	$lang_op = exapi_lang("marker");	break;
		case "clear" :	$lang_op = exapi_lang("clear");	break;
		case "import" :	$lang_op = exapi_lang("import");	break;
		case "approve":	$lang_op = exapi_lang("approve");	break;
		case "cancel":	$lang_op = exapi_lang("cancel");	break;
		case "reject":	$lang_op = exapi_lang("reject");	break;
		default:	$lang_op = exapi_lang("Error: please inform sysadmin");	break;
		endswitch ;
	$t->set_var(array('timestamp'	=> $timestamp,
			'year'	=> date("Y",$timestamp),
			'month'	=> date("m",$timestamp),
			'day'	=> date("d",$timestamp),
			'time'	=> date("H:i:s",$timestamp),
			'trans_id'	=> $rs['trans_id'],
			'app'	=> $rs['app'],
			'op'	=> $lang_op,
			'script'=> $rs['script'],
			'ip'	=> $rs['ip'],
			'userid'=> $rs['userid'],
			'id'	=> $rs['id'],
			'view'	=> exapi_link("/$app/${tran}view.php",$getstr),
						)) ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','detail','report');
	exapi_footer() ;

?>
