<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.invoice.inc.php 0.13.1 2005/06/15 C K Wu

    class invoice {

//---- Invoice List SQL Formation

    function invoice_list_sql() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	if ($ckapi[params][tran]=="invoicent")	$where = "amount=netamount $where" ;	else	$where = "amount<>netamount $where";
	$last10 = substr($where,strlen($where)-10,10) ;
	$fields = "transdate,duedate,invnumber,ordnumber,name,isocode,amount,a.id" ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$sql1 =	"SELECT $fields FROM ${pre}ar a, ${pre}customer b WHERE $where AND a.customer=b.id " ;
		$sql2 =	"SELECT $fields FROM ${pre}ar a, ${pre}customer b, ${pre}r_match c " ;
		$sql2.=	"WHERE $where AND customer=b.id AND a.id=c.invoiceid " ;
		$sql2.=	"GROUP BY $fields HAVING sum(s_amount)>=amount " ;
		if ($ckapi[hostsys][dbtype]=="mysql")	{
			$user = $ckapi[hostsys][username] ;
			$ckapi[params_sql][temp1] = $temp1 = "${pre}arntl1".$user.time() ;
			$ckapi[params_sql][temp2] = $temp2 = "${pre}arntl2".$user.time() ;
			$adodb->query("CREATE TABLE $temp1 AS $sql1");
			$adodb->query("CREATE TABLE $temp2 AS $sql2");
			$sql = "SELECT $temp1.* FROM $temp1 LEFT JOIN $temp2 " ;
			$sql.= "ON $temp1.id=$temp2.id WHERE $temp2.id IS NULL ORDER BY $order $sort" ;
			}
			else	$sql="$sql1 EXCEPT $sql2 ORDER BY $order $sort" ;
		}
	  else	$sql =	"SELECT $fields FROM ${pre}ar a, ${pre}customer b WHERE $where AND a.customer=b.id ORDER BY $order $sort";
	return $sql ;
	}

//---- Invoice List Link Adjustement

    function invoice_list_adjust() {
	global $ckapi ;

	$app = $ckapi[params][app] ;
	$tran = $ckapi[params][tran] ;
	foreach ($ckapi[params_list] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;
	$return = "/$app/${tran}list.php" ;
	$getstr = "id=$dt[id]&filter=$filter&return=$return" ;
	$t->set_var('edit_addtax',exapi_link("/$app/invoicewtedit.php",$getstr)) ;
	$getstr = "order=$order&sort=$sort&id=$dt[id]&filter=$filter" ;
	$t->set_var('bulk_action',exapi_link("/$app/${tran}bulk.php",$getstr)) ;
	$disabled = ($dt[id]=="") ? "disabled" : "" ;
	$t->set_var('disabled',$disabled) ;
	}

//---- Invoice Data Read

    function invoice_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$script = $ckapi[params_post][script] ;

	$result = $adodb->query("SELECT * FROM $table WHERE id='$id'");
	$dt = $result->fetchRow() ;
	$dt[taxstatus] = ($tran=="invoicent") ? "e" : $dt[taxincluded] ;
	$dt[oldisocode] = $dt[isocode] ;
	if ($script=="so2invcopy") {
		$dt[transdate] = $dt[duedate] = "" ;
		$dt[ordnumber] = $dt[sonumber] ;
		}
	$table = ($script=="so2invcopy") ? "${pre}oitem" : "${pre}invoice" ;
	$result = $adodb->query("SELECT * FROM $table WHERE trans_id='$id' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['itemid'.$i]		=	$rs['itemid'] ;
		$dt['itemtype'.$i]		=	$rs['itemtype'] ;
		$dt['description'.$i]		=	$rs['description'] ;
		$dt['qty'.$i]			=	$rs['qty'] ;
		$dt['unit'.$i]			=	$rs['unit'] ;
		$dt['price'.$i]			=	$rs['price'] ;
		$dt['cost'.$i]			=	$rs['cost'] ;
		$dt['discount'.$i]		=	$rs['discount'] ;
		$dt['income_accno_id'.$i]	=	$rs['income_accno_id'] ;
		$dt['inventory_accno_id'.$i]	=	$rs['inventory_accno_id'] ;
		$dt['expense_accno_id'.$i]	=	$rs['expense_accno_id'] ;
		$dt['tax1'.$i]			=	$rs['tax1'] ;
		$dt['tax2'.$i]			=	$rs['tax2'] ;
		$dt['tax1_accno_id'.$i]		=	$rs['tax1_accno_id'] ;
		$dt['tax2_accno_id'.$i]		=	$rs['tax2_accno_id'] ;
		}
	return $dt ;
	}

//---- Invoice Add Initialisation

    function invoice_add_init() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$dt['transdate'] = date("Y-m-d") ;
	$result = $adodb->query("SELECT nativecurr FROM ${pre}defaults");
	$dt['isocode'] = $dt['oldisocode'] = $result->fields('nativecurr') ;
	$result = $adodb->query("SELECT exrate FROM ${pre}currency WHERE isocode='$dt[isocode]'");
	$dt['exrate'] = $result->fields('exrate') ;
	}

//---- Invoice Detail Validation Checks

    function invoice_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error");
	if ($dt[invnumber]=="")			$err=exapi_lang("Invoice Number Missing");
	if (input2date($dt[transdate])=="")	$err=exapi_lang("Invalid Invoice Date");
	if (input2date($dt[duedate])=="")	$err=exapi_lang("Invalid Due Date");
	if ($dt[exrate]<=0)			$err=exapi_lang("Invalid Exchange Rate") ;
	$result = $adodb->query("SELECT nativecurr FROM ${pre}defaults");
	if ($dt[isocode]==$result->fields('nativecurr') and $dt[exrate]<>1)
					$err=exapi_lang("Exchange rate for ledger currency must = 1") ;
	$result = $adodb->query("SELECT * FROM ${pre}currency WHERE isocode='$dt[isocode]'");
	$nativeexrate = $result->fields('exrate') ;
	if ($nativeexrate>0) {
		$ratio = $dt[exrate]/$nativeexrate ;
		if (0.8>$ratio or $ratio>1.2)
					$err=exapi_lang("Exchange rate deviates too much from default") ;
		}
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		$row = exapi_lang("Row") ;	$rowi = "[$row $i]" ;
		if ($dt['itemid'.$i]=='')	$err=exapi_lang("Item Code Missing");
		if ($dt['qty'.$i] and !is_numeric($dt['qty'.$i]))
					$err=$rowi.exapi_lang("Invalid Qty, must be numeric.");
		if ($dt['discount'.$i] and !is_numeric($dt['discount'.$i]) and $dt[taxstatus]<>"t")
					$err=$rowi.exapi_lang("Invalid Discount, must be numeric.");
		if ($dt['price'.$i] and !is_numeric($dt['price'.$i]))
					$err=$rowi.exapi_lang("Invalid Unit Price, must be numeric.");
		if ($dt['cost'.$i] and !is_numeric($dt['cost'.$i]))
					$err=$rowi.exapi_lang("Invalid Unit Cost, must be numeric.");
		if ($dt['tax1'.$i] and !is_numeric($dt['tax1'.$i]))
					$err=$rowi.exapi_lang("Invalid Tax1, must be numeric.");
		if ($dt['tax2'.$i] and !is_numeric($dt['tax2'.$i]))
					$err=$rowi.exapi_lang("Invalid Tax2, must be numeric.");
		if (($dt[taxstatus]=="f" or $dt[taxstatus]=="t") and $dt['tax1_pref'.$i]=='')
					$err=$rowi.exapi_lang("Blank Choice on Primary Tax Rate");
		if (($dt[taxstatus]=="f" or $dt[taxstatus]=="t") and $dt['tax2_pref'.$i]=='')
					$err=$rowi.exapi_lang("Blank Choice on Secondary Tax Rate");
		}
	if ($dt[isocode]<>$dt[oldisocode]) {
		$msg1 = exapi_lang('Currency changed') ;
		$msg2 = exapi_lang('Default exchange rate loaded') ;
		$msg3 = exapi_lang('Ensure pre-existing (discount,price,cost,tax) are still valid') ;
		$msg4 = exapi_lang('Click [Post Invoice] to re-activate invoice posting') ;
		$err = "$msg1;  $msg2;  $msg3;  $msg4" ;
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write Invoice Header

    function invoice_header_write() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$script = &$ckapi[params_post][script] ;
	$t = &$ckapi[objects][template] ;

	$result = $adodb->query("SELECT nativecurr FROM ${pre}defaults");
	$loc_for = ($result->fields('nativecurr')==$dt[isocode]) ? exapi_lang('Local') : exapi_lang('*** Foreign ***') ;
	$taxstatus = $dt[taxstatus] ;
	$t->set_var('lang_invnumber',exapi_lang('Invoice#'));
	$t->set_var('lang_id',exapi_lang('Audit Id:')." ");
	$t->set_var('lang_curr_invoice',exapi_lang('Currency Invoice'));
	$t->set_var('lang_loc_for',$loc_for);
	$t->set_var('lang_ordnumber',exapi_lang('SO#'));
	$t->set_var('lang_transdate',exapi_lang('Invoice Date'));
	$t->set_var('lang_duedate',exapi_lang('Due Date'));
	$t->set_var('lang_customer',exapi_lang('Customer'));
	$t->set_var('lang_taxstatus',exapi_lang('Unit Price Tax Status'));
	$t->set_var('lang_isocode',exapi_lang('Currency'));
	$t->set_var('lang_exrate',exapi_lang('Exchange Rate'));
	$t->set_var('invnumber',$dt[invnumber]) ;
	$t->set_var('ordnumber',$dt[ordnumber]) ;
	$transdate = $dt[transdate] ;
	$duedate = $dt[duedate] ;
	$customer = $dt[customer] ;
	if (!$duedate and $customer and $transdate) {
		$result = $adodb->query("SELECT * FROM ${pre}customer WHERE id='$customer'");
		$terms=$result->fields('terms');
		$td = explode("-",$transdate);
		$duedate=date("Y-m-d",mktime(0,0,0,$td[1],$td[2]+$terms,$td[0])) ;
		}
	$t->set_var('transdate',$transdate) ;
	$t->set_var('duedate',$duedate) ;
	$t->set_var('customer',$customer) ;
	$t->set_var('customer_selectlist',selectlist('customer','name','',$customer,'id','name','id')) ;
	$optiont = exapi_lang('Tax Included') ;
	$optionf = exapi_lang('Tax Not Included') ;
	$optione = exapi_lang('Tax Exempted') ;
	if ($tran=="invoicent")	$tax_sl = "<OPTION value='e' selected>$optione</OPTION>" ;
	    else {
		$tax_sl = "<OPTION value='t'>$optiont</OPTION>" ;
		$tax_sl.= "<OPTION value='f'>$optionf</OPTION>" ;
		$tax_sl.= "<OPTION value='e'>$optione</OPTION>" ;
		$tax_sl = str_replace("'$taxstatus'","'$taxstatus' selected",$tax_sl) ;
		}
	$t->set_var('tax_selectlist',$tax_sl) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('isocode_selectlist',selectlist('currency','isocode','',$dt[isocode],'isocode','isocode','description')) ;
	if ($dt[isocode]<>$dt[oldisocode]) {
		$result = $adodb->query("SELECT exrate FROM ${pre}currency WHERE isocode='$dt[isocode]'");
		$dt[exrate] = $result->fields('exrate') ;
		$msg1 = exapi_lang('Currency changed') ;
		$msg2 = exapi_lang('Default exchange rate loaded') ;
		$msg3 = exapi_lang('Ensure pre-existing (discount,price,cost,tax) are still valid') ;
		$t->set_var('message',"$msg1;  $msg2;  $msg3");
		}
	$t->set_var('exrate',$dt[exrate]) ;

	$msg1 = exapi_lang("UC - Unit Cost, BTUP - Before Tax Unit Price, my std rate - my standard rate as a vendor.");
	$msg2=  exapi_lang("Remember to adjust 'Post to Account', if appropriate.");
	$msg3 = exapi_lang("To recalculate Due Date, clear the Due Date field and click [Refresh Page].");
	$msg4 = exapi_lang("Non-numeric Unit Price and Tax will be converted to zero.");
	$msg5 = exapi_lang("If assembly/package is not to be exploded, choose it from the normal Product/Parts or Services sections of the item list.") ;
	$msg6 = exapi_lang("If Unit Price includes tax, discount is ignored.") ;
	$msg7 = exapi_lang("Posted (Tax Exempted) invoice will appear in the Invoice [no Tax] list.");
	$msg8 = exapi_lang("Manual tax input is allowed.");
	$msg9 = exapi_lang("However, inaccurate tax may be construed as an attempt to evade tax.");
	$t->set_var('message',"$msg1  $msg2<br>$msg3  <b>$msg4</b><br>$msg5<br>$msg6  $msg7<br><b>$msg8  $msg9</b>");

	$t->parse('out','report',True);
	}

//---- Reformat Invoice Array

    function invoice_transform() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = exapi_lang('Row')." " ;
	$temp[id] = $dt[id] ;
	$temp[control] = $dt[control] ;
	$temp[customer] = $dt[customer] ;
	$temp[transdate] = $dt[transdate] ;
	$temp[duedate] = $dt[duedate] ;
	$temp[invnumber] = $dt[invnumber] ;
	$temp[ordnumber] = $dt[ordnumber] ;
	$temp[taxstatus] = $dt[taxstatus] ;
	$temp[ar_accno_id] = $dt[ar_accno_id] ;
	$temp[isocode] = $dt[isocode] ;
	$temp[oldisocode] = $dt[oldisocode] ;
	$temp[exrate] = $dt[exrate] ;

	if (isset($delete)) {$delrowno = intval(str_replace($row_,"",$delete)); }
	$j = 1 ;
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		$itemid = $dt['itemid'.$i] ;
		if ($i==$delrowno) continue;
		if ($itemid<0)	{
			$itemid = -$itemid ;
			$qty = $dt['qty'.$i]==0 ? 1 : $dt['qty'.$i] ;
			$result = $adodb->query("SELECT * FROM ${pre}assembly WHERE assembly_id='$itemid'");
			While ($rs=$result->fetchRow()) {
				$temp['itemid'.$j] = $rs['item_id'] ;
				$temp['qty'.$j] = $rs['qty'] * $qty ;
				$j++ ;
				}
			continue ;
			}
		$temp['itemid'.$j]		=	$dt['itemid'.$i] ;
		$temp['itemtype'.$j]		=	$dt['itemtype'.$i] ;
		$temp['description'.$j]		=	$dt['description'.$i] ;
		$temp['qty'.$j]			=	$dt['qty'.$i] ;
		$temp['unit'.$j]		=	$dt['unit'.$i] ;
		$temp['price'.$j]		=	$dt['price'.$i] ;
		$temp['cost'.$j]		=	$dt['cost'.$i] ;
		$temp['discount'.$j]		=	$dt['discount'.$i] ;
		$temp['income_accno_id'.$j]	=	$dt['income_accno_id'.$i] ;
		$temp['inventory_accno_id'.$j]	=	$dt['inventory_accno_id'.$i] ;
		$temp['expense_accno_id'.$j]	=	$dt['expense_accno_id'.$i] ;
		$temp['tax1_pref'.$j]		=	$dt['tax1_pref'.$i] ;
		$temp['tax2_pref'.$j]		=	$dt['tax2_pref'.$i] ;
		$temp['tax1'.$j]		=	$dt['tax1'.$i] ;
		$temp['tax2'.$j]		=	$dt['tax2'.$i] ;
		$temp['tax1_accno_id'.$j]	=	$dt['tax1_accno_id'.$i] ;
		$temp['tax2_accno_id'.$j]	=	$dt['tax2_accno_id'.$i] ;
		$j++ ;
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=True ;
	if ($newrow)					$temp['itemid'.$j] = "" ;
	$dt = $temp ;
	unset($temp) ;
	}

//---- Write Invoice Detail

    function invoice_detail_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$firstime = $ckapi[params_post][firstime] ;
	$op = $ckapi[params_post][op] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_block('report','cogs_row','cogs_section');
	$row_ = exapi_lang('Row')." " ;
	$taxstatus = $dt[taxstatus] ;
	$tax_warning = exapi_lang("***** Choice Pending") ;
	if ($op=="view" or $op=="delete")	$posted = True ;
	if ($taxstatus<>'e') {
		$tax_pref_slist = "<OPTION value=''></OPTION>" ;
		$tax_pref_slist.= "<OPTION value='i'>".exapi_lang('apply item tax rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='c'>".exapi_lang('apply customer rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='s'>".exapi_lang('apply my std rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='z'>".exapi_lang('tax rate = zero')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='m'>".exapi_lang('manual tax input')."</OPTION>" ;
		$customer = ($dt[customer]=="") ? 0 : $dt[customer];
		$sql = "SELECT customer_id,chart_id,rate FROM ${pre}customertax a, ${pre}tax b " ;
		$sql.= "WHERE customer_id='$customer' and a.tax_id=b.id and a.taxtype='1'" ;
		$result = $adodb->query($sql);
		$ctax1chartid = $result->fields(chart_id) ;
		$ctax1rate = $result->fields(rate) ;
		$sql = "SELECT customer_id,chart_id,rate FROM ${pre}customertax a, ${pre}tax b " ;
		$sql.= "WHERE customer_id='$customer' and a.tax_id=b.id and a.taxtype='2'" ;
		$result = $adodb->query($sql);
		$ctax2chartid = $result->fields(chart_id) ;
		$ctax2rate = $result->fields(rate) ;
		$sql = "SELECT customer_id,chart_id,rate " ;
		$sql.= "FROM ${pre}customertax a,${pre}tax b,${pre}customer c ";
		$sql.= "WHERE c.name='zzzzMyself' and customer_id=c.id and a.tax_id=b.id and taxtype='1'" ;
		$result = $adodb->query($sql);
		$stax1chartid = $result->fields(chart_id) ;
		$stax1rate = $result->fields(rate) ;
		$sql = "SELECT customer_id,chart_id,rate " ;
		$sql.= "FROM ${pre}customertax a, ${pre}tax b, ${pre}customer c " ;
		$sql.= "WHERE c.name='zzzzMyself' and customer_id=c.id and a.tax_id=b.id and taxtype='2'" ;
		$result = $adodb->query($sql);
		$stax2chartid = $result->fields(chart_id) ;
		$stax2rate = $result->fields(rate) ;
		}
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_number',exapi_lang('Item Code / Id<br>(Part/Service)'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_qty',exapi_lang('Qty'));
	$t->set_var('lang_unit',exapi_lang('Unit<br>/UC'));
	$t->set_var('lang_btup',exapi_lang('BTUP'));
	$t->set_var('lang_discount',exapi_lang('Discount')."<br>$");
	$t->set_var('lang_tax',exapi_lang('Tax'));
	$result = $adodb->query("SELECT artax1cap,artax2cap,artax1pref,artax2pref FROM ${pre}defaults");
	$t->set_var('lang_tax1',$result->fields(artax1cap));
	$t->set_var('lang_tax2',$result->fields(artax2cap));
	$tax1pref = $result->fields(artax1pref) ;
	$tax2pref = $result->fields(artax2pref) ;
	$t->set_var('lang_price',exapi_lang('Unit<br>Price'));
	$t->set_var('lang_itemtotal',exapi_lang('Item Total'));
	$t->set_var('lang_netamount',exapi_lang('Net of Tax'));
	$t->set_var('lang_accno',exapi_lang('Post to Account'));
	$t->set_var('lang_delete',exapi_lang('Delete<br>Button'));
	$t->set_var('lang_newrow',exapi_lang('Add New Row'));
	$t->set_var('lang_cogs',exapi_lang('Inventory Item:-  Dr COGS'));
	$t->set_var('lang_inv',exapi_lang('Inventory Item:-  Cr Inventory'));
	$item_sl = item_selectlist("",'') ;
	$inc_acc_list = selectlist('chart','accno',"WHERE link like '%AR_amount%'",'','id','accno','substring(description,1,20)') ;
	$cogs_acc_list = selectlist('chart','accno',"WHERE link like '%IC_cogs%'",'','id','accno','substring(description,1,20)') ;
	$inv_acc_list = selectlist('chart','accno',"WHERE link like '%IC:%' or link like '%IC'",'','id','accno','substring(description,1,20)') ;
	if ($firstime and $ckapi[params][doneexit]=="so2invfilter.php")	$fromso = True ;
	$tax_acc_list = ($fromso) ? "" : selectlist('chart','accno',"WHERE link like '%AR_tax%'",'','id','accno','substring(description,1,20)') ;
	$sum_tax1 = $sum_tax2 = $sum_itemtotal = $sum_netamount = 0 ;
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		$t->set_var('itemid_fld','itemid'.$i) ;
		$t->set_var('itemtype_fld','itemtype'.$i) ;
		$t->set_var('description_fld','description'.$i);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('unit_fld','unit'.$i);
		$t->set_var('discount_fld','discount'.$i);
		$t->set_var('price_fld','price'.$i);
		$t->set_var('income_accno_fld','income_accno_id'.$i);
		$t->set_var('tax1_pref_fld','tax1_pref'.$i);
		$t->set_var('tax2_pref_fld','tax2_pref'.$i);
		$t->set_var('tax1_fld','tax1'.$i);
		$t->set_var('tax2_fld','tax2'.$i);
		$t->set_var('tax1_accno_fld','tax1_accno_id'.$i);
		$t->set_var('tax2_accno_fld','tax2_accno_id'.$i);
		$itemid = $dt['itemid'.$i] ;
		$itemtype = $dt['itemtype'.$i] ;
		$description = $dt['description'.$i] ;
		$unit = $dt['unit'.$i] ;
		$qty = ($itemid<>'' and $dt['qty'.$i]=='') ? 1 : $dt['qty'.$i] ;
		$discount = $dt['discount'.$i] ;
		$price = $dt['price'.$i] ;
		$cost = $dt['cost'.$i] ;
		$incaid = $dt['income_accno_id'.$i] ;
		$cogaid = $dt['expense_accno_id'.$i] ;
		$invaid = $dt['inventory_accno_id'.$i] ;
		$tax1_pref = ($dt['tax1_pref'.$i] or $posted) ? $dt['tax1_pref'.$i] : $tax1pref ;
		$tax2_pref = ($dt['tax2_pref'.$i] or $posted) ? $dt['tax2_pref'.$i] : $tax2pref ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		if ($taxstatus<>"e" and ($tax1_pref=="" or $tax1_pref==' ') and !$posted)
				$t->set_var('lang_taxremark1',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark1',"");
		if ($taxstatus<>"e" and ($tax2_pref=="" or $tax2_pref==' ') and !$posted)
				$t->set_var('lang_taxremark2',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark2',"");
		$tax1 = $dt['tax1'.$i] ;
		$tax2 = $dt['tax2'.$i] ;
		$t1aid = $dt['tax1_accno_id'.$i] ;
		$t2aid = $dt['tax2_accno_id'.$i] ;
		$itemid = ($itemid=="") ? 0 : $itemid ;
		if (!$itemtype or $fromso) {
			$result = $adodb->query("SELECT * FROM ${pre}service WHERE id='$itemid'");
			if ($result->RecordCount()>0) {
				$incaid = $incaid<>'' ? $incaid : $result->fields('income_accno_id');
				$itemtype = "s" ;
				}
			   else {
				$result = $adodb->query("SELECT * FROM ${pre}parts WHERE id='$itemid'");
				if ($result->RecordCount()>0) {
					$cost = (($cost<>'' or $itemid==0) and !$fromso) ?
								$cost : $result->fields('cost')/$dt[exrate];
					$cost = number_format($cost,2,".",'') ;
					$incaid = $incaid<>'' ? $incaid : $result->fields('income_accno_id');
					$cogaid = $cogaid<>'' ? $cogaid : $result->fields('expense_accno_id');
					$invaid = $invaid<>'' ? $invaid : $result->fields('inventory_accno_id');
					$itemtype = "i" ;
					}
				}
			$description = $description<>'' ? $description : $result->fields('description');
			$unit = $unit<>'' ? $unit : $result->fields('unit');
			$price = ($price<>'' or $itemid==0) ? $price : $result->fields('price')/$dt[exrate];
			$price = number_format($price,2,".",'') ;
			}
		$t->set_var('itemid',$itemid) ;
		$t->set_var('item_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$item_sl));
		$t->set_var('itemtype',$itemtype);
		$t->set_var('description',$description);
		$t->set_var('unit',$unit);
		$t->set_var('qty',$qty);
		$t->set_var('discount',$discount);
		if ($taxstatus=="t" or $posted)	$t->set_var('disc_readonly','readonly');
			else			$t->set_var('disc_readonly','');
		$price = number_format($price,2,".",'') ;
		$price = ($itemid==0) ? "" : $price ;
		$t->set_var('price',$price);
		$slist = ($itemtype) ? str_replace("'$incaid'","'$incaid' selected",$inc_acc_list) : "" ;
		$t->set_var('inc_acc_selectlist',$slist);
		switch ($tax1_pref) :
			case "c" :
				$tax1chartid = $ctax1chartid ;
				$tax1rate = $ctax1rate ;
				break ;
			case "s" :
				$tax1chartid = $stax1chartid ;
				$tax1rate = $stax1rate ;
				break ;
			case "i" :
				$sql = "SELECT chart_id,rate FROM ${pre}itemtax a, ${pre}tax b " ;
				$sql.= "WHERE item_id='$itemid' and tax_id=id and taxtype='1' and taxgroup='ar'";
				$result = $adodb->query($sql);
				$tax1chartid = $result->fields(chart_id) ;
				$tax1rate = $result->fields(rate) ;
				break ;
			case "z" :	$tax1rate = 0 ;		break ;
			case "m" :	$tax1rate = 0 ;		break ;
			case " " :	$tax1rate = 0 ;		break ;
			case "" :	$tax1rate = 0 ;		break ;
			endswitch ;
		switch ($tax2_pref) :
			case "c" :
				$tax2chartid = $ctax2chartid ;
				$tax2rate = $ctax2rate ;
				break ;
			case "s" :
				$tax2chartid = $stax2chartid ;
				$tax2rate = $stax2rate ;
				break ;
			case "i" :
				$sql = "SELECT chart_id,rate FROM ${pre}itemtax a, ${pre}tax b " ;
				$sql.= "WHERE item_id='$itemid' and tax_id=id and taxtype='2' and taxgroup='ar'";
				$result = $adodb->query($sql);
				$tax2chartid = $result->fields(chart_id) ;
				$tax2rate = $result->fields(rate) ;
				break ;
			case "z" :	$tax2rate = 0 ;		break ;
			case "m" :	$tax2rate = 0 ;		break ;
			case " " :	$tax2rate = 0 ;		break ;
			case "" :	$tax2rate = 0 ;		break ;
			endswitch ;
		switch ($taxstatus) :
			case "f" :
				$t->set_var('btup',$price);
				$netamount = number_format($qty*$price-$discount,2,".",'') ;
				$keeptax1=($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ");
				$keeptax2=($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ");
				$tax1 = ($keeptax1) ? $tax1 : $netamount*$tax1rate ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $netamount*$tax2rate ;
				$tax2 = number_format($tax2,2,".",'') ;
				$itemtotal = $netamount + $tax1 + $tax2 ;
				break ;
			case "t" :
				$t->set_var('btup','.');
				$t->set_var('discount','');
				$itemtotal = $taxbase = number_format($qty*$price,2,".",'') ;
				$keeptax1=($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ");
				$keeptax2=($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ");
				if ($keeptax1)		$taxbase -= $tax1 ;
				if ($keeptax2)		$taxbase -= $tax2 ;
				$tax1 = ($keeptax1) ? $tax1 : $taxbase*$tax1rate/(1+$tax1rate+$tax2rate) ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $taxbase*$tax2rate/(1+$tax1rate+$tax2rate) ;
				$tax2 = number_format($tax2,2,".",'') ;
				$netamount = $itemtotal - $tax1 - $tax2 ;
				break ;
			case "e" :
				$t->set_var('btup','.');
				$netamount = number_format($qty*$price-$discount,2,".",'') ;
				$itemtotal = $netamount ;
				$tax1rate = $tax2rate = 0 ;
				$tax1 = $tax2 = 0 ;
				$t1aid = $tax1chartid = $t2aid = $tax2chartid = 0 ;
				break ;
			endswitch ;
		$t1aid = $t1aid=='' ? $tax1chartid : $t1aid ;
		$slist = $tax1==0 ? "" : str_replace("'$t1aid'","'$t1aid' selected",$tax_acc_list) ;
		$t->set_var('tax1_acc_selectlist',$slist);
		$t2aid = $t2aid=='' ? $tax2chartid : $t2aid ;
		$slist = $tax2==0 ? "" : str_replace("'$t2aid'","'$t2aid' selected",$tax_acc_list) ;
		$t->set_var('tax2_acc_selectlist',$slist);
		$sum_tax1 += $tax1 ;
		$sum_tax2 += $tax2 ;
		$sum_itemtotal += $itemtotal ;
		$sum_netamount += $netamount ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		$t->set_var('tax1',$tax1);
		$t->set_var('tax2',$tax2);
		$t->set_var('itemtotal',$itemtotal);
		$t->set_var('netamount',$netamount);
		if ($posted)	$t->set_var('rowno',"done") ;
			else	$t->set_var('rowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		if ($itemtype=="i") {
			$t->set_var('cost_fld','cost'.$i);
			$cost = number_format($cost,2,".",'') ;
			$cost = ($itemid==0) ? "" : $cost ;
			$t->set_var('cost',$cost);
			$cogs = number_format($qty*$cost,2,".",'') ;
			$cogs = ($itemid==0) ? "" : $cogs ;
			$t->set_var('cogs',$cogs);
			$t->set_var('expense_accno_fld','expense_accno_id'.$i);
			$slist=($itemtype) ? str_replace("'$cogaid'","'$cogaid' selected",$cogs_acc_list) :"";
			$t->set_var('cogs_acc_selectlist',$slist);
			$t->set_var('inventory_accno_fld','inventory_accno_id'.$i);
			$slist =($itemtype) ? str_replace("'$invaid'","'$invaid' selected",$inv_acc_list) :"";
			$t->set_var('inv_acc_selectlist',$slist);
			$t->parse('detail_section','cogs_row',True) ;
			}
		$t->set_var('cogs_section',"");

		$dt['itemid'.$i] = $itemid ;
		$dt['itemtype'.$i] = $itemtype ;
		$dt['description'.$i] = $description ;
		$dt['qty'.$i] = $qty ;
		$dt['price'.$i] = $price ;
		$dt['cost'.$i] = $cost ;
		$dt['discount'.$i] = $discount ;
		$dt['unit'.$i] = $unit ;
		$dt['tax1'.$i] = $tax1 ;
		$dt['tax2'.$i] = $tax2 ;
		$dt['tax1_accno_id'.$i] = $t1aid ;
		$dt['tax2_accno_id'.$i] = $t2aid ;
		$dt['income_accno_id'.$i] =  $incaid ;
		$dt['inventory_accno_id'.$i] =  $invaid ;
		$dt['expense_accno_id'.$i] =  $cogaid ;
		$dt['netamount'.$i] = $netamount ;
		}

	$t->set_var('lang_totalnet',exapi_lang('Total Tax / Net Amount'));
	$t->set_var('lang_totalar',exapi_lang('Total Receivable'));
	$t->set_var('sum_tax',number_format($sum_tax1+$sum_tax2,2,".",'')) ;
	$dt[sum_netamount] = number_format($sum_netamount,2,".",'') ;
	$t->set_var('sum_netamount',number_format($sum_netamount,2,".",'')) ;
	$dt[sum_itemtotal] = number_format($sum_itemtotal,2,".",'') ;
	$t->set_var('sum_itemtotal',number_format($sum_itemtotal,2,".",'')) ;
$ar_acc_list = selectlist('chart','accno',"WHERE link like '%AR:%' or link like '%AR'",$dt[ar_accno_id],'id','accno','substring(description,1,20)');
	$t->set_var('ar_acc_selectlist',$ar_acc_list) ;
	$t->set_var('oldisocode',$dt['isocode']);
	$t->parse('out','report',True);
	}

//---- Invoice Post Initialisation

    function invoice_post_init() {
	global $ckapi ;

	$tran = $ckapi[params][tran] ;
	$dt = &$ckapi[params_post][dt] ;

	$dt[source] = ($tran=='invoicewt') ? "ARWT" : "ARNT" ;
	$dt[description] = "AR: Invoice# $dt[invnumber]" ;
	if ($dt[taxstatus]=="e")	$dt[taxstatus] = "f" ;
	$dt[taxincluded] = $dt[taxstatus] ;
	$dt[amount] = $dt[sum_itemtotal] ;
	$dt[netamount] = $dt[sum_netamount] ;
	}

//---- Invoice Post - PreCommit Routine

    function invoice_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$id = &$ckapi[params_post][id] ;
	$op = &$ckapi[params_post][op] ;
	$t = &$ckapi[objects][template] ;

	if (substr_count($ckapi[params_post][script],'acctran')>0)	{
		$adodb->query("DELETE from ${pre}acc_trans where trans_id='$id'");
		For ($i=1;isset($dt['accno'.$i]);$i++) {
			$chart_id	=	$dt['accno'.$i];
			$attrib1	=	$dt['attrib1'.$i] ;
			$attrib2	=	$dt['attrib2'.$i] ;
			$attrib3	=	$dt['attrib3'.$i] ;
			$dr		=	$dt['dr'.$i] ;
			$cr		=	$dt['cr'.$i] ;
			if ($dr==0) $amount=$cr; else $amount=-$dr;
			$attrib1 = ($attrib1=="") ? 0 : $attrib1 ;
			$attrib2 = ($attrib2=="") ? 0 : $attrib2 ;
			$attrib3 = ($attrib3=="") ? 0 : $attrib3 ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,attrib1,attrib2,attrib3,amount,transdate)" ;
			$sql.=	"VALUES ('$id','$chart_id','$attrib1','$attrib2','$attrib3','$amount','$dt[transdate]')" ;
			$adodb->query($sql);
			}
		return ;
		}
	$exrate = $dt['exrate'] ;
	$transdate = $dt['transdate'] ;
	if ($op<>'new')	{
		$adodb->query("DELETE from ${pre}invoice where trans_id=$id");
		$adodb->query("DELETE from ${pre}acc_trans where trans_id=$id");
		}
	if ($op<>'delete') {
		$aramount = 0 ;
		For ($i=1;isset($dt['itemid'.$i]);$i++) {
			$itemid		= $dt['itemid'.$i];
			$itemtype	= $dt['itemtype'.$i];
			$desc		= addslashes($dt['description'.$i]);
			$unit		= addslashes($dt['unit'.$i]);
			$qty		= $dt['qty'.$i];
			$price		= $dt['price'.$i];
			$cost		= $dt['cost'.$i] ;
			$discount	= $dt['discount'.$i];
			$incaid		= $dt['income_accno_id'.$i] ;
			$cogaid 	= $dt['expense_accno_id'.$i] ;
			$invaid 	= $dt['inventory_accno_id'.$i] ;
			$tax1		= number_format($dt['tax1'.$i],2,".",'');
			$tax2		= number_format($dt['tax2'.$i],2,".",'');
			$t1aid		= $dt['tax1_accno_id'.$i] ;
			$t2aid		= $dt['tax2_accno_id'.$i] ;
			$led_netamount	= number_format($dt['netamount'.$i]*$exrate,2,".",'') ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$incaid','$led_netamount','$transdate')";
			$adodb->query($sql);

			if ($itemtype=="i" and $cost<>0 and $cost<>'') {
				$cogs = number_format($qty*$cost*$exrate,2,".",'') ;
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$cogaid','-$cogs','$transdate')";
				$adodb->query($sql);
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$invaid','$cogs','$transdate')";
				$adodb->query($sql);
				}
			if ($tax1==0 or $tax1=='')	$led_tax1 = 0.00 ;
			  else	{
				$led_tax1 = number_format($tax1*$exrate,2,".",'') ;
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$t1aid','$led_tax1','$transdate')" ;
				$adodb->query($sql);
				}
			if ($tax2==0 or $tax2=='')	$led_tax2 = 0.00 ;
			  else	{
				$led_tax2 = number_format($tax2*$exrate,2,".",'') ;
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$t2aid','$led_tax2','$transdate')" ;
				$adodb->query($sql);
				}
			$invaid = ($invaid=="") ? 0 : $invaid ;
			$incaid = ($incaid=="") ? 0 : $incaid ;
			$cogaid = ($cogaid=="") ? 0 : $cogaid ;
			$t1aid = ($t1aid=="") ? 0 : $t1aid ;
			$t2aid = ($t2aid=="") ? 0 : $t2aid ;
			$sql = "INSERT INTO ${pre}invoice (trans_id,inventory_accno_id,";
			$sql.= "income_accno_id,expense_accno_id,itemid,itemtype,";
			$sql.= "description,qty,price,cost,discount," ;
			$sql.= "unit,tax1,tax2,tax1_accno_id,tax2_accno_id) " ;
			$sql.= "VALUES ('$id','$invaid','$incaid','$cogaid','$itemid'," ;
			$sql.= "'$itemtype','$desc','$qty','$price','$cost','$discount'," ;
			$sql.= "'$unit','$tax1','$tax2','$t1aid','$t2aid')";
			$adodb->query($sql);
			$aramount += $led_netamount + $led_tax1 + $led_tax2 ;
			}
		$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
		$sql.= "VALUES ('$id','$dt[ar_accno_id]','-$aramount','$transdate')";
		$adodb->query($sql);
		}
	if ($op=='delete') {
		$adodb->query("DELETE FROM ${pre}r_match where invoiceid=$id");
		$adodb->query("DELETE from ${pre}ismatch where invoiceid=$id");
		}
	}

//---- Invnt Accounting Entries Reload (from ar/invoice tables)

    function invoice_reload() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$sql = "SELECT ar_accno_id,taxincluded,amount,exrate FROM ${pre}ar WHERE id='$id'" ;
	$result = $adodb->query($sql);
	$aracc = $result->fields('ar_accno_id') ;
	$taxstatus = $result->fields('taxincluded') ;
	$exrate = $result->fields('exrate') ;
	$result = $adodb->query("SELECT * FROM ${pre}invoice WHERE trans_id='$id'") ;
	$aramt = 0 ;
	$i = 1 ;
	While ($rs=$result->fetchRow()) {
		$qty	= $rs['qty'] ;
		$price	= $rs['price'] ;
		$cost   = $rs['cost'] ;
		$discount = $rs['discount'] ;
		$tax1	= $rs['tax1'] ;
		$tax2	= $rs['tax2'] ;
		$incaid	= $rs['income_accno_id'] ;
		$invaid	= $rs['inventory_accno_id'] ;
		$expaid	= $rs['expense_accno_id'] ;
		$t1aid	= $rs['tax1_accno_id'] ;
		$t2aid	= $rs['tax2_accno_id'] ;
		switch ($taxstatus) :
			case "f" : $netamount = number_format($qty*$price-$discount,2,".",'') ;	break ;
			case "t" : $netamount = number_format($qty*$price,2,".",'') - $tax1 - $tax2 ; break ;
			case "e" : $netamount = number_format($qty*$price-$discount,2,".",'') ;	break ;
			endswitch ;
		$dt['accno'.$i]	=	$incaid ;
		$led_netamount	=	number_format($netamount*$exrate,2,".",'') ;
		$dt['dr'.$i]	=	"" ;
		$dt['cr'.$i]	= 	$led_netamount ;
		$i++ ;
		if ($invaid<>0 and $invaid<>"") {
			$cogs = number_format($qty*$cost*$exrate,2,".",'') ;
			$dt['accno'.$i]	=	$expaid;
			$dt['dr'.$i]	= 	sprintf("%01.2f",$cogs) ;
			$dt['cr'.$i]	= 	"" ;
			$i++ ;
			$dt['accno'.$i]	=	$invaid;
			$dt['dr'.$i]	= 	"" ;
			$dt['cr'.$i]	= 	sprintf("%01.2f",$cogs) ;
			$i++ ;
			}
		if ($tax1==0 or $tax1=='')	$led_tax1 = 0.00 ;
		  else	{
			$dt['accno'.$i]	=	$t1aid;
			$led_tax1	=	number_format($tax1*$exrate,2,".",'') ;
			$dt['dr'.$i]	= 	"" ;
			$dt['cr'.$i]	= 	$led_tax1 ;
			$i++ ;
			}
		if ($tax2==0 or $tax2=='')	$led_tax2 = 0.00 ;
		  else	{
			$dt['accno'.$i]	=	$t2aid;
			$led_tax2	=	number_format($tax2*$exrate,2,".",'') ;
			$dt['dr'.$i]	= 	"" ;
			$dt['cr'.$i]	= 	$led_tax2 ;
			$i++ ;
			}
		$aramt += $led_netamount + $led_tax1 + $led_tax2 ;
		}
	$dt['accno'.$i]	=	$aracc;
	$dt['dr'.$i]	= 	sprintf("%01.2f",$aramt) ;
	$dt['cr'.$i]	= 	"" ;
	return $dt ;
	}

//---- Invnt Accounting Entries Accmask Creation

    function invoice_accmask() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$result = $adodb->query("Select ar_accno_id from ${pre}ar where id='$id'");
	$accmask = $result->fields('ar_accno_id') ;
	$result = $adodb->query("Select tax1_accno_id,tax2_accno_id from ${pre}invoice where trans_id='$id'");
	While ($rs=$result->fetchRow())	$accmask .= ":".$result->fields('tax1_accno_id').":".$result->fields('tax2_accno_id') ;
	$ckapi[params_post][accmask] = $accmask ;
	}

    }

?>
