<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// invoiceaging.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-ar' ;
	$tran = 'invoice' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$customer = ($_GET["customer"]) ? $_GET["customer"] : $_POST["customer"] ;
	$repdate = ($_GET["repdate"]) ? $_GET["repdate"] : $_POST["repdate"] ;

	$t = ckapi_tpl($app);
	$t->set_file('report',"${tran}aging.tpl") ;
	$t->set_block('report','invoice_row','invoice_section');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_invoiceaging', exapi_lang('CUSTOMER INVOICE AGING REPORT as of')." $repdate");
	$t->set_var('lang_customer', exapi_lang('Customer:')."    ");

	$t->set_var('lang_duedate', exapi_lang('DUE DATE'));
	$t->set_var('lang_invnumber', exapi_lang('INVOICE#'));
	$t->set_var('lang_invoiceid',exapi_lang('AUDIT ID'));
	$t->set_var('lang_isocode',exapi_lang('CURRENCY'));
	$t->set_var('lang_amount', exapi_lang('AMOUNT'));
	$t->set_var('lang_paidamount', exapi_lang('PAID'));
	$t->set_var('lang_osamount', exapi_lang('O/S'));
	$t->set_var('lang_separator', '|');
	$t->set_var('lang_notdue', exapi_lang('NOT DUE'));
	$t->set_var('lang_0to30', exapi_lang('1-30'));
	$t->set_var('lang_31to60', exapi_lang('31-60'));
	$t->set_var('lang_61to90', exapi_lang('61-90'));
	$t->set_var('lang_91to120', exapi_lang('91-120'));
	$t->set_var('lang_120plus', exapi_lang('120+'));
	$t->set_var('lang_detail', exapi_lang('DETAIL'));
	$t->set_var('lang_history', exapi_lang('History'));
	$t->set_var('lang_total', exapi_lang('Total'));
	$t->set_var('lang_unallocated', exapi_lang('Unallocated'));
	$t->set_var('lang_net', exapi_lang('Net O/S'));
	$note1 = exapi_lang('Note 1') ;
	$t->set_var('lang_note1',$note1);
	$note1a = exapi_lang('These lines are for control reconciliation purpose only') ;
	$note1b = exapi_lang('The figures represent an amalgamation of different currency amounts') ;
	$t->set_var('note1',"$note1 :-<br>$note1a.<br>$note1b.");

	$sql = "SELECT name FROM ${pre}customer WHERE id='$customer'" ;
	$result = $adodb->query($sql);
	$t->set_var('customer',$result->fields('name')." -- ".$customer) ;
	$id = $customer ;
	$sql ="SELECT sum(amount) as totpaidamt FROM ${pre}receipt WHERE customer='$id' and transdate <= '$repdate'";
	$result = $adodb->query($sql);
	$totpaidamt = $result->fields('totpaidamt') ;
	$sql ="SELECT sum(s_amount) as allocated FROM ${pre}receipt a, ${pre}r_match b " ;
	$sql.="WHERE customer='$id' and transdate <= '$repdate' and a.id=receiptid";
	$result = $adodb->query($sql);
	$allocated = $result->fields('allocated') ;
	$unallocated = $totpaidamt-$allocated ;


	$user = $ckapi[hostsys][username];
	$temp1 = "${pre}ar1".$user.time() ;
	$temp2 = "${pre}ar2".$user.time() ;
	$sql = "CREATE TABLE $temp1 AS " ;
	$sql.="SELECT invnumber,id,isocode,transdate,duedate,amount,netamount,0.00 as paidamount FROM ${pre}ar ";
	$sql.="WHERE customer='$id'  and transdate <= '$repdate'";
	$adodb->query($sql);

	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT invnumber,a.id,a.isocode,a.transdate,duedate,0.00 as amount,0.00 as netamount,sum(s_amount) as paidamount " ;
	$sql.= "FROM ${pre}ar a, ${pre}r_match b, ${pre}receipt c ";
	$sql.= "WHERE a.customer='$id' and a.transdate<='$repdate' and a.id=b.invoiceid and " ;
	$sql.=				"c.transdate<='$repdate' and c.id=receiptid " ;
	$sql.= "GROUP BY a.isocode,a.transdate,duedate,a.id,invnumber";
	$adodb->query($sql);
	$sql = "CREATE TABLE $temp2 AS " ;
	$sql.= "SELECT invnumber,id,isocode,transdate,duedate,sum(amount) as amount,sum(netamount) as netamount," ;
	$sql.=				"sum(paidamount) as paidamount,0.00 as osamount " ;
	$sql.= "FROM $temp1 GROUP BY isocode,transdate,duedate,id,invnumber ";
	$adodb->query($sql);
	$sql = "UPDATE $temp2 SET osamount=amount-paidamount" ;
	$adodb->query($sql);
	$result = $adodb->query("SELECT * FROM $temp2 WHERE osamount > 0 ORDER BY duedate,id") ;

if ($result->RecordCount()==0) {
	$t->set_var('duedate','') ;
	$t->set_var('invnumber',exapi_lang('No invoice outstanding')) ;
	$t->set_var('invoiceid','') ;
	$t->set_var('isocode','') ;
	$t->set_var('amount','') ;
	$t->set_var('paidamount','') ;
	$t->set_var('osamount','') ;
	$t->set_var('notdue','') ;
	$t->set_var('0to30','') ;
	$t->set_var('31to60','') ;
	$t->set_var('61to90','') ;
	$t->set_var('91to120','') ;
	$t->set_var('120plus','') ;
	$t->set_var('history','') ;
	$t->set_var('lang_history','');
	$t->parse('invoice_section','invoice_row',True);
	}
$sumamount = $sumpaid = $sumos = 0 ;
$sumnotdue = $sum30 = $sum60 = $sum90 = $sum120 = $sum120plus = 0 ;
While ($rs=$result->fetchRow()) {
	$duedate = $rs['duedate'] ;
	$t->set_var('duedate',$duedate) ;
	$t->set_var('invnumber',$rs['invnumber']) ;
	$t->set_var('isocode',$rs['isocode']) ;
	$id		=	$rs['id'] ;
	$amount		=	$rs['amount'] ;
	$netamount	=	$rs['netamount'] ;
	$paidamount	=	$rs['paidamount'] ;
	$osamount	=	$rs['osamount'] ;
	$t->set_var('invoiceid',$id) ;
	$t->set_var('amount',$amount) ;
	$t->set_var('paidamount',$paidamount) ;
	$t->set_var('osamount',$osamount) ;
	$overdue = (strtotime($repdate)-strtotime($duedate))/86400 ;
	$age = $overdue < 0 ? 0 : floor($overdue) ;
	$notdue = $age30 = $age60 = $age90 = $age120 = $age120plus = "" ;
	if ($age==0)				$notdue = $osamount ;
	if ($age>0 and $age<31)		$age30 = $osamount ;
	if ($age>30 and $age<61)	$age60 = $osamount ;
	if ($age>60 and $age<91)	$age90 = $osamount ;
	if ($age>90 and $age<121)	$age120 = $osamount ;
	if ($age>120)			$age120plus = $osamount ;
	$t->set_var('notdue',$notdue) ;
	$t->set_var('0to30',$age30) ;
	$t->set_var('31to60',$age60) ;
	$t->set_var('61to90',$age90) ;
	$t->set_var('91to120',$age120) ;
	$t->set_var('120plus',$age120plus) ;
	if ($amount==$netamount)	$filter = urlencode(" WHERE amount=netamount and a.id=$id ") ;
		else			$filter = urlencode(" WHERE amount<>netamount and a.id=$id ") ;
	$history = exapi_link("/$app/invrpthist.php","id=$id&filter=$filter");
	$t->set_var('history',$history) ;
	$t->parse('invoice_section','invoice_row', True);

	$sumamount	+=	$amount ;
	$sumpaid	+=	$paidamount ;
	$sumos		+=	$osamount ;
	$sumnotdue	+=	$notdue ;
	$sum30		+=	$age30 ;
	$sum60		+=	$age60 ;
	$sum90		+=	$age90 ;
	$sum120		+=	$age120 ;
	$sum120plus	+=	$age120plus ;
	}
$t->set_var('sumamount',$sumamount) ;
$t->set_var('sumpaid',$sumpaid) ;
$t->set_var('sumos',$sumos) ;
$t->set_var('sumnotdue',$sumnotdue) ;
$t->set_var('sum30',$sum30) ;
$t->set_var('sum60',$sum60) ;
$t->set_var('sum90',$sum90) ;
$t->set_var('sum120',$sum120) ;
$t->set_var('sum120plus',$sum120plus) ;
$t->set_var('unallocated',$unallocated) ;
$t->set_var('net',$sumos-$unallocated) ;
$t->set_var('lang_notes',exapi_lang('Press [done] button at Detail History screen to go on to invoice maintenance'));

$adodb->query("DROP TABLE $temp1,$temp2");

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report');
	exapi_footer() ;

?>
