<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// brstatement.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-bank' ;
	$tran = 'brstatement' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$chart_id = ($_GET["chart_id"]) ? $_GET["chart_id"] : $_POST["chart_id"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$bankbal = ($_GET["bankbal"]) ? $_GET["bankbal"] : $_POST["bankbal"] ;

	$t = ckapi_tpl($app);
	$t->set_file('report','brstatement.tpl') ;
	$t->set_block('report','bankbal_row','bankbal_section');
	$t->set_block('report','ledgbal_row','ledgbal_section');
	$note1 = exapi_lang("Adj Statement Balance <> Adj Ledger Balance") ;
	$note2 = exapi_lang("Check to ensure prior periods' statement items are posted back to the Ledger") ;
	$note = "$note1:  $note2." ;

/*---------------------------------------------------------------------------------*/

	$result = $adodb->query("SELECT accno,description FROM ${pre}chart WHERE id='$chart_id'") ;
	$bankacline = exapi_lang('Bank Account').":  ".$result->fields('accno')." -- ".$result->fields('description') ;
	$t->set_var('bankacline',$bankacline);
	$t->set_var('dateline',exapi_lang('Reconciliation Date').":  ".$to);

	$t->set_var('lang_brstatement', exapi_lang('Bank Reconciliation Statement'));
	$t->set_var('lang_notes','notes.tba');
	$t->set_var('lang_date', exapi_lang('Date'));
	$t->set_var('lang_source', exapi_lang('Source'));
	$t->set_var('lang_description', exapi_lang('Description'));
	$t->set_var('lang_refnumber',exapi_lang('Ref Number'));
	$t->set_var('lang_cheque', exapi_lang('Cheque#'));
	$t->set_var('lang_status', exapi_lang('Status'));
	$t->set_var('lang_amount', exapi_lang('Amount'));

/*-----------------List Report Content -----------------------------------
//------------------------------------------------------------------------*/

	$t->set_var('brdate',$to) ;
	$t->set_var('lang_bankbal',exapi_lang('Bank Statement Balance')) ;
	$t->set_var('bankbal',$bankbal) ;

	$sql = "SELECT * FROM ${pre}bkr_trans WHERE chart_id='$chart_id' AND transdate<='$to' AND " ;
	$sql.= " substring(source,1,2)<>'SI' AND (status<>'c' or status is null) ORDER BY transdate" ;
	$result = $adodb->query($sql);
	if ($result->RecordCount()==0) {
		$t->set_var('date','') ;
		$t->set_var('source','') ;
		$t->set_var('description',exapi_lang('No Ledger Item found')) ;
		$t->set_var('refnumber','') ;
		$t->set_var('cheque','') ;
		$t->set_var('status','') ;
		$t->set_var('amount','') ;
		$t->parse('bankbal_section','bankbal_row',True);
		}
	While ($rs=$result->fetchRow()) {
		$amount = $rs['amount'] ;
		$t->set_var('date',$rs['transdate']) ;
		$t->set_var('source',$rs['source']) ;
		$t->set_var('description',$rs['description']) ;
		$t->set_var('refnumber',$rs['refnumber']) ;
		$t->set_var('cheque',$rs['cheque']) ;
		$t->set_var('status',$rs['status']) ;
		$t->set_var('amount',$amount) ;
		$t->parse('bankbal_section','bankbal_row',True);
		$bankbal += $amount ;
		}
	$t->set_var('lang_adjbankbal',exapi_lang('Adjusted Bank Statement Balance')) ;
	$t->set_var('adjbankbal',$bankbal) ;

	$t->set_var('lang_ledgbal',exapi_lang('Ledger (Bank) Account Balance')) ;
	$sql =	"SELECT sum(amount) as balance FROM ${pre}acc_trans " ;
	$sql.=	"WHERE chart_id='$chart_id' and transdate<='$to'" ;
	$result = $adodb->query($sql);
	$ledgbal = -$result->fields('balance') ;
	$t->set_var('ledgbal',$ledgbal) ;

	$sql = "SELECT * FROM ${pre}bkr_trans WHERE chart_id='$chart_id' AND substring(source,1,2)='SI' AND ";
	$sql.= "transdate>='$from' AND transdate<='$to' ORDER BY transdate" ;
	$result = $adodb->query($sql);
	if ($result->RecordCount()==0) {
		$t->set_var('date','') ;
		$t->set_var('source','') ;
		$t->set_var('description',exapi_lang('No Bank Statement Item found')) ;
		$t->set_var('refnumber','') ;
		$t->set_var('cheque','') ;
		$t->set_var('status','') ;
		$t->set_var('amount','') ;
		$t->parse('ledgbal_section','ledgbal_row',True);
		}
	While ($rs=$result->fetchRow()) {
		$amount = $rs['amount'] ;
		$t->set_var('date',$rs['transdate']) ;
		$t->set_var('source',$rs['source']) ;
		$t->set_var('description',$rs['description']) ;
		$t->set_var('refnumber',$rs['refnumber']) ;
		$t->set_var('cheque',$rs['cheque']) ;
		$t->set_var('status',$rs['status']) ;
		$t->set_var('amount',$amount) ;
		$t->parse('ledgbal_section','ledgbal_row',True);
		$ledgbal += $amount ;
		}
	$t->set_var('lang_adjledgbal',exapi_lang('Adjusted Ledger (Bank) Account Balance')) ;
	$t->set_var('adjledgbal',$ledgbal) ;
	if ($bankbal==$ledgbal)		$note = "" ;
	$t->set_var('note',$note) ;

/*--------------------Write bottom Section------------------------------------------*/

    $t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
    $t->set_var('lang_done',exapi_lang('Done'));
    $t->pparse('out','report');
	exapi_footer() ;

?>
