<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// controlreport.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-bank' ;
	$tran = 'controlreport' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$chart_id = ($_GET["chart_id"]) ? $_GET["chart_id"] : $_POST["chart_id"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;

	$t = ckapi_tpl($app);
	$t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_control_report', exapi_lang('Bank Reconciliation Audit Control Report'));
	$t->set_var('lang_bankac', exapi_lang('Bank Account'));
	$t->set_var('lang_br_date', exapi_lang('Bank Reconcilation Date'));
	$t->set_var('lang_system_date', exapi_lang('System Date'));
	$t->set_var('lang_ledgitem', exapi_lang('Imported Ledger Item'));
	$t->set_var('lang_bankitem', exapi_lang('Bank Statement Item'));
	$t->set_var('lang_suspitem', exapi_lang('Suspense Item'));
	$t->set_var('lang_requested_status', exapi_lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', exapi_lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_asof', exapi_lang('Status as of'));
	$t->set_var('lang_total_amount', exapi_lang('Total Amount'));
	$t->set_var('lang_total_count', exapi_lang('Total Record Count'));
	$t->set_var('lang_latest_id', exapi_lang('Latest Audit Trail ID'));

	$note = exapi_lang("This report will not persist over time and cannot be produced retrospectively.");
	$t->set_var('note', exapi_lang('Note').":  $note");
	$lang_na = exapi_lang("N/A") ;

/*-----------------Gather and Write Status Date Info---------------------------------*/

$result = $adodb->query("SELECT accno,description FROM ${pre}chart WHERE id='$chart_id'") ;
$t->set_var('bankac', $result->fields('accno')." -- ".$result->fields('description') );
$t->set_var('br_date', $to );

$sql =	"SELECT sum(amount) as ledgitem from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate<='$to' and source<>'SUSP' and substring(source,1,2)<>'SI'" ;
$result = $adodb->query($sql);
$ledgitem = $result->fields('ledgitem') ;

$sql =	"SELECT sum(amount) as bankitem from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate>=$from and transdate<='$to' and substring(source,1,2)='SI'" ;
$result = $adodb->query($sql);
$bankitem = $result->fields('bankitem') ;

$sql =	"SELECT sum(amount) as suspitem from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate<='$to' and source='SUSP'" ;
$result = $adodb->query($sql);
$suspitem = $result->fields('suspitem') ;

$sql =	"SELECT count(amount) as ledgitem_count from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate<='$to' and source<>'SUSP' and substring(source,1,2)<>'SI'" ;
$result = $adodb->query($sql);
$ledgitem_count = $result->fields('ledgitem_count') ;

$sql =	"SELECT count(amount) as bankitem_count from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate>='$from' and transdate<='$to' and substring(source,1,2)='SI'" ;
$result = $adodb->query($sql);
$bankitem_count = $result->fields('bankitem_count') ;

$sql =	"SELECT count(amount) as suspitem_count from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate<='$to' and source='SUSP'" ;
$result = $adodb->query($sql);
$suspitem_count = $result->fields('suspitem_count') ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate<='$to' and source<>'SUSP' and substring(source,1,2)<>'SI'" ;
$result = $adodb->query($sql);
$ledgitem_id = $result->fields('max_id') ;
if ($ledgitem_count==0)		$ledgitem_id = $lang_na ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate>='$from' and transdate<='$to' and substring(source,1,2)='SI'" ;
$result = $adodb->query($sql);
$bankitem_id = $result->fields('max_id') ;
if ($bankitem_count==0)		$bankitem_id = $lang_na ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate<='$to' and source='SUSP'" ;
$result = $adodb->query($sql);
$suspitem_id = $result->fields('max_id') ;
if ($suspitem_count==0)		$suspitem_id = $lang_na ;

$t->set_var('ledgitem',sprintf("%01.2f",$ledgitem)) ;
$t->set_var('bankitem',sprintf("%01.2f",$bankitem)) ;
$t->set_var('suspitem',sprintf("%01.2f",$suspitem)) ;
$t->set_var('ledgitem_count',$ledgitem_count) ;
$t->set_var('bankitem_count',$bankitem_count) ;
$t->set_var('suspitem_count',$suspitem_count) ;
$t->set_var('ledgitem_id',$ledgitem_id) ;
$t->set_var('bankitem_id',$bankitem_id) ;
$t->set_var('suspitem_id',$suspitem_id) ;

/*-----------------Gather and Write Current System Date Info-----------------------------*/

$sql =	"SELECT sum(amount) as ledgitem from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"source<>'SUSP' and substring(source,1,2)<>'SI'" ;
$result = $adodb->query($sql);
$ledgitem = $result->fields('ledgitem') ;

$sql =	"SELECT sum(amount) as bankitem from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"substring(source,1,2)='SI'" ;
$result = $adodb->query($sql);
$bankitem = $result->fields('bankitem') ;

$sql =	"SELECT sum(amount) as suspitem from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"source='SUSP'" ;
$result = $adodb->query($sql);
$suspitem = $result->fields('suspitem') ;

$sql =	"SELECT count(amount) as ledgitem_count from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"source<>'SUSP' and substring(source,1,2)<>'SI'" ;
$result = $adodb->query($sql);
$ledgitem_count = $result->fields('ledgitem_count') ;

$sql =	"SELECT count(amount) as bankitem_count from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"substring(source,1,2)='SI'" ;
$result = $adodb->query($sql);
$bankitem_count = $result->fields('bankitem_count') ;

$sql =	"SELECT count(amount) as suspitem_count from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"source='SUSP'" ;
$result = $adodb->query($sql);
$suspitem_count = $result->fields('suspitem_count') ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"source<>'SUSP' and substring(source,1,2)<>'SI'" ;
$result = $adodb->query($sql);
$ledgitem_id = $result->fields('max_id') ;
if ($ledgitem_count==0)		$ledgitem_id = $lang_na ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"substring(source,1,2)='SI'" ;
$result = $adodb->query($sql);
$bankitem_id = $result->fields('max_id') ;
if ($bankitem_count==0)		$bankitem_id = $lang_na ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"source='SUSP'" ;
$result = $adodb->query($sql);
$suspitem_id = $result->fields('max_id') ;
if ($suspitem_count==0)		$suspitem_id = $lang_na ;

$t->set_var('system_date',date("Y-m-d",time())) ;
$t->set_var('current_ledgitem',sprintf("%01.2f",$ledgitem)) ;
$t->set_var('current_bankitem',sprintf("%01.2f",$bankitem)) ;
$t->set_var('current_suspitem',sprintf("%01.2f",$suspitem)) ;
$t->set_var('current_ledgitem_count',$ledgitem_count) ;
$t->set_var('current_bankitem_count',$bankitem_count) ;
$t->set_var('current_suspitem_count',$suspitem_count) ;
$t->set_var('current_ledgitem_id',$ledgitem_id) ;
$t->set_var('current_bankitem_id',$bankitem_id) ;
$t->set_var('current_suspitem_id',$suspitem_id) ;


/*--------------------Write bottom Section------------------------------------------*/

    $t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
    $t->set_var('lang_done',exapi_lang('Done'));

    $t->pparse('out','report');
	exapi_footer() ;

?>
