<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.ledger.inc.php 0.13.1 2005/06/15 C K Wu

    class ledger {

//---- Ledger Item List SQL Formation

    function ledger_list_sql() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_bankac',exapi_lang('Bank Account'));
	list($dummy,$chart_id) = explode("'",$where) ;
	$result = $adodb->query("SELECT accno,description FROM ${pre}chart WHERE id='$chart_id'");
	$bankac = $result->fields('accno')."--".$result->fields('description') ;
	$t->set_var('bankac',$bankac);

	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter = urlencode(urldecode(stripslashes($filter))) ;

	$t->set_var('filter',$filter);
	$t->set_var('sort',$sort);
	$t->set_var('order',$order);
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->set_var('done_action',exapi_link("/$app/${tran}filter.php"));

	$sql =  "SELECT * FROM ${pre}bkr_trans " ;
	$sql.=	"WHERE substring(source,1,2)<>'SI' and substring(source,1,2)<>'SU' $where ORDER BY ".$order." ".$sort ;
	$result = $adodb->query($sql);
	if ($result->RecordCount()==0)		$t->set_var('disabled','disabled');

	return $sql ;
	}

//---- Ledger Item List Link Adjustement

    function ledger_list_adjust() {
	global $ckapi ;

	foreach ($ckapi[params_list][dt] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('status',"");
	if ($status=="c")		$t->set_var('status',exapi_lang('Cleared'));
	if ($status=="s")		$t->set_var('status',exapi_lang('Stopped'));
	}

//---- Ledger Item Read

    function ledger_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$result = $adodb->query("select * from ${pre}bkr_trans where id='$id'");
//	$result = $adodb->query("select * from ${pre}bkr_trans where trans_id='$id'");
	return $result->fetchRow() ;

	}

//---- Ledger Item Detail Validation Checks

    function ledger_validate() {
	global $ckapi,$pre,$adodb ;

	$err=""; $error=exapi_lang('Error') ;
	$user = $ckapi[hostsys][username];
	$lockwhere = "WHERE resource='bankledgerbulk'" ;
	$result = $adodb->query("SELECT * FROM ${pre}resourcelock $lockwhere");
	$used_by = $result->fields('used_by') ;
	if ($used_by=="")	$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' $lockwhere");
	  else	$err = exapi_lang("Bank Rec. Ledger Item [Bulk] Update/Edit/Delete is being accessed by ").$used_by;
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Ledger Item Delete Validation Checks

    function delete_validate() {
	global $ckapi,$pre,$adodb ;

	$err=""; $error=exapi_lang('Error') ;
	$user = $ckapi[hostsys][username];
	$lockwhere = "WHERE resource='bankledgerbulk'" ;
	$result = $adodb->query("SELECT * FROM ${pre}resourcelock $lockwhere");
	$used_by = $result->fields('used_by') ;
	if ($used_by=="")	$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' $lockwhere");
	  else	$err = exapi_lang("Bank Rec. Ledger Item [Bulk] Update/Edit/Delete is being accessed by ").$used_by;
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write Ledger Item Detail

    function ledger_write() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_transdate',exapi_lang('Ledger Date'));
	$t->set_var('lang_refnumber',exapi_lang('Ref Number'));
	$t->set_var('lang_cheque',exapi_lang('Cheque Number'));
	$t->set_var('lang_amount',exapi_lang('Amount'));
	$t->set_var('lang_status',exapi_lang('Status'));
	$t->set_var('lang_source',exapi_lang('Source'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_id',exapi_lang('ID#'));

	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('transdate',$dt[transdate]);
	$t->set_var('refnumber',$dt[refnumber]);
	$t->set_var('cheque',$dt[cheque]);
	$t->set_var('amount',$dt[amount]);
	$t->set_var('status',$dt[status]);
	$t->set_var('source',$dt[source]);
	$t->set_var('description',$dt[description]);
	$optionc = exapi_lang('Cheque/Item cleared and appeared in bank statement') ;
	$options = exapi_lang('Cheque/Item stopped and bank informed') ;
	$selectlist = "<OPTION value='c'>c -- $optionc</OPTION>";
	$selectlist.= "<OPTION value='s'>s -- $options</OPTION>" ;
	$selectlist.= "<OPTION value=''></OPTION>" ;
	$status_sl = str_replace("'$dt[status]'","'$dt[status]'"." selected",$selectlist ) ;
	$t->set_var('status_selectlist',$status_sl);

	$t->parse('out','report',True);
	}

    function ledger_post_postcommit() {
	global $pre,$adodb ;

	$adodb->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='bankledgerbulk'");
	}

    }

?>
