<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// controlreport.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-contact' ;
	$tran = 'control' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$status_date = ($_GET["status_date"]) ? $_GET["status_date"] : $_POST["status_date"] ;

/*---------------------------------------------------------------------------------*/

	$t = ckapi_tpl($app);
	$t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$msg1 = exapi_lang('RP - Related Person') ;
	$msg2 = exapi_lang('AO - Associated Organization') ;
	$msg3 = exapi_lang('CC - Communication Channel') ;
	$msg4 = exapi_lang('CD - Contact Data') ;
	$t->set_var('message',"[$msg1;  $msg2;  $msg3; $msg4]");
	$t->set_var('lang_control_report', exapi_lang('Contact Management Audit Control Report'));
	$t->set_var('lang_system_date', exapi_lang('System Date'));
	$t->set_var('lang_org', exapi_lang('Org'));
	$t->set_var('lang_person', exapi_lang('Person'));
	$t->set_var('lang_org_person', exapi_lang('Org -> RP'));
	$t->set_var('lang_person_org', exapi_lang('Person -> AO'));
	$t->set_var('lang_org_org', exapi_lang('Org -> AO'));
	$t->set_var('lang_person_person', exapi_lang('Person -> RP'));
	$t->set_var('lang_ccdata', exapi_lang('CC Data'));
	$t->set_var('lang_address', exapi_lang('Address'));
	$t->set_var('lang_cmcode', exapi_lang('CD Code'));
	$t->set_var('lang_commcat', exapi_lang('CC Category'));
	$t->set_var('lang_commcode', exapi_lang('CC Code'));
	$t->set_var('lang_current_status', exapi_lang('TOTAL DATABASE STATUS'));
	$t->set_var('lang_status_asof', exapi_lang('Status as of'));
	$t->set_var('lang_total_count', exapi_lang('Total Record Count'));
	$t->set_var('lang_latest_id', exapi_lang('Latest Audit Trail ID'));

/*-----------------Gather and Write Database Info---------------------------------*/

$t->set_var('system_date',date("Y-m-d",time())) ;

$sql="SELECT count(id) as org_count, max(id) as max_id from ${pre}org WHERE orgname<>''";
$result = $adodb->query($sql);
$t->set_var('org_count',$result->fields('org_count')) ;
$t->set_var('latest_org_id',$result->fields('max_id')) ;

$sql="SELECT count(id) as person_count, max(id) as max_id from ${pre}person WHERE family<>''";
$result = $adodb->query($sql);
$t->set_var('person_count',$result->fields('person_count')) ;
$t->set_var('latest_person_id',$result->fields('max_id')) ;

$sql =	"SELECT count(contactid) as cnt from ${pre}org_person";
$result = $adodb->query($sql);
$t->set_var('org_person_count',$result->fields('cnt')) ;
$t->set_var('latest_org_person_id',exapi_lang('N/A')) ;

$sql =	"SELECT count(contactid) as cnt from ${pre}person_org";
$result = $adodb->query($sql);
$t->set_var('person_org_count',$result->fields('cnt')) ;
$t->set_var('latest_person_org_id',exapi_lang('N/A')) ;

$sql =	"SELECT count(contactid) as cnt from ${pre}org_org";
$result = $adodb->query($sql);
$t->set_var('org_org_count',$result->fields('cnt')) ;
$t->set_var('latest_org_org_id',exapi_lang('N/A')) ;

$sql =	"SELECT count(contactid) as cnt from ${pre}person_person";
$result = $adodb->query($sql);
$t->set_var('person_person_count',$result->fields('cnt')) ;
$t->set_var('latest_person_person_id',exapi_lang('N/A')) ;

$sql =	"SELECT count(contactid) as cnt from ${pre}comm" ;
$result = $adodb->query($sql);
$t->set_var('ccdata_count',$result->fields('cnt')) ;
$t->set_var('latest_ccdata_id',exapi_lang('N/A')) ;

$sql =	"SELECT count(contactid) as cnt from ${pre}address,${pre}org WHERE contactid=id" ;
$result = $adodb->query($sql);
$orgaddr_cnt = $result->fields('cnt') ;
$sql =	"SELECT count(contactid) as cnt from ${pre}address,${pre}person WHERE contactid=id" ;
$result = $adodb->query($sql);
$prsaddr_cnt = $result->fields('cnt') ;
$t->set_var('address_count',$orgaddr_cnt+$prsaddr_cnt) ;
$t->set_var('latest_address_id',exapi_lang('N/A')) ;

$lang_comm = strtolower(exapi_lang('comm')) ;
$sql =	"SELECT count(id) as cmcode_count, max(id) as max_id from ${pre}category WHERE app='$app' and type<>'$lang_comm'" ;
$result = $adodb->query($sql);
$t->set_var('cmcode_count',$result->fields('cmcode_count')) ;
$t->set_var('latest_cmcode_id',$result->fields('max_id')) ;

$sql =	"SELECT count(id) as commcat_count, max(id) as max_id from ${pre}category WHERE app='$app' and type='$lang_comm' and parent='0'" ;
$result = $adodb->query($sql);
$t->set_var('commcat_count',$result->fields('commcat_count')) ;
$t->set_var('latest_commcat_id',$result->fields('max_id')) ;

$sql =	"SELECT count(id) as commcode_count, max(id) as max_id from ${pre}category WHERE app='$app' and type='$lang_comm' and parent<>'0'" ;
$result = $adodb->query($sql);
$t->set_var('commcode_count',$result->fields('commcode_count')) ;
$t->set_var('latest_commcode_id',$result->fields('max_id')) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report');
	exapi_footer() ;

?>
