<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.commcat.inc.php 0.13.1 2005/06/15 C K Wu

    class commcat {

//---- Comm Channel Category Detail Validation Checks

    function commcat_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error") ;
	$maxname = 10 ;
	$maxdesc = 40 ;
	$desc = $dt[description] ;
	if ($dt[name]=="")			$err = exapi_lang("Channel category name Missing") ;
	   else if (strlen($dt[name])>$maxname)	$err = exapi_lang("Channel category name too long") ;
	if ($desc=="")				$err = exapi_lang("Channel category description Missing") ;
	   else if (strlen($desc)>$maxdesc)	$err = exapi_lang("Channel category description too long") ;
	if ($dt[type]<>$dt[oldtype] or $dt[name]<>$dt[oldname]) {
		$result = $adodb->query("SELECT * from ${pre}category where type='$dt[type]' and name='$dt[name]'");
		if ($result->RecordCount()>0)	$err = exapi_lang("Channel category name already exists") ;
		}
	if ($dt[app]<>$ckapi[params][app])	$err = exapi_lang("Invalid hidden app var -> Inform system admin") ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Comm Channel Category Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$app = $ckapi[params][app] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$allow = $dt[allowdelete] ;
	if ($allow<>"y" and $allow<>"Y")	$err = exapi_lang("Contact code flagged deletion not allowed");
	
	$errmsg1 = exapi_lang("This Channel category is in use within an existing") ;
	$commcode = exapi_lang("Comm Channel Code") ;
	$id = $dt[id] ;
	$result = $adodb->query("SELECT * FROM ${pre}category where app='$app' and parent='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $commcode id#".$result->fields('id') ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Comm Channel Category Detail

    function commcat_write() {
	global $ckapi ;

	$app = $ckapi[params][app] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$dt[parent] = 0 ;
	$lang_comm = strtolower(exapi_lang('comm')) ;
	$noyes_sl = "<OPTION value='n'>".exapi_lang('No')."</OPTION>" ;
	$noyes_sl.= "<OPTION value='y'>".exapi_lang('Yes')."</OPTION>" ;
	$t->set_var('lang_id',exapi_lang('Audit ID:')."  ");
	$t->set_var('lang_type',exapi_lang('Code Type'));
	$t->set_var('lang_name',exapi_lang('Channel Category Name'));
	$t->set_var('lang_description',exapi_lang('Channel Category Description'));
	$t->set_var('lang_adelete',exapi_lang('Allow Delete'));
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('app',$app);
	$t->set_var('type_selectlist',selectlist('category','type',"WHERE app='$app' and type='$lang_comm'",$dt[type],'distinct type','type'));
	$t->set_var('oldtype',$dt[oldtype]);
	$t->set_var('name',$dt[name]);
	$t->set_var('oldname',$dt[oldname]);
	$t->set_var('description',$dt[description]);
	$ad_sl = str_replace("'$dt[allowdelete]'","'$dt[allowdelete]' selected",$noyes_sl) ;
	$t->set_var('adelete_selectlist',$ad_sl);
	$t->parse('out','report',True);
	}

    }

?>
