<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.org.inc.php 0.13.1 2005/06/15 C K Wu

	class org {

//---- Contact Org Data Read

    function org_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	$result = $adodb->query("SELECT * FROM $table WHERE id='$id'");
	$dt = $result->fetchRow() ;
	if (is_array($uniqueflds) and $op=='edit')
	  	foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	if ($op=='copy')	$id=0 ;
	$lang_person = strtolower(exapi_lang('person')) ;
	$sql = "SELECT a.*,c.description as nature,b.prsnumber,b.family,b.given " ;
	$sql.= "FROM ${pre}org_person a, ${pre}person b, ${pre}category c " ;
	$sql.= "WHERE contactid='$id' and preferred='y' and c.type='$lang_person' and personid=b.id and a.personcode=c.name";
	$result = $adodb->query($sql);
	$dt[person] = $result->fetchRow() ;
	$lang_org = strtolower(exapi_lang('org')) ;
	$sql = "SELECT a.*,c.description as nature,b.orgname " ;
	$sql.= "FROM ${pre}org_org a, ${pre}org b, ${pre}category c " ;
	$sql.= "WHERE contactid='$id' and preferred='y' and c.type='$lang_org' and orgid=b.id and a.orgcode=c.name";
	$result = $adodb->query($sql);
	$dt[org] = $result->fetchRow() ;

	$lang_comm = strtolower(exapi_lang('comm')) ;
	$sql = "SELECT a.*,c.description as nature,b.id as catid " ;
	$sql.= "FROM ${pre}comm a, ${pre}category b, ${pre}category c " ;
	$sql.= "WHERE contactid='$id' and preferred='y' and b.type='$lang_comm' and commcode=c.name and c.parent=b.id";
	$result = $adodb->query($sql);
	while ($rs=$result->fetchRow()) {
		$catid = $rs[catid] ;
		$dt[comm][$catid] = $rs ;
		}
	$lang_addr = strtolower(exapi_lang('address')) ;
	$sql = "SELECT a.*,b.description as nature FROM ${pre}address a, ${pre}category b " ;
	$sql.= "WHERE contactid='$id' and preferred='y' and app='$app' and type='$lang_addr' and addresscode=b.name";
	$result = $adodb->query($sql);
	$dt[addr] = $result->fetchRow() ;
	$lang_org = strtolower(exapi_lang('org')) ;
	$sql = "SELECT contactid,name as nature,description as data,preferred " ;
	$sql.= "FROM ${pre}status a, ${pre}category b ";
	$sql.= "WHERE contactid='$id' and preferred='y' and a.statuscode=b.name and b.type='$lang_org'";
	$result = $adodb->query($sql);
	$dt[status] = $result->fetchRow() ;
	$lang_othr = exapi_lang('others') ;
	$sql = "SELECT contactid,description as nature,value as data,preferred FROM ${pre}others " ;
	$sql.= "WHERE contactid='$id' and preferred='y'";
	$result = $adodb->query($sql);
	$dt[othr] = $result->fetchRow() ;

	return $dt ;
	}

//---- Org Detail Validation Checks

    function org_validate() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error = exapi_lang("Error") ;
	if ($dt[orgnumber]=="")			$err=exapi_lang('Org Name/# Missing');
	if ($dt[orgname]=="")			$err=exapi_lang('Organization name missing');
	$result = $adodb->query("SELECT * FROM ${pre}person where prsnumber='$dt[orgnumber]'");
	if ($result->RecordCount()>0)		$err=exapi_lang("Org Name/# being used by an existing person contact") ;
	if ($dt[orgnumber]<>$dt[oldorgnumber]) {
		$result = $adodb->query("SELECT * FROM ${pre}org where orgnumber='$dt[orgnumber]'");
		if ($result->RecordCount()>0)	$err=exapi_lang("Org Name/# already exists") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- org Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=exapi_lang('Error') ;
	$errmsg1 = exapi_lang("This org is in use within an existing") ;
	$personorg = exapi_lang("Person=Org Linkage record") ;
	$orgorg = exapi_lang("Org=Org Linkage record") ;
	$customer = exapi_lang("Customer record") ;
	$id = $dt[id] ;
	$result = $adodb->query("SELECT * FROM ${pre}person_org where orgid='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $personorg id#".$result->fields('contactid') ;
	$result = $adodb->query("SELECT * FROM ${pre}org_org where orgid='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $orgorg id#".$result->fields('contactid') ;
	$result = $adodb->query("SELECT * FROM ${pre}customer where contactid='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $customer id#".$result->fields('id') ;
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Org Header

    function org_header_write() {
	global $ckapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$script = &$ckapi[params_post][script] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('lang_orgnumber',exapi_lang("Name/#"));
	$t->set_var('lang_id',exapi_lang("Audit Id :"));
	$t->set_var('lang_note',exapi_lang("Note"));
	$t->set_var('lang_orgname',exapi_lang("Organization Name"));
	$t->set_var('lang_nationalorgid',exapi_lang("Organization National ID"));
	$t->set_var('lang_username',exapi_lang("Host System User Name"));

	$blankopt = "<OPTION value=''></OPTION>" ;
	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('orgnumber',$dt[orgnumber]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('note',$dt[note]);
	$t->set_var('orgname',$dt[orgname]);
	$t->set_var('nationalorgid',$dt[nationalorgid]);
	$t->set_var('username',$dt[username]);

//	$t->parse('out','report',True);
	}

//---- Write org Detail

    function org_detail_write() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$op = $ckapi[params_post][op] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$tr_colorc = $ckapi[hostsys][tr_color3] ;

	$t->set_var('lang_channel',exapi_lang("Contact Data Type"));
	$t->set_var('lang_prefer',exapi_lang("Preferred Data"));
	$t->set_var('lang_type',exapi_lang("(comm - communication channel)"));
	$t->set_var('lang_category',exapi_lang("Category"));
	$t->set_var('lang_nature',exapi_lang("Nature"));
	$t->set_var('lang_data',exapi_lang("Data"));
	$t->set_var('lang_full',exapi_lang("Full Info"));
	switch ($op) :
		case "view" :	$t->set_var('lang_action',exapi_lang('view')) ;	break;
		case "copy" :	$t->set_var('lang_action',"") ;			break;
		case "edit" :	$t->set_var('lang_action',exapi_lang('edit')) ;	break;
		case "delete" :	$t->set_var('lang_action','') ;			break;
		case "add" :	$t->set_var('lang_action',"") ;			break;
		endswitch ;

	$t->set_var('type',exapi_lang("Related Person"));
	$t->set_var('nature',$dt[person][nature]);
	$title = $dt[person][title] ;
	$prsnumber = $dt[person][prsnumber] ;
	$family = $dt[person][family] ;
	$given = $dt[person][given] ;
	if ($family=="" and $given=="")		$data = $prsnumber ;
	  else					$data = "$prsnumber ($family, $given)" ;
	if ($title<>"")	{
		$lang_title = exapi_lang("Title") ;
		$data.= " [$lang_title - $title]" ;
		}
	$t->set_var('data',$data);
	$script = "orgperson$op.php" ;
	$getstr = "id=$dt[id]&return=$script" ;
	switch ($op) :
		case "view" :	$t->set_var('action',exapi_link("/$app/$script",$getstr));	break;
		case "edit" :	$t->set_var('action',exapi_link("/$app/$script",$getstr));	break;
		endswitch ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$t->set_var('type',exapi_lang("Associated Organization"));
	$t->set_var('nature',$dt[org][nature]);
	$t->set_var('data',$dt[org][orgname]);
	$script = "orgorg$op.php" ;
	$getstr = "id=$dt[id]&return=$script" ;
	switch ($op) :
		case "view" :	$t->set_var('action',exapi_link("/$app/$script",$getstr));	break;
		case "edit" :	$t->set_var('action',exapi_link("/$app/$script",$getstr));	break;
		endswitch ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);
	
	$lang_comm = strtolower(exapi_lang('comm')) ;
	$msg = exapi_lang("Comm") ;
	$result = $adodb->query("SELECT * FROM ${pre}category WHERE app='$app' and type='$lang_comm' and parent='0'");
	while ($rs=$result->fetchRow()) {
		$catid = $rs[id] ;
		$comm = ($dt[comm][$catid]<>"") ? $dt[comm][$catid] : "" ;
		$desc = $rs[description] ;
		$t->set_var('type',"$msg - $desc");
		$t->set_var('nature',$comm[nature]);
		$t->set_var('data',$comm[commdata]);
		$script = "comm$op.php" ;
		$getstr = "id=$dt[id]&table=$table&catid=$catid&return=$script" ;
		switch ($op) :
			case "view" :	$t->set_var('action',exapi_link("/$app/$script",$getstr));	break;
			case "edit" :	$t->set_var('action',exapi_link("/$app/$script",$getstr));	break;
			endswitch ;
		$t->set_var('tr_color',$tr_colorc) ;
		$t->parse('detail_section','detail', True);
		}
	
	$t->set_var('type',exapi_lang("Address"));
	$t->set_var('nature',$dt[addr][nature]);
	$l1 = trim($dt[addr][line1]) ;
	$l2 = trim($dt[addr][line2]) ;
	$l3 = trim($dt[addr][line3]) ;
	$l4 = trim($dt[addr][line4]) ;
	$reg = trim($dt[addr][region]) ;
	$ctry = trim($dt[addr][country]) ;
	$zip = trim($dt[addr][zip]) ;
	$t->set_var('data',"$l1 $l2<br>$l3 $l4<br>$reg $ctry $zip");
	$script = "address$op.php" ;
	$getstr = "id=$dt[id]&table=$table&return=$script" ;
	switch ($op) :
		case "view" :	$t->set_var('action',exapi_link("/$app/$script",$getstr));	break;
		case "edit" :	$t->set_var('action',exapi_link("/$app/$script",$getstr));	break;
		endswitch ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$t->set_var('type',exapi_lang("Status"));
	$t->set_var('nature',$dt[status][nature]);
	$t->set_var('data',$dt[status][data]);
	$script = "status$op.php" ;
	$getstr = "id=$dt[id]&table=$table&return=$script" ;
	switch ($op) :
		case "view" :	$t->set_var('action',exapi_link("/$app/$script",$getstr));	break;
		case "edit" :	$t->set_var('action',exapi_link("/$app/$script",$getstr));	break;
		endswitch ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$t->set_var('type',exapi_lang("Others"));
	$t->set_var('nature',$dt[othr][nature]);
	$t->set_var('data',$dt[othr][data]);
	$script = "others$op.php" ;
	$getstr = "id=$dt[id]&table=$table&return=$script" ;
	switch ($op) :
		case "view" :	$t->set_var('action',exapi_link("/$app/$script",$getstr));	break;
		case "edit" :	$t->set_var('action',exapi_link("/$app/$script",$getstr));	break;
		endswitch ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	if ($op=="edit") {
		$t->set_var('lang_image_action',exapi_lang("Edit Image"));
		$getstr = "id=$dt[id]&table=$table&return=imageedit.php" ;
		$t->set_var('image_action',exapi_link("/$app/imageedit.php",$getstr));
		}
	  else	$t->set_var('lang_image_action',"");
	$imageid = $dt[id] ;
	$img = $ckapi[hostsys][dataarea]."/images/$imageid.png" ;
	$t->set_var('image',exapi_link("/$app/contactview_image.php","imgfile=$img"));
	$t->set_var('tr_color_a',$tr_color2) ;
	$t->set_var('tr_color_b',$tr_color1) ;

	}
	
//---- org Post - PreCommit Routine (* if delete op, erase auxillary info *)

    function org_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	if ($op=='delete') {
		$adodb->query("DELETE FROM ${pre}org_person where contactid = '$id'");
		$adodb->query("DELETE FROM ${pre}org_org where contactid = '$id'");
		$adodb->query("DELETE FROM ${pre}comm where contactid = '$id'");
		$adodb->query("DELETE FROM ${pre}address where contactid = '$id'");
		$adodb->query("DELETE FROM ${pre}status where contactid = '$id'");
		$adodb->query("DELETE FROM ${pre}others where contactid = '$id'");
		$imgfile = $ckapi[hostsys][dataarea]."/images/$id.png" ;
		exec("rm -f $imgfile") ;
		}
	}
	
    }

?>



