<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.address.inc.php 0.13.1 2005/06/15 C K Wu

    class address {

//---- Address Read

    function address_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$table = $ckapi[params][table] ;
	$id = $ckapi[params_post][id] ;

	$result = $adodb->query("SELECT * FROM $table WHERE id='$id'");
	$dt = $result->fetchRow() ;
	if ($table=="${pre}org")	$dt[name] = $dt[orgnumber] ;
	if ($table=="${pre}person")	$dt[name] = $dt[prsnumber] ;
	$result = $adodb->query("SELECT * FROM ${pre}address where contactid='$id' order by addresscode");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['line1'.$i]		=	$rs['line1'] ;
		$dt['line2'.$i]		=	$rs['line2'] ;
		$dt['line3'.$i]		=	$rs['line3'] ;
		$dt['line4'.$i]		=	$rs['line4'] ;
		$dt['addresscode'.$i]	=	$rs['addresscode'] ;
		$dt['region'.$i]	=	$rs['region'] ;
		$dt['country'.$i]	=	$rs['country'] ;
		$dt['zip'.$i]		=	$rs['zip'] ;
		$dt['preferred'.$i]	=	$rs['preferred'] ;
		}
	return $dt;
	}

//---- Write Address Header

    function address_header_write() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	$t->set_var('lang_name',exapi_lang('Contact Name/# :'));
	$t->set_var('lang_id',exapi_lang('Audit Id :'));
	$t->set_var('name',$dt[name]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('table',$ckapi[params][table]) ;
	$t->parse('out','report',True);
	}

//---- Write Address Detail

    function address_detail_write() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;

	$row_ = exapi_lang('Row')." " ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',exapi_lang('Insert<br>before'));
	$t->set_var('lang_address',exapi_lang('Address (Addr) Line1, Line2, Line3, Line4'));
	$t->set_var('lang_codetype',exapi_lang("Type of Code") );
	$t->set_var('lang_codedesc',exapi_lang("Code -- Description [or Data Input Field]") );
	$t->set_var('lang_preferred',exapi_lang('Preferred Address'));
	$t->set_var('lang_addresscode',exapi_lang('Address Type'));
	$t->set_var('lang_region',exapi_lang('Region'));
	$t->set_var('lang_country',exapi_lang('Country'));
	$t->set_var('lang_zip',exapi_lang('Postal Code'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('lang_reserved',exapi_lang('Reserved Space'));
	$blankopt = "<OPTION value=''></OPTION>" ;
	$lang_address = strtolower(exapi_lang('address')) ;
	$lang_region = exapi_lang('region') ;
	$lang_country = exapi_lang('country') ;
	$lang_no = exapi_lang("no") ;
	$lang_yes = exapi_lang("yes") ;
	$preferred_sl = "<OPTION value='n'>n -- $lang_no</OPTION><OPTION value='y'>y -- $lang_yes</OPTION>" ;
	$where = "WHERE app='ck-contact' and type='$lang_address'" ;
	$addresscode_sl = selectlist('category','name',$where,'','name','name','substring(description,1,25)') ;
	$where = "WHERE app='ck-contact' and type='$lang_region'" ;
	$region_sl = $blankopt.selectlist('category','name',$where,'','name','name','substring(description,1,25)') ;
	$where = "WHERE app='ck-contact' and type='$lang_country'" ;
	$country_sl = $blankopt.selectlist('category','name',$where,'','name','name','substring(description,1,25)') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['addresscode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('line1_fld','line1'.$i);
			$t->set_var('line2_fld','line2'.$i);
			$t->set_var('line3_fld','line3'.$i);
			$t->set_var('line4_fld','line4'.$i);
			$t->set_var('preferred_fld','preferred'.$i) ;
			$t->set_var('addresscode_fld','addresscode'.$i) ;
			$t->set_var('region_fld','region'.$i) ;
			$t->set_var('country_fld','country'.$i) ;
			$t->set_var('zip_fld','zip'.$i) ;
			$t->set_var('line1','') ;
			$t->set_var('line2','') ;
			$t->set_var('line3','') ;
			$t->set_var('line4','') ;
			$t->set_var('zip','') ;
			$t->set_var('preferred_selectlist',$preferred_sl) ;
			$t->set_var('addresscode_selectlist',$addresscode_sl) ;
			$t->set_var('region_selectlist',$region_sl) ;
			$t->set_var('country_selectlist',$country_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$preferred	= $dt['preferred'.$i] ;
		$addresscode	= $dt['addresscode'.$i] ;
		$region		= $dt['region'.$i] ;
		$country	= $dt['country'.$i] ;
		$t->set_var('line1_fld','line1'.$j);
		$t->set_var('line2_fld','line2'.$j);
		$t->set_var('line3_fld','line3'.$j);
		$t->set_var('line4_fld','line4'.$j);
		$t->set_var('preferred_fld','preferred'.$j) ;
		$t->set_var('addresscode_fld','addresscode'.$j) ;
		$t->set_var('region_fld','region'.$j) ;
		$t->set_var('country_fld','country'.$j) ;
		$t->set_var('zip_fld','zip'.$j) ;

		$t->set_var('line1',$dt['line1'.$i]) ;
		$t->set_var('line2',$dt['line2'.$i]) ;
		$t->set_var('line3',$dt['line3'.$i]) ;
		$t->set_var('line4',$dt['line4'.$i]) ;
		$t->set_var('zip',$dt['zip'.$i]) ;
		$t->set_var('preferred_selectlist',str_replace("'$preferred'","'$preferred' selected",$preferred_sl)) ;
		$t->set_var('addresscode_selectlist',str_replace("'$addresscode'","'$addresscode' selected",$addresscode_sl)) ;
		$t->set_var('region_selectlist',str_replace("'$region'","'$region' selected",$region_sl)) ;
		$t->set_var('country_selectlist',str_replace("'$country'","'$country' selected",$country_sl));
		if ($posted)	$t->set_var('insrowno',"done") ;  else  $t->set_var('insrowno',$row_.$j);
		if ($posted)	$t->set_var('delrowno',"done") ;  else  $t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('line1_fld','line1'.$i);
		$t->set_var('line2_fld','line2'.$i);
		$t->set_var('line3_fld','line3'.$i);
		$t->set_var('line4_fld','line4'.$i);
		$t->set_var('preferred_fld','preferred'.$i) ;
		$t->set_var('addresscode_fld','addresscode'.$i) ;
		$t->set_var('region_fld','region'.$i) ;
		$t->set_var('country_fld','country'.$i) ;
		$t->set_var('zip_fld','zip'.$i) ;
		$t->set_var('line1','') ;
		$t->set_var('line2','') ;
		$t->set_var('line3','') ;
		$t->set_var('line4','') ;
		$t->set_var('zip','') ;
		$t->set_var('preferred_selectlist',$preferred_sl) ;
		$t->set_var('addresscode_selectlist',$addresscode_sl) ;
		$t->set_var('region_selectlist',$region_sl) ;
		$t->set_var('country_selectlist',$country_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->parse('out','report',True);
	}

    }

?>

