<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// employeefilter.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-hr' ;
	$tran = 'employee' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'employee',
				'tran'		=> $tran ,
				'table'		=> "${pre}employee" 			) ;
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("Search among existing Employees :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Employee") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$lang_prefix = strtolower(exapi_lang('prefix')) ;
	$lang_suffix = strtolower(exapi_lang('suffix')) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Prefix') ,
				type		=>	'select' ,
				selectlist	=>$nullopt.selectlist('category','name',"WHERE app='$app' and type='$lang_prefix'",'','name','name') ,
				varname		=>	'prefix' ,
				defval		=>	'' ,
				note		=>	exapi_lang('Search for target Employee Name Prefix'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Suffix') ,
				type		=>	'select' ,
				selectlist	=>$nullopt.selectlist('category','name',"WHERE app='$app' and type='$lang_suffix'",'','name','name') ,
				varname		=>	'suffix' ,
				defval		=>	'' ,
				note		=>	exapi_lang('Search for target Employee Name Suffix')) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Employee Name/#') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	'' ,
				note		=>	exapi_lang('Search for target key word in the Employee Name/# Field') ) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Family Name') ,
				type		=>	'input' ,
				varname		=>	'family' ,
				defval		=>	'' ,
				note		=>	exapi_lang('Search for target key word in the Employee Family Name Field') ) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Given Name') ,
				type		=>	'input' ,
				varname		=>	'given' ,
				defval		=>	'' ,
				note		=>	exapi_lang('Search for target key word in the Employee Given Name Field') ) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('National ID') ,
				type		=>	'input' ,
				varname		=>	'nationalid' ,
				defval		=>	'' ,
				note		=>	exapi_lang('Search for target key word in the Employee National ID Field') ) ;

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
