<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.commcode.inc.php 0.13.1 2005/06/15 C K Wu

    class commcode {

//---- Comm Channel Code List SQL Formation

    function commcode_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	
	if (!$order)	$order = "b.name" ;
	if (!$sort)	$sort = "ASC" ;
	$sql =  "SELECT a.name as commcat,b.name,b.description,b.allowdelete,b.id " ;
	$sql.=  "FROM ${pre}category a, ${pre}category b ";
	$sql.=  "WHERE $where and b.parent=a.id " ;
	$sql.=	"order by $order $sort" ;
	return $sql ;
	}

//---- comm Channel Code Read

    function commcode_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;

	$sql =  "SELECT a.name as commcat,b.name,b.description,b.allowdelete,b.id,b.control " ;
	$sql.=  "FROM $table a, $table b WHERE b.id='$id' and b.parent=a.id " ;
	$result = $adodb->query($sql);
	$dt = $result->fetchRow() ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt;
	}

//---- Comm Channel Code Detail Validation Checks

    function commcode_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$table = $ckapi[params][table] ;

	$err=""; $error=exapi_lang("Error") ;
	$maxname = 10 ;
	$maxdesc = 40 ;
	$desc = $dt[description] ;
	if ($dt[name]=="")			$err = exapi_lang("Channel code name Missing") ;
	   else if (strlen($dt[name])>$maxname)	$err = exapi_lang("Channel code name too long") ;
	if ($desc=="")				$err = exapi_lang("Channel code description Missing") ;
	   else if (strlen($desc)>$maxdesc)	$err = exapi_lang("Channel code description too long") ;
	if ($dt[commcat]<>$dt[oldcommcat] or $dt[name]<>$dt[oldname]) {
		$sql =  "SELECT * FROM $table a, $table b WHERE b.parent=a.id AND a.name='$dt[commcat]' and b.name='$dt[name]'" ;
		$result = $adodb->query($sql);
		if ($result->RecordCount()>0)	$err = exapi_lang("Channel category/code name combo already exists") ;
		}
	if ($dt[app]<>$ckapi[params][app])	$err = exapi_lang("Invalid hidden app var -> Inform system admin") ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Comm Channel Code Delete Validation Checks

    function delete_validate() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$allow = $dt[allowdelete] ;
	if ($allow<>"y" and $allow<>"Y")	$err = exapi_lang("Channel code flagged deletion not allowed");
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Comm Channel Code Detail

    function commcode_write() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$dt[parent] = 0 ;
	$lang_comm = strtolower(exapi_lang('comm')) ;
	$noyes_sl = "<OPTION value='n'>".exapi_lang('No')."</OPTION>" ;
	$noyes_sl.= "<OPTION value='y'>".exapi_lang('Yes')."</OPTION>" ;
	$t->set_var('lang_id',exapi_lang('Audit ID:')."  ");
	$t->set_var('lang_commcat',exapi_lang('Channel Category'));
	$t->set_var('lang_name',exapi_lang('Channel Code Name'));
	$t->set_var('lang_description',exapi_lang('Channel Code Description'));
	$t->set_var('lang_adelete',exapi_lang('Allow Delete'));
	
	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)	$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('app',$ckapi[params][app]);
$t->set_var('commcat_selectlist',selectlist('category','name',"WHERE app='ck-hr' and type='$lang_comm' and parent='0'",$dt[commcat],'name','name'));
	$t->set_var('name',$dt[name]);
	$t->set_var('description',$dt[description]);
	$ad_sl = str_replace("'$dt[allowdelete]'","'$dt[allowdelete]' selected",$noyes_sl) ;
	$t->set_var('adelete_selectlist',$ad_sl);
	$t->parse('out','report',True);
	}

//---- Comm Channel Code Post - Init Routine

    function commcode_post_init() {
	global $ckapi,$adodb ;

	$table = $ckapi[params][table] ;
	$dt = &$ckapi[params_post][dt] ;

	$lang_comm = strtolower(exapi_lang('comm')) ;
	if ($ckapi[params_post][op]<>'delete') {
		$sql =  "SELECT id as parent FROM $table WHERE app='$dt[app]' and type='$lang_comm' and name='$dt[commcat]' and parent='0'" ;
		$result = $adodb->query($sql);
		$dt["parent"]= $result->fields('parent') ;
		$dt["type"] = $lang_comm ;
		}
	}

    }

?>
