<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.dept.inc.php 0.13.1 2005/06/15 C K Wu

    class dept {

//---- Department Detail Validation Checks

    function dept_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error") ;
	if ($dt[name]=="")		$err=exapi_lang('Department name Missing');
	if ($dt[description]=="")	$err=exapi_lang('Department description Missing');
	if ($dt[email] and strpos($dt[email],'@')=='')  $err = exapi_lang("Invalid email address") ;
	if ($dt[name]<>$dt[oldname]) {
		$result = $adodb->query("SELECT * from ${pre}department where name='$dt[name]'");
		if ($result->RecordCount()>0)	$err = exapi_lang("Department Name already exists") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Department Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$errmsg1 = exapi_lang("This department is in use within an existing") ;
	$emprec = exapi_lang("employee record") ;
	$journal = exapi_lang("journal") ;
	$id = $dt[id] ;
	$result = $adodb->query("SELECT * from ${pre}employee where dept='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $emprec id#".$result->fields('id') ;

	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Department Detail

    function dept_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',exapi_lang('Audit ID:')."  ");
	$t->set_var('lang_name',exapi_lang('Department Name'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_head',exapi_lang('Head of Department'));
	$t->set_var('lang_email',exapi_lang('Contact Email'));
	$t->set_var('lang_headcount',exapi_lang('Head Count'));
	$id = ($dt[id]=="") ? 0 : $dt[id] ;
	$t->set_var('id',$id);
	$t->set_var('control',$dt[control]);
	$t->set_var('name',$dt[name]);
	$t->set_var('oldname',$dt[oldname]);
	$t->set_var('description',$dt[description]);
	$t->set_var('head_sl',selectlist('employee','name','',$dt[head],'id','name','id'));
	$t->set_var('email',$dt[email]);
	$result = $adodb->query("SELECT count(name) as headcount from ${pre}employee where dept = '$id'");
	$t->set_var('headcount',$result->fields('headcount'));
	$t->set_var('message','');
	$t->parse('out','report',True);
	}


    }

?>
