<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.employee.inc.php 0.13.1 2005/06/15 C K Wu

	class employee {

//---- Employee List SQL Formation

    function employee_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	
	$sql =  "SELECT a.*,b.family,b.given,b.nationalid " ;
	$sql.=  "FROM ${pre}employee a, ${pre}empperson b ";
	$sql.=  "WHERE $where and contactid=b.id " ;
	$sql.=	"order by $order $sort" ;
	return $sql ;
	}

//---- Employee Read

    function employee_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$result = $adodb->query("SELECT * FROM $table WHERE id='$id'");
	$dt = $result->fetchRow() ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
//		}
	}

//---- Employee Detail Validation Checks

    function employee_validate() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error = exapi_lang("Error") ;
	if ($dt[title]=="")			$err=exapi_lang('Corporate title missing');
	if ($dt[contactid]<>$dt[oldcontactid]) {
		$result = $adodb->query("SELECT * FROM ${pre}employee where contactid='$dt[contactid]'");
		if ($result->RecordCount()>0)	$err=exapi_lang("Employee Name/# belongs to an existing employee") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Employee Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$errmsg = exapi_lang("This employee is in use within an existing") ;
	$payroll = exapi_lang("payroll record") ;
	$id = $dt[id] ;
	$result = $adodb->query("SELECT * FROM ${pre}payroll where empid='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg $payroll id#".$result->fields('id') ;

	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Employee Detail

    function employee_write() {
	global $ckapi ;

	$app = $ckapi[params][app] ;
	$op = $ckapi[params_post][op] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('lang_name',exapi_lang("Employee Name/#"));
	$t->set_var('lang_id',exapi_lang("Audit Id"));
	$t->set_var('lang_contactid',exapi_lang("Contact Info"));
	$t->set_var('contactid_comment',exapi_lang("This points to the employee's personal info record"));
	$t->set_var('lang_ctitle',exapi_lang("Corporate Title"));
	$t->set_var('lang_dept',exapi_lang("Department"));
	$t->set_var('lang_grade',exapi_lang("Staff Grade"));
	$t->set_var('lang_supervisor',exapi_lang("Supervisor"));
	$t->set_var('lang_subtitle',exapi_lang("Auxillary Employee Information [click righthand links to view/edit details]"));
	$t->set_var('lang_contact',exapi_lang("Detail Contact Info"));
	$t->set_var('lang_ec',exapi_lang("Emergency Contact"));
	$t->set_var('lang_dates',exapi_lang("Important Dates"));
	$t->set_var('lang_leave',exapi_lang("Leave Record"));
	$t->set_var('lang_perform',exapi_lang("Performance Review"));
	$t->set_var('lang_role',exapi_lang("Role"));
	if ($ckapi[params_post][op]=='add' or $ckapi[params_post][op]=='edit')
		{$t->set_var('lang_viewedit',exapi_lang("Edit"));	$viewedit = "edit" ;	}
	  else	{$t->set_var('lang_viewedit',exapi_lang("View"));	$viewedit = "view" ;	}

	$blankopt = "<OPTION value=''></OPTION>" ;
	if ($op=='edit' and is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$name = ($ckapi[hostsys][dbtype]=="mysql") ? "substring(concat(family,', ',given),1,25)" : "substring((family||', '||given),1,25)" ;
	$t->set_var('contactid_sl',selectlist('empperson','prsnumber','',$dt[contactid],'id','prsnumber',$name,'id'));
	$t->set_var('title',$dt[title]);
	$t->set_var('dept_sl',selectlist('department','name','',$dt[dept],'id','description'));
	$lang_grade = strtolower(exapi_lang('grade')) ;
	$t->set_var('grade_sl',selectlist('category','name',"WHERE type='$lang_grade'",$dt[grade],'name','name','substring(description,1,25)'));
	$t->set_var('supervisor_sl',selectlist('employee','name','',$dt[supervisor],'id','name','id'));
	$getstr = "id=$dt[id]" ;
	$t->set_var('dates',exapi_link("/$app/dates$viewedit.php",$getstr));
	$t->set_var('leave',exapi_link("/$app/leave$viewedit.php",$getstr));
	$t->set_var('perform',exapi_link("/$app/pr$viewedit.php",$getstr));
	$t->set_var('role',exapi_link("/$app/role$viewedit.php",$getstr));

	$t->parse('out','report',True);
	}

//---- Employee Post Initialisation

    function employee_post_init() {
	global $ckapi,$pre,$adodb ;

	$dt = &$ckapi[params_post][dt] ;
	$result = $adodb->query("SELECT prsnumber as name FROM ${pre}empperson WHERE id=$dt[contactid]") ;
	$dt[name] = $result->fields('name') ;
	}
	
//---- Employee Post - PreCommit Routine (* if delete op, erase auxillary info *)

    function employee_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = $ckapi[params_post][dt] ;
	if ($op=='delete') {
		$adodb->query("DELETE FROM ${pre}dates where empid = '$id'");
		$adodb->query("DELETE FROM ${pre}leave where empid = '$id'");
		$adodb->query("DELETE FROM ${pre}pr where empid = '$id'");
		$adodb->query("DELETE FROM ${pre}role where empid = '$id'");
		}
	}
    }

?>



