<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// alternatefilter.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-inv' ;
	$tran = 'alternate' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;

	$msg1 = exapi_lang('Alternative Parts relate to one-way substitution only.') ;
	$msg2 = exapi_lang('For reverse substitution, explicit input is required.') ;
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("Search among existing Alternate Parts :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Alternate Part") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Name/Number') ,
				type		=>	'input' ,
				varname		=>	'partnumber' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for target character/numeric combination in the Alternate Part Name/# field') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Description') ,
				type		=>	'input' ,
				varname		=>	'description' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for target key word in the Alternate Part Description field'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Notes') ,
				type		=>	'input' ,
				varname		=>	'notes' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for target key word in the Alternate Part Notes field'));

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
