<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// inventoryhist.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-inv' ;
	$tran = 'inventory' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$start = ($_GET["start"]) ? $_GET["start"] : $_POST["start"] ;
	$filter=stripslashes($filter);

	$t = ckapi_tpl($app);
	$t->set_file('report',"${tran}hist.tpl") ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',exapi_lang('View Inventory Balance and In/Out History'));
	$t->set_var('message','') ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$db_type = $ckapi[hostsys][dbtype] ;
	$note1 =exapi_lang('Bal - Stock Balance; IA - Inventory Adjustment; GR - Goods Receipt; GD - Goods Delivery; CS - Cash Sale.');
	$note2 =exapi_lang('Press (done) button at View Detail screen to go on to transaction maintenance');

	$err="";
	if (isset($start))	{
		if (input2date($start)=="")		$err=exapi_lang("Error: Invalid History Start Date");
		$jdstart = mktime(0,0,0,intval(substr($start,5,2)),intval(substr($start,8,2)),intval(substr($start,0,4))) ;
		$today = mktime(0,0,0,date("m"),date("d"),date("Y")) ;
		if ($jdstart>$today)			$err=exapi_lang("Error: Start Date > System day") ;
		}
	if ($err)	$err = "<b>$err</b>" ;
	$start = (!$start) ? date("Y-m-d",mktime(0,0,0,date("m")-1,1,date("Y"))) : $start ;

/*------------- Write (Inventory) Header to Screen Display ----------------------------*/

	$t->set_var('lang_id',exapi_lang('Audit ID'));
	$t->set_var('lang_number',exapi_lang('Part#/Description'));
	$t->set_var('lang_bin',exapi_lang('Bin Location'));
	$t->set_var('lang_notes',exapi_lang('Notes'));
	$t->set_var('lang_note',$note2);

	$result = $adodb->query("SELECT * FROM ${pre}parts WHERE id='$id'");
	$t->set_var('id',$id);
	$t->set_var('partnumber',$result->fields('partnumber'));
	$t->set_var('bin',$result->fields('bin'));
	$desc = $result->fields('partnumber')." -- ".$result->fields('description') ;
	$t->set_var('desc',$desc);
	$t->set_var('notes',$result->fields('notes'));

/*------------- Write Inventory History to Screen Display ----------------------------*/

	$t->set_var('lang_date',exapi_lang('Date'));
	$t->set_var('lang_type',exapi_lang('Type'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_ordnumber',exapi_lang('Order Number'));
	$t->set_var('lang_qty_pos',exapi_lang('Qty Received<br>/(+ve)Adjusted'));
	$t->set_var('lang_qty_neg',exapi_lang('Qty Issued<br>/(-ve)Adjusted'));
	$t->set_var('lang_balance',exapi_lang('Balance'));
	$t->set_var('lang_viewdetail',exapi_lang('View Detail'));

if ($err=="") {

	$sql = "SELECT sum(qty) as sumqty FROM ${pre}inv_trans a,${pre}il b " ;
	$sql.= "WHERE parts_id=$id and a.trans_id=b.id and a.transdate<'$start'" ;
	$result = $adodb->query($sql);
	$t->set_var('date',$start);
	$t->set_var('type',exapi_lang("Bal"));
	$t->set_var('description',exapi_lang("Beginning Balance"));
	$t->set_var('ordnumber','');
	$t->set_var('qty_pos','');
	$t->set_var('qty_neg','');
	$sumqty = $result->fields('sumqty') ;
	$sumqty = isset($sumqty) ? $sumqty : 0 ;
	$t->set_var('balance',$sumqty);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$iasql = "SELECT a.transdate,source,description,'' as ordnumber,qty,trans_id " ;
	$iasql.= "FROM ${pre}inv_trans a, ${pre}il b ";
	$iasql.= "WHERE parts_id=$id and a.trans_id=b.id and substring(source,1,2)='IA' " ;
	$iasql.= "and a.transdate>='$start' " ;
	$posql = "SELECT a.transdate,source,description,ponumber as ordnumber,qty,trans_id " ;
	$posql.= "FROM ${pre}inv_trans a, ${pre}il b, ${pre}po c ";
	$posql.= "WHERE parts_id=$id and a.trans_id=b.id and order_id=c.id and a.transdate>='$start' " ;
	$sosql = "SELECT a.transdate,source,description,sonumber as ordnumber,qty,trans_id " ;
	$sosql.= "FROM ${pre}inv_trans a, ${pre}il b, ${pre}so c ";
	$sosql.= "WHERE parts_id=$id and a.trans_id=b.id and order_id=c.id and a.transdate>='$start' " ;
	$cssql = "SELECT a.transdate,source,description,'' as ordnumber,qty,trans_id " ;
	$cssql.= "FROM ${pre}inv_trans a, ${pre}il b, ${pre}pos c ";
	$cssql.= "WHERE parts_id=$id and a.trans_id=b.id and order_id=c.id and a.transdate>='$start' " ;

	if ($db_type=="mysql")	{
		$temp = "${pre}ihist".time() ;
		$adodb->query("CREATE TABLE $temp AS $posql") ;
		$adodb->query("INSERT INTO $temp $sosql") ;
		$adodb->query("INSERT INTO $temp $iasql") ;
		$adodb->query("INSERT INTO $temp $cssql") ;
		$result = $adodb->query("SELECT * from $temp ORDER BY transdate") ;
		}
	    else {
		$sql = "$iasql UNION $sosql UNION $posql UNION $cssql ORDER BY transdate" ;
		$result = $adodb->query($sql);
		}
	$balance = $sumqty ;
	$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	While ($rs=$result->fetchRow()) {
		$t->set_var('date',$rs['transdate']);
		$t->set_var('type',substr($rs['source'],0,2));
		$t->set_var('description',$rs['description']);
		$t->set_var('ordnumber',$rs['ordnumber']);
		$qty = $rs['qty'] ;
		if ($qty>=0) {
			$t->set_var('qty_pos',$qty);
			$t->set_var('qty_neg',".");
			}
		  else {
			$t->set_var('qty_pos',".");
			$t->set_var('qty_neg',$qty);
			}
		$balance += $qty ;

		$t->set_var('balance',$balance);
		$transcode = substr($rs['source'],0,4);
		$trans_id = $rs['trans_id'];
		$ifilter = urlencode("${markpri}1id${marksec}$trans_id") ;
		$afilter = urlencode("${markpri}1a.id${marksec}$trans_id") ;
		switch ($transcode) :
			case "IA" :	$jscript = $oscript = "/$app/iaview.php" ;
					$jfilter = $ofilter = $ifilter ;		break ;
			case "GR" :	$jscript = $oscript = "/$app/grview.php" ;
					$jfilter = $ofilter = $afilter ;		break ;
			case "GD" :	$jscript = $oscript = "/$app/gdview.php" ;
					$jfilter = $ofilter = $afilter ;		break ;
			case "CSNT" :	$jscript = "/$app/gdview.php" ;
					$oscript = "/ck-pos-c/csntview.php" ;
					$jfilter = $ofilter = $afilter ;		break ;
			case "CSWT" :	$jscript = "/$app/gdview.php" ;
					$oscript = "/ck-pos-c/cswtview.php" ;
					$jfilter = $ofilter = $afilter ;		break ;
			default : 	$script = "error" ;				break ;
			endswitch ;
		$t->set_var('journal',exapi_link("$jscript","id=$trans_id&filter=$jfilter"));
		$t->set_var('lang_journal',exapi_lang("Inv Tran"));
		$t->set_var('origin',exapi_link("$oscript","id=$trans_id&filter=$ofilter"));
		$t->set_var('lang_origin',exapi_lang("Origin"));
		if ($script=="error")	{
			$t->set_var('origin',"");
			$t->set_var('lang_origin',"<b>".exapi_lang("Error")."</b>");
			}
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('date',date("Y-m-d"));
	$t->set_var('type',exapi_lang("Bal"));
	$t->set_var('description',exapi_lang("Current Balance"));
	$t->set_var('ordnumber','');
	$t->set_var('qty_pos','');
	$t->set_var('qty_neg','');
	$t->set_var('balance',$balance);
	$t->set_var('journal',"");
	$t->set_var('lang_journal',"");
	$t->set_var('origin',"");
	$t->set_var('lang_origin',"");
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);
	if ($db_type=="mysql")		$adodb->query("DROP TABLE $temp") ;
	}

else {
	$note1 = $err ;
	$t->set_var('detail_section',"") ;
	}

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_note1',$note1);
	$t->set_var('lang_note2',$note2);
	$t->set_var('lang_start',exapi_lang('History Start Date'));
	$t->set_var('start',$start);
	$t->set_var('lang_regenerate',exapi_lang('Regenerate (after changing History Start Date)'));
	$t->set_var('regenerate_action',exapi_link("/$app/${tran}hist.php","id=$id&filter=$filter"));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->set_var('done_action',exapi_link("/$app/${tran}list.php","filter=$filter")) ;
	$t->pparse('out','report',True);
	exapi_footer() ;

?>
