<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// journalerrlist.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-ledger' ;
	$tran = 'journalerrlist' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)

	$t = ckapi_tpl($app);
	$t->set_file(array('report'=>'confirm.tpl',  'question'=>'confirm.tpl'));
	$title = exapi_lang("List of Journals with Anomalies") ;
	$comment = exapi_lang("By definition, this list should be empty") ;

/*------------- Print List ----------------------------*/

	echo "<br><br><B>$title</b><br><br>" ;
	$sql = "SELECT a.id,source,description,sum(amount) as amount FROM ${pre}gl a, ${pre}acc_trans b " ;
	$sql.= "WHERE a.id=trans_id GROUP BY a.id,trans_id,source,description" ;
	$result = $adodb->query($sql);
	While ($rs=$result->fetchRow()) {
		$amount = sprintf("%01.2f",$rs['amount']) ;
		if ($amount==0)		continue ;
		$id = $rs['id'] ;
		$source = $rs['source'] ;
		$desc = $rs['description'] ;
		echo "Journal ID: $id;  Source: $source;  Description: $desc;  Net Dr/Cr Amount: $amount<br>" ;
		}

	$sql = "SELECT a.id,source,description,chart_id,b.amount FROM ${pre}gl a, ${pre}acc_trans b " ;
	$sql.= "WHERE a.id=trans_id and (chart_id=0 or b.amount=0)" ;
	$result = $adodb->query($sql);
	While ($rs=$result->fetchRow()) {
		$id = $rs['id'] ;
		$source = $rs['source'] ;
		$desc = $rs['description'] ;
		$chart_id = $rs['chart_id'] ;
		$amount = sprintf("%01.2f",$rs['amount']) ;
		echo "Journal ID: $id;  Source: $source;  Description: $desc;  A/C id: $chart_id;  Entry Amount: $amount;<br>" ;
		}

	echo exapi_lang("<br>End of List<br>") ;

	$t->set_var('lang_confirm',$comment);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('yes_action',exapi_link("/$app/reportfilter.php"));
	$t->set_var('no_action',exapi_link("/$app/reportfilter.php"));
	$t->set_var('lang_yes',exapi_lang('Done'));
	$t->set_var('lang_no',exapi_lang('Done'));
	$t->pparse('out','report',True);
	exapi_footer() ;

?>
