<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// reportfilter.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-ledger' ;
	$tran = 'report' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$msg1 = exapi_lang('Generation of ledger report requires lengthy processing time.') ;
	$msg2.= exapi_lang('You should initiate report generation only during off-peak hours.') ;
	$ckapi[phrases] =array('lang_title'=>exapi_lang('Choose Report to Generate and to set Report Parameters :'),
				'lang_criteria'	=> exapi_lang("Report Parameters") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Report Generation") ,
				'lang_add'	=> exapi_lang("Done") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$result = $adodb->query("Select * from ${pre}defaults");
	$a1cap = $result->fields('attrib1cap');		$a1tbl = str_replace($pre,'',$result->fields('attrib1tbl'));
	$a2cap = $result->fields('attrib2cap');		$a2tbl = str_replace($pre,'',$result->fields('attrib2tbl'));
	$a3cap = $result->fields('attrib3cap');		$a3tbl = str_replace($pre,'',$result->fields('attrib3tbl'));
	$a1sdf = $result->fields('attrib1sdesc');	$a1cnv = $result->fields('attrib1cnval');
	$a2sdf = $result->fields('attrib2sdesc');	$a2cnv = $result->fields('attrib2cnval');
	$a3sdf = $result->fields('attrib3sdesc');	$a3cnv = $result->fields('attrib3cnval');
	$ac_sl = "<OPTION value='0'>all -- All Accounts (will fail under heavy load)</OPTION>" ;
	$ac_sl .= selectlist('chart','accno'," WHERE charttype='A' ",'','id','accno','substring(description,1,20)') ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$note1 = exapi_lang("If wrong action chosen, click [Report] to restart.") ;
	$note1a = exapi_lang("If all parameters chosen, press [Start Report Generation] one more time to start.") ;
	$nullopt = "<OPTION value=''></OPTION>" ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Which Report') ,
				type		=>	'select' ,
				selectlist	=>	'' ,
				varname		=>	'actnum' ,
				defval		=>	'' ,
				note		=>	"$note1<br>$note1a"			);

	$ckapi[filter][] = array(criteria	=>	$a1cap ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.selectlist($a1tbl,$a1sdf,'','','id',"substring($a1sdf,1,10)") ,
				varname		=>	'attrib1' ,
				defval		=>	'' ,
				note		=>exapi_lang("Choose to produce the report of which")." $a1cap") ;

	$ckapi[filter][] = array(criteria	=>	$a2cap ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.selectlist($a2tbl,$a2sdf,'','','id',"substring($a2sdf,1,10)") ,
				varname		=>	'attrib2' ,
				defval		=>	'' ,
				note		=>exapi_lang("Choose to produce the report of which")." $a2cap") ;

	$ckapi[filter][] = array(criteria	=>	$a3cap ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.selectlist($a3tbl,$a3sdf,'','','id',"substring($a3sdf,1,10)") ,
				varname		=>	'attrib3' ,
				defval		=>	'' ,
				note		=>exapi_lang("Choose to produce the report of which")." $a3cap") ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Which Account') ,
				type		=>	'select' ,
				selectlist	=>	$ac_sl ,
				varname		=>	'account' ,
				defval		=>	'' ,
				note		=>	exapi_lang('Select the target account')	);

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Report Status as of (Current Period)') ,
				type		=>	'input' ,
				varname		=>	'rdate_curr' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Date from (Current Period)') ,
				type		=>	'input' ,
				varname		=>	'datefrom_curr' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Date to (Current Period)') ,
				type		=>	'input' ,
				varname		=>	'dateto_curr' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Report Status as of (Comparison Period)') ,
				type		=>	'input' ,
				varname		=>	'rdate_comp' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Date from (Comparison Period)') ,
				type		=>	'input' ,
				varname		=>	'datefrom_comp' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Date to (Comparison Period)') ,
				type		=>	'input' ,
				varname		=>	'dateto_comp' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$trialbalance = exapi_lang('Trial Balance') ;
	$incomestatement = exapi_lang('Income Statement') ;
	$balancesheet = exapi_lang('Balance Sheet') ;
	$ledgerlisting = exapi_lang('Ledger Listing') ;
	$controlreport = exapi_lang('Ledger Audit Control Report') ;
	$anomalies = exapi_lang('List of Journals with Anomalies') ;
	$ckapi[filter][actlist] = array (	1=>"<OPTION value='1'>1 -- $trialbalance</OPTION>",
						2=>"<OPTION value='2'>2 -- $incomestatement</OPTION>",
						3=>"<OPTION value='3'>3 -- $balancesheet</OPTION>",
						4=>"<OPTION value='4'>4 -- $ledgerlisting</OPTION>",
						5=>"<OPTION value='5'>5 -- $controlreport</OPTION>",
						6=>"<OPTION value='6'>6 -- $anomalies</OPTION>" ) ;
	$ckapi[filter][actstring] = array("0",			/* first entry	*/
					"05",			/* report 1	*/
					"067910",		/* report 2	*/
					"058",			/* report 3	*/
					"067",			/* report 4	*/
					"05",			/* report 5	*/
					"0"			/* report 6	*/		) ;
	$actnum = ($_GET["actnum"]) ? $_GET["actnum"] : $_POST["actnum"] ;
	if ($actnum==1 or $actnum==3) {
		For ($i=1;$i<=3;$i++)	{
			$constantvar = "a${i}cnv" ;
			if ($$constantvar == "yes")	$ckapi[filter][actstring][$actnum] .= "$i" ;
			}
		}
	if ($actnum==2 or $actnum==4)
		For ($i=1;$i<=3;$i++)			$ckapi[filter][actstring][$actnum] .= "$i" ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_filter() ;
	exapi_footer() ;

?>

