<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.tax.inc.php 0.13.1 2005/06/15 C K Wu

    class tax {

//---- Tax Detail Validation Checks

    function tax_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err="";  $error = exapi_lang("Error") ;
	if ($dt[taxnumber]=="")				$err=exapi_lang("Tax Name/Number Missing");
	if ($dt[rate] and !is_numeric($dt[rate]))	$err=exapi_lang("Tax Rate must be numeric");
	if ($dt[rate]<0 or $dt[rate]>10)		$err=exapi_lang("Rate must be 0-10(assumed maximum)");
	if ($dt[taxnumber]<>$dt[oldtaxnumber]) {
		$result = $adodb->query("SELECT * FROM ${pre}tax where taxnumber='$dt[taxnumber]'");
		if ($result->RecordCount()>0)		$err=exapi_lang("Tax Name/# already exists") ;
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Tax Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$errmsg1 = exapi_lang("This tax is still listed as default") ;
	$vendorrec = exapi_lang("within vendor record") ;
	$customerrec = exapi_lang("within customer record") ;
	$itemrec = exapi_lang("within parts/service record") ;
	$id = $dt[id] ;
	$result = $adodb->query("SELECT * from ${pre}vendortax where tax_id='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $vendorrec id#".$result->fields('vendor_id') ;
	$result = $adodb->query("SELECT * from ${pre}customertax where tax_id='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $customerrec id#".$result->fields('customer_id') ;
	$result = $adodb->query("SELECT * from ${pre}itemtax where tax_id='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $itemrec id#".$result->fields('item_id') ;
	
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Tax Detail

    function tax_write() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',exapi_lang('Audit ID:')."  ");
	$t->set_var('lang_taxnumber',exapi_lang('Name/Number'));
	$t->set_var('lang_rate',exapi_lang('Rate'));
	$t->set_var('lang_account',exapi_lang('Associated Ledger A/C'));
	$t->set_var('lang_notes',exapi_lang('Notes'));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('taxnumber',$dt[taxnumber]);
	$t->set_var('rate',$dt[rate]);
	$t->set_var('chart_id',$dt[chart_id]);
$t->set_var('acc_selectlist',selectlist('chart','accno',"WHERE link like '%AP_tax%'",$dt[chart_id],'id','accno','substring(description,1,20)'));
	$t->set_var('notes',$dt[notes]);
	$t->parse('out','report',True);
	}

    }

?>
