<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// pontfilter.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-po' ;
	$tran = 'pont' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'po' ,
				'tran'		=> $tran			) ;
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("Search among posted purchase orders [no Tax] :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Purchase Order [no Tax]") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$warning = exapi_lang("Make sure you have completed all Invoice/PO Matching before checking on unbilled POs") ;
	$ckapi[filter][] = array(criteria	=>	exapi_lang('Vendor') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.selectlist('vendor','name','','','id','name','id') ,
				varname		=>	'vendor' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Select the appropriate vendor') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Currency') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.selectlist('currency','isocode','','','isocode','isocode','description') ,
				varname		=>	'isocode' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Select the appropriate currency') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Purchase Order Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Must be a valid date; format: YYYY-MM-DD') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Purchase Order Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Must be a valid date; format: YYYY-MM-DD') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Purchase Order Number') ,
				type		=>	'input' ,
				varname		=>	'ponumber' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for target key word/number in the purchase order # field') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Unbilled PO Only') ,
				type		=>	'checkbox' ,
				varname		=>	'opentran' ,
				defval		=>	"" ,
				note		=>	exapi_lang("Click box if only non fully billed POs are to be retrieved")."<br><b>".$warning."</b>" );

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
