<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// pontlist.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-po' ;
	$tran = 'pont' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'po' ,
				'tran'		=> $tran ,
				'table'		=> "${pre}po" 				);
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("List of Purchase Orders [no Tax]") ,
				'lang_add'	=> exapi_lang("Add New Purchase Order [no Tax]") ,	);
	$ckapi[columns] = array('transdate'	=> exapi_lang('PO Date') ,
				'duedate'	=> exapi_lang('Due Date') ,
				'name'		=> exapi_lang('Vendor') ,
				'ponumber'	=> exapi_lang('PO#') ,
				'isocode'	=> exapi_lang('Currency') ,
				'amount'	=> exapi_lang('Amount') ,
				'id'		=> exapi_lang('Audit ID') 			);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'billhist'	=> "/$app/pobillhist.php" ,
				'opo'		=> "/$app/${tran}off.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'edit_addtax'	=> "/$app/powtedit.php" , /* dummy */
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> exapi_lang("View") ,
				'lang_billhist'	=> exapi_lang('Billing History') ,
				'lang_opo'	=> exapi_lang('Official PO') ,
				'lang_bulk'	=> exapi_lang("Bulk Despatch") ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_edit_addtax'=>exapi_lang('Edit (Add Tax)') ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")				) ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_list() ;

	$temp1 = $ckapi[params_sql][temp1];
	$temp2 = $ckapi[params_sql][temp2];
	if ($temp1<>"")	$adodb->query("DROP TABLE $temp1");
	if ($temp2<>"")	$adodb->query("DROP TABLE $temp2");
	exapi_footer() ;

?>
