<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// cashballist.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-pos-m' ;
	$tran = 'cashbal' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	
	$filter = urldecode(stripslashes($filter)) ;
	$proc = newobj('ck-api','process') ;
	$where = $proc->decode_where($filter) ;
	$filter = urlencode($filter) ;

	$t = ckapi_tpl($app);
	$t->set_file('report',"${tran}list.tpl") ;
	$t->set_block('report','cashbal','cashbal_section');
	$t->set_block('report','cashanal','cashanal_section');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('lang_title',exapi_lang('List of Shift End Cash Balances'));
	$t->set_var('lang_sorthead',exapi_lang('[click column heading to re-sort table]'));
	$t->set_var('lang_cashbox',exapi_lang('Cash Box Name'));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->set_var('done_action',exapi_link("/$app/shiftbalfilter.php"));

	$script = "/$app/${tran}list.php" ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var('sort_transdate',$proc->sortlink(exapi_lang('Cash Sale Date'),$script,'transdate',$sort,$getstr));
	$t->set_var('sort_shift',$proc->sortlink(exapi_lang('Shift'),$script,'shift',$sort,$getstr));
	$t->set_var('sort_name',$proc->sortlink(exapi_lang('Quasi-Cash Name'),$script,'name',$sort,$getstr));
	$t->set_var('sort_itemtype',$proc->sortlink(exapi_lang('Item Type'),$script,'itemtype',$sort,$getstr));
	$t->set_var('sort_amount',$proc->sortlink(exapi_lang('Amount'),$script,'amount',$sort,$getstr));
	$t->set_var('lang_view',exapi_lang('View Detail'));
	$t->set_var('lang_copy',exapi_lang('Copy/Modify'));
	$t->set_var('lang_delete',exapi_lang('Delete'));

	$rpos = strrpos($where,"'") ;
	$lpos = strrpos(substr($where,1,$rpos-1),"'") ;
	$cboxid = substr($where,$lpos) ;
	$result = $adodb->query("SELECT name FROM ${pre}cashbox WHERE id=$cboxid");
	$t->set_var('cashbox',$result->fields('name')) ;

// ---------------------- Write Quasi-Cash Balances Section -------------------------

if (!$order) {$order = "name" ; }
if (!$sort)  {$sort = "ASC" ; }
$blankdate = "transdate = ''" ;
if (substr_count($where,$blankdate)>0)	$where = str_replace($blankdate,"1<>1",$where) ;
$sql =	"SELECT itemid,transdate,b.shift as shift,c.name as name,itemtype,sum(qty*a.value) as amount " ;
$sql.=	"FROM ${pre}positem a, ${pre}pos b, ${pre}qcash c " ;
$sql.=	"WHERE $where and itemtype='q' and a.trans_id=b.id and a.itemid=c.id  " ;
$sql.=	"GROUP BY itemid,transdate,b.shift,c.name,itemtype ORDER BY ".$order." ".$sort ;
$result = $adodb->query($sql);

if ($result->RecordCount()==0) {
	$t->set_var(array(	'transdate'	=> exapi_lang("No Matching Item Found"),
				'shift'		=> "",
				'name'		=> "",
				'itemtype'	=> "",
				'amount'	=> "",
				'view'		=> "" ));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('cashbal_section','cashbal',True);
	}
While ($rs=$result->fetchRow()) {
	$id = $rs['itemid'] ;
	$name = $rs['name'] ;
	$amount = $rs['amount'] ;
	$t->set_var(array(	'transdate'	=> $rs['transdate'],
				'shift'		=> $rs['shift'],
				'name'		=> $name ,
				'itemtype'	=> $rs['itemtype'],
				'amount'	=> $amount ,
				'view'	=> exapi_link("/$app/${tran}view.php","id=$id&filter=$filter")  ));
	if ($name==exapi_lang("Cash"))	$cashamount = number_format($amount,2,".",'') ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('cashbal_section','cashbal',true);
	}

$sql =	"SELECT itemid,transdate,shift,sum(qty*value) as amount FROM ${pre}positem a, ${pre}pos b " ;
$sql.=	"WHERE $where and itemtype='c' and a.trans_id=b.id GROUP BY itemid,transdate,shift" ;
$result = $adodb->query($sql) ;
$id = $result->fields('itemid') ;
$changeamount = number_format($result->fields('amount'),2,".",'') ;
$t->set_var(array(	'transdate'	=> $result->fields('transdate'),
			'shift'		=> $result->fields('shift'),
			'name'		=> exapi_lang('Cash Change') ,
			'itemtype'	=> "c",
			'amount'	=> $changeamount,
			'view'		=> exapi_link("/$app/${tran}view.php","id=$id&filter=$filter")  ));
$t->set_var('tr_color',$ckapi[hostsys][th_bg]) ;
$t->parse('cashbal_section','cashbal',true);
$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$t->parse('cashbal','cashbal_section',true);

// -------------------------------- Write Cash Balance Analysis Section -----------------------------------------

$t->set_var('lang_analysis',exapi_lang('Cash Balance Analysis')) ;
$t->set_var('lang_note1',exapi_lang('[Shift]:  1-Morning, 2-Afternoon, 3-Overnight'));
$t->set_var('lang_note2',exapi_lang('[TranType]: s - start-of-shift, +/- => Cash in/out, e - end-of-shift'));
$t->set_var('lang_transdate',exapi_lang('Cash Sale Date')) ;
$t->set_var('lang_shift',exapi_lang('Shift')) ;
$t->set_var('lang_name',exapi_lang('Item Detail')) ;
$t->set_var('lang_trantype',exapi_lang('Transaction Type')) ;
$t->set_var('lang_amount',exapi_lang('Amount')) ;

$netbal = 0 ;
$result = $adodb->query("SELECT * from ${pre}cbtran WHERE $where and trantype='s'") ;
$amount = number_format($result->fields('amount'),2,".",'') ; $netbal+= $amount ;
$t->set_var(array(	'transdate'	=> $result->fields('transdate'),
			'shift'		=> $result->fields('shift'),
			'name'		=> exapi_lang('Start-of-shift Cash-in'),
			'trantype'	=> $result->fields('trantype'),
			'amount'	=> $amount			)) ;
$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$t->parse('cashanal_section','cashanal',true);
$netbal+= number_format($cashamount,2,".",'') ;
$t->set_var(array(	'transdate'	=> $result->fields('transdate'),
			'shift'		=> $result->fields('shift'),
			'name'		=> exapi_lang('Total Cash tendered by Customer'),
			'trantype'	=> '',
			'amount'	=> $cashamount			)) ;
$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$t->parse('cashanal_section','cashanal',true);

$netbal+= number_format($changeamount,2,".",'') ;
$t->set_var(array(	'transdate'	=> $result->fields('transdate'),
			'shift'		=> $result->fields('shift'),
			'name'		=> exapi_lang('Total Cash Change returned to Customer'),
			'trantype'	=> '',
			'amount'	=> $changeamount		)) ;
$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$t->parse('cashanal_section','cashanal',true);

$result = $adodb->query("SELECT * from ${pre}cbtran WHERE $where and trantype<>'s' and trantype<>'e'");
While ($rs=$result->fetchRow()) {
	$id = $rs['id'] ;
	$trantype = $rs['trantype'] ;
	$amount = number_format($rs['amount'],2,".",''); $netbal+= $amount ;
	if ($trantype=='+')	$name = exapi_lang("Additional Cash transferred in during Shift") ;
	if ($trantype=='-')	$name = exapi_lang("Additional Cash transferred out during Shift") ;
	$t->set_var(array(	'transdate'	=> $rs['transdate'],
				'shift'		=> $rs['shift'],
				'name'		=> $name,
				'trantype'	=> $trantype,
				'amount'	=> $amount	));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('cashanal_section','cashanal',true);
	}

$result = $adodb->query("SELECT * from ${pre}cbtran WHERE $where and trantype='e'") ;
$amount = number_format($result->fields('amount'),2,".",''); $netbal+= $amount ;
$t->set_var(array(	'transdate'	=> $result->fields('transdate'),
			'shift'		=> $result->fields('shift'),
			'name'		=> exapi_lang('End-of-shift Cash-out'),
			'trantype'	=> $result->fields('trantype'),
			'amount'	=> $amount			)) ;
$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$t->parse('cashanal_section','cashanal',true);

$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$t->parse('cashanal','cashanal_section',true);

$t->set_var('lang_netbal',exapi_lang('Cash Balance that should be available inside CashBox or Cash ShortFall(+ve)/Surplus(-ve) post End-of-Shift operation')) ;
$t->set_var('netbal',$netbal) ;

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','report',True);
	exapi_footer() ;

?>
