<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// cashboxlist.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-pos-m' ;
	$tran = 'cashbox' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}cashbox" 		);
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("List of Cash Boxes") ,
				'lang_add'	=> exapi_lang("Add New Cash Box") ,
			'lang_note1'	=> exapi_lang('[Shift]:  1 - Morning, 2 - Afternoon, 3 - Overnight')	);
	$ckapi[columns] = array('name'		=> exapi_lang('Cashbox Name') ,
				'cashier'	=> exapi_lang('Cashier for Current Shift') ,
				'shift'		=> exapi_lang('Current Shift') ,
				'location'	=> exapi_lang('Location') ,
				'maxcash'	=> exapi_lang('Cash Full Warning Level') ,
				'id'		=> exapi_lang('Audit ID') 		);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> exapi_lang("View") ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")				) ;

	$proc = newobj('ck-api','process') ;
	$proc->process_list() ;
	exapi_footer() ;

?>
