<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.addon.inc.php 0.13.1 2005/06/15 C K Wu

    class addon {

//---- AddOn Read

    function addon_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$result = $adodb->query("select * from ${pre}addon where id='$id'");
	$dt = $result->fetchRow() ;
	$sql = "SELECT tax_id from ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=1 and a.tax_id=b.id and b.taxgroup='cs'" ;
	$result = $adodb->query($sql);
	$dt[cstax1] = $result->fields('tax_id') ;
	$sql = "SELECT tax_id from ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=2 and a.tax_id=b.id and b.taxgroup='cs'" ;
	$result = $adodb->query($sql);
	$dt[cstax2] = $result->fields('tax_id') ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}


//---- Addon Detail Validation Checks

    function addon_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	if (!$dt[name] or $dt[name]=="")		$err=exapi_lang('AddOn Charge/Reduction Name missing');
		else	{
			$result = $adodb->query("SELECT * from ${pre}addon WHERE name='$dt[name]'") ;
			if ($result->RecordCount()<>0 and $dt[name]<>$dt[oldname])
				$err=exapi_lang('AddOn Charge/Reduction name already in use');
			}
	if ($dt[factor] and !is_numeric($dt[factor]))	$err=exapi_lang('Factor must be numeric');
	if ($dt[factor]<0 and !$dt[minsale])		$err=exapi_lang('Min Sale missing');
	if ($dt[factor]>0 and !$dt[maxsale])		$err=exapi_lang('Max Sale missing');
	if ($dt[mincount]>$dt[maxcount])		$err=exapi_lang('Min count must be <= Max count');
	if ($dt[minsale]>$dt[maxsale])			$err=exapi_lang('Min Sale must be <= Max value');
	if ($dt[mincount] and !is_numeric($dt[mincount]))	$err=exapi_lang("Min count must be numeric");
	if ($dt[maxcount] and !is_numeric($dt[maxcount]))	$err=exapi_lang("Max count must be numeric");
	if ($dt[minsale] and !is_numeric($dt[minsale]))	$err=exapi_lang("Min value must be numeric");
	if ($dt[maxsale] and !is_numeric($dt[maxsale]))	$err=exapi_lang("Max Sale must be numeric");
	if (input2date($dt[start])=="")			$err=exapi_lang('Invalid [Valid from] Date');
	if (input2date($dt[endd])=="")			$err=exapi_lang('Invalid [Valid to] Date');
	if (strtotime($dt[start])>strtotime($dt[endd]))	$err=exapi_lang('[Valid from] LaterThan [Valid to]');
	if (strtotime($dt[start])=="-1")		$err=exapi_lang("[Valid from] beyond valid date range");
	if (strtotime($dt[endd])=="-1")			$err=exapi_lang("[Valid to] beyond valid date range");
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Addon Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$cashsale = exapi_lang('cash sale') ;
	$errmsg1 = exapi_lang("This addon is in use within an existing") ;
	$id = $dt[id] ;
	$result = $adodb->query("SELECT * from ${pre}positem WHERE itemid='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $cashsale id#".$result->fields('id') ;

	if ($err<>"")			$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write AddOn Charge/Discount Detail

    function addon_write() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',exapi_lang('Audit ID:')."  ");
	$t->set_var('lang_splan_id',exapi_lang('Sales Promotion ID:')."  ");
	$t->set_var('lang_name',exapi_lang('Name'));
	$t->set_var('lang_factor',exapi_lang('Factor (based on Cash Sale Total)'));
	$t->set_var('lang_mincount',exapi_lang('Min count per Tran'));
	$t->set_var('lang_maxcount',exapi_lang('Max count per Tran'));
	$t->set_var('lang_minsale',exapi_lang('Min ($)sale per Tran'));
	$t->set_var('lang_maxsale',exapi_lang('Max ($)sale per Tran'));
	$t->set_var('lang_start',exapi_lang('Valid from'));
	$t->set_var('lang_endd',exapi_lang('Valid to'));
	$t->set_var('lang_notes',exapi_lang('Notes'));
	$t->set_var('lang_basis',exapi_lang('Calculation Basis (g/n)'));
	$t->set_var('lang_linkageaccount',exapi_lang("Link to Ledger Accounts and Tax Detail"));
	$t->set_var('lang_income_accno',exapi_lang("Income / Tax"));
	$t->set_var('lang_expense_accno',exapi_lang("Expense"));
	$t->set_var('lang_cstax1',exapi_lang("Primary Tax for the Addon"));
	$t->set_var('lang_cstax2',exapi_lang("Secondary Tax for the Addon"));
	$t->set_var('lang_reserved',exapi_lang("Reserved Space"));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('splan_id',$dt[splan_id]);
	$t->set_var('name',$dt[name]);
	$t->set_var('factor',$dt[factor]);
	$t->set_var('mincount',$dt[mincount]);
	$t->set_var('maxcount',$dt[maxcount]);
	$t->set_var('minsale',$dt[minsale]);
	$t->set_var('maxsale',$dt[maxsale]);
	$t->set_var('start',$dt[start]);
	$t->set_var('endd',$dt[endd]);
	$t->set_var('notes',$dt[notes]);
	$basis = $dt[basis] ;
	$basis_sl ="<OPTION value='g'>".exapi_lang('g - Gross Cash Sale')."</OPTION>" ;
	$basis_sl.="<OPTION value='n'>".exapi_lang('n - Net Cash Sale')."</OPTION>";
	$basis_sl = str_replace("'$basis'","'$basis'"." selected",$basis_sl) ;
	$t->set_var('basis_option_block',$basis_sl );
	$inc_accno = $dt[incacc_id] ;
	$t->set_var('inc_accno',$inc_accno);
	$t->set_var('inc_acc_option_block', selectlist('chart','accno',"WHERE link like '%SV_income%' or link like '%CS_tax%'",$inc_accno,'id','accno','description'));
	$exp_accno = $dt[expacc_id] ;
	$t->set_var('exp_accno',$exp_accno);
	$t->set_var('exp_acc_option_block', selectlist('chart','accno',"WHERE link like '%SV_expense%'",$exp_accno,'id','accno','description'));
	$notax = "<OPTION value=''>".exapi_lang('No Tax')."</OPTION>" ;
	$rate = ($ckapi[hostsys][dbtype]=="mysql") ? "concat(rate*100,'%')" : "(rate*100||'%')" ;
	$t->set_var('cstax1_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='cs'",$dt[cstax1],'id',$rate,'taxnumber','id'));
	$t->set_var('cstax2_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='cs'",$dt[cstax2],'id',$rate,'taxnumber','id'));

	$t->parse('out','report',True);
	}

//---- AddOn Post Initialisation

    function addon_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$dt[splan_id] = ($dt[splan_id]=="") ? 0 : $dt[splan_id] ;
	}

//---- AddOn Post - PreCommit Routine

    function addon_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = $ckapi[params_post][dt] ;
	$table = "${pre}itemtax" ;

	if ($op<>'new')		$adodb->query("DELETE FROM $table WHERE item_id=$id") ;
	if ($op<>'delete') {
		$sql="INSERT INTO $table (item_id,tax_id,taxtype) " ;
		if ($dt[cstax1]<>"")	$adodb->query("$sql VALUES ('$id','$dt[cstax1]','1')");
		if ($dt[cstax2]<>"")	$adodb->query("$sql VALUES ('$id','$dt[cstax2]','2')");
		}
	}

    }

?>
