<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.sprice.inc.php 0.13.1 2005/06/15 C K Wu

    class sprice {

//---- Special Price Detail Validation Checks

    function sprice_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$table = $ckapi[params][table] ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error") ;
	if (!$dt[name] or $dt[name]=="")		$err=exapi_lang("Special Price Name missing");
		else	{
			$result = $adodb->query("SELECT * from $table WHERE name='$dt[name]'") ;
			if ($result->RecordCount()<>0 and $dt[name]<>$dt[oldname])
				$err=exapi_lang('Special Price name already in use');
			}
	if (!$dt[itemid] or $dt[itemid]=="")		$err=exapi_lang("ID of normally priced item missing");
	if (!$dt[price] or $dt[price]=="")		$err=exapi_lang("Price missing");
	if ($dt[price] and !is_numeric($dt[price]))	$err=exapi_lang("Price must be numeric");
	if (input2date($dt[start])=="")			$err=exapi_lang("Invalid [Valid from] Date");
	if (input2date($dt[endd])=="")			$err=exapi_lang("Invalid [Valid to] Date");
	if (strtotime($dt[start])>strtotime($dt[endd]))	$err=exapi_lang("[Valid from] LaterThan [Valid to]");
	if (strtotime($dt[start])=="-1")		$err=exapi_lang("[Valid from] beyond valid date range");
	if (strtotime($dt[endd])=="-1")			$err=exapi_lang("[Valid to] beyond valid date range");

	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Special Price Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$cashsale = exapi_lang('cash sale') ;
	$errmsg1 = exapi_lang("This special price is in use within an existing") ;
	$result = $adodb->query("SELECT * from ${pre}positem WHERE itemid='$dt[id]'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $cashsale id#".$result->fields('trans_id') ;

	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Special Price Detail

    function sprice_write() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',exapi_lang('Audit ID:')."  ");
	$t->set_var('lang_splan_id',exapi_lang('Sales Promotion ID:')."  ");
	$t->set_var('lang_name',exapi_lang('Name'));
	$t->set_var('lang_price',exapi_lang('Special Price'));
	$t->set_var('lang_itemid',exapi_lang('ID of normally priced item'));
	$t->set_var('lang_start',exapi_lang('Valid from'));
	$t->set_var('lang_endd',exapi_lang('Valid to'));
	$t->set_var('lang_notes',exapi_lang('Notes'));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('splan_id',0);
	$t->set_var('name',$dt[name]);
	$t->set_var('price',$dt[price]);
	$t->set_var('itemid',$dt[itemid]);
	$t->set_var('start',$dt[start]);
	$t->set_var('endd',$dt[endd]);
	$itemid = $dt[itemid] ;
	$t->set_var('itemid_sl',item_selectlist("","$itemid"));
	$t->set_var('notes',$dt[notes]);
	$t->parse('out','report',True);
	}

    }

?>
