<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.quote.inc.php 0.13.1 2005/06/15 C K Wu

    class quote {

//---- Quotation List SQL Formation

    function quote_list_sql() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	if ($ckapi[params][tran]=="quotent")	$where = "amount=netamount $where" ;	else	$where = "amount<>netamount $where";
	$last10 = substr($where,strlen($where)-10,10) ;
	$fields = "transdate,duedate,quotenumber,name,isocode,amount,a.id" ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$sql1 =	"SELECT $fields FROM ${pre}quote a, ${pre}customer b WHERE $where AND a.customer=b.id " ;
		$sql2 =	"SELECT $fields FROM ${pre}quote a, ${pre}customer b, ${pre}sqmatch c " ;
		$sql2.=	"WHERE $where AND customer=b.id AND a.id=c.quoteid " ;
		$sql2.=	"GROUP BY $fields HAVING sum(a_amount)>=amount " ;
		if ($ckapi[hostsys][dbtype]=="mysql")	{
			$user = $ckapi[hostsys][username] ;
			$ckapi[params_sql][temp1] = $temp1 = "${pre}quotentl1".$user.time() ;
			$ckapi[params_sql][temp2] = $temp2 = "${pre}quotentl2".$user.time() ;
			$adodb->query("CREATE TABLE $temp1 AS $sql1");
			$adodb->query("CREATE TABLE $temp2 AS $sql2");
			$sql = "SELECT $temp1.* FROM $temp1 LEFT JOIN $temp2 " ;
			$sql.= "ON $temp1.id=$temp2.id WHERE $temp2.id IS NULL ORDER BY $order $sort" ;
			}
			else	$sql="$sql1 EXCEPT $sql2 ORDER BY $order $sort" ;
		}
	  else	$sql =	"SELECT $fields FROM ${pre}quote a, ${pre}customer b WHERE $where AND a.customer=b.id ORDER BY $order $sort";
	return $sql ;
	}

//---- Quotation List Link Adjustement

    function quote_list_adjust() {
	global $ckapi ;

	$app = $ckapi[params][app] ;
	$tran = $ckapi[params][tran] ;
	foreach ($ckapi[params_list] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;
	$return = "/$app/${tran}list.php" ;
	$getstr = "id=$dt[id]&filter=$filter&return=$return" ;
	$t->set_var('edit_addtax',exapi_link("/$app/quotewtedit.php",$getstr)) ;
	$getstr = "order=$order&sort=$sort&id=$dt[id]&filter=$filter" ;
	$t->set_var('bulk_action',exapi_link("/$app/${tran}bulk.php",$getstr)) ;
	$disabled = ($dt[id]=="") ? "disabled" : "" ;
	$t->set_var('disabled',$disabled) ;
	}

//---- Quote Data Read

    function quote_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$script = $ckapi[params_post][script] ;

	$result = $adodb->query("SELECT * FROM $table WHERE id='$id'");
	$dt = $result->fetchRow() ;
	$dt[taxstatus] = ($tran=="quotent") ? "e" : $result->fields('taxincluded') ;
	$dt[oldisocode] = $dt[isocode] ;
	$result = $adodb->query("SELECT * FROM ${pre}oitem WHERE trans_id='$id' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['itemid'.$i]		=	$rs['itemid'] ;
		$dt['itemtype'.$i]		=	$rs['itemtype'] ;
		$dt['description'.$i]		=	$rs['description'] ;
		$dt['qty'.$i]			=	$rs['qty'] ;
		$dt['unit'.$i]			=	$rs['unit'] ;
		$dt['price'.$i]			=	$rs['price'] ;
		$dt['cost'.$i]			=	$rs['cost'] ;
		$dt['discount'.$i]		=	$rs['discount'] ;
		$dt['tax1'.$i]			=	$rs['tax1'] ;
		$dt['tax2'.$i]			=	$rs['tax2'] ;
		}
	return $dt ;
	}

//---- Quote Add Initialisation

    function quote_add_init() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$dt['transdate'] = date("Y-m-d") ;
	$result = $adodb->query("SELECT nativecurr FROM ${pre}defaults");
	$dt['isocode'] = $dt['oldisocode'] = $result->fields('nativecurr') ;
	$result = $adodb->query("SELECT exrate FROM ${pre}currency WHERE isocode='$dt[isocode]'");
	$dt['exrate'] = $result->fields('exrate') ;
	}

//---- Quote Detail Validation Checks

    function quote_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error") ;
	$row = exapi_lang("Row") ;
	if ($dt[quotenumber]=="")		$err=exapi_lang('Quotaltion Number Missing');
	if (input2date($dt[transdate])=="")	$err=exapi_lang('Invalid Quotation Date');
	if (input2date($dt[duedate])=="")	$err=exapi_lang('Invalid Due Date');
	if ($dt[exrate]<=0)			$err=exapi_lang("Invalid Exchange Rate") ;
	$result = $adodb->query("SELECT nativecurr FROM ${pre}defaults");
	if ($dt[isocode]==$result->fields('nativecurr') and $dt[exrate]<>1)
					$err=exapi_lang("Exchange rate for ledger currency must = 1") ;
	$result = $adodb->query("SELECT * FROM ${pre}currency WHERE isocode='$dt[isocode]'");
	$nativeexrate = $result->fields('exrate') ;
	if ($nativeexrate>0) {
		$ratio = $dt[exrate]/$nativeexrate ;
		if (0.8>$ratio or $ratio>1.2)	$err=exapi_lang("Exchange rate deviates too much from default") ;
		}
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		if ($dt['itemid'.$i]=='')	$err=$rowi.exapi_lang('Item Code Missing');
		if ($dt['qty'.$i] and !is_numeric($dt['qty'.$i]))
					$err=$rowi.exapi_lang("Invalid Qty, must be numeric");
		if ($dt['discount'.$i] and !is_numeric($dt['discount'.$i]) and $dt[taxstatus]<>"t")
					$err=$rowi.exapi_lang("Invalid Discount, must be numeric");
		if ($dt['price'.$i] and !is_numeric($dt['price'.$i]))
					$err=$rowi.exapi_lang("Invalid Unit Price, must be numeric");
		if ($dt['tax1'.$i] and !is_numeric($dt['tax1'.$i]))
					$err=$rowi.exapi_lang("Invalid Tax1, must be numeric");
		if ($dt['tax2'.$i] and !is_numeric($dt['tax2'.$i]))
					$err=$rowi.exapi_lang("Invalid Tax2, must be numeric");
		if (($dt[taxstatus]=="f" or $dt[taxstatus]=="t") and $dt['tax1_pref'.$i]=='')
					$err=$rowi.exapi_lang("Blank Choice on Primary Tax Rate");
		if (($dt[taxstatus]=="f" or $dt[taxstatus]=="t") and $dt['tax2_pref'.$i]=='')
					$err=$rowi.exapi_lang("Blank Choice on Secondary Tax Rate");
		}
	if ($dt[isocode]<>$dt[oldisocode]) {
		$warn1 = exapi_lang('Currency changed') ;
		$warn2 = exapi_lang('Default exchange rate loaded') ;
		$warn3 = exapi_lang('Ensure pre-existing (discount,price,cost,tax) are correct') ;
		$warn4 = exapi_lang('Click [Post Quotation] to re-activate quotation posting') ;
		$err = "$warn1;  $warn2;  $warn3;  $warn4" ;
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write Quotation Header

    function quote_header_write() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$script = &$ckapi[params_post][script] ;
	$t = &$ckapi[objects][template] ;

	$result = $adodb->query("SELECT nativecurr FROM ${pre}defaults");
	$loc_for = ($result->fields('nativecurr')==$dt[isocode]) ? exapi_lang('Local') : exapi_lang('*** Foreign ***') ;
	if ($dt[isocode]<>$dt[oldisocode]) {
		$result = $adodb->query("SELECT exrate FROM ${pre}currency WHERE isocode='$dt[isocode]'");
		$dt[exrate] = $result->fields('exrate') ;
		$msg1 = exapi_lang('Currency changed') ;
		$msg2 = exapi_lang('Default exchange rate loaded') ;
		$msg3 = exapi_lang('Ensure pre-existing (discount,price,cost,tax) are correct') ;
		$t->set_var('message',"$msg1;  $msg2;  $msg3");
		}
	$taxstatus = $dt[taxstatus] ;
	$t->set_var('lang_quotenumber',exapi_lang('Quotation#'));
	$t->set_var('lang_id',exapi_lang('Audit Id:')." ");
	$t->set_var('lang_curr_quote',exapi_lang('Currency Quotation'));
	$t->set_var('lang_loc_for',$loc_for);
	$t->set_var('lang_so_id',exapi_lang('Sales Order Id:')." ");
	$t->set_var('lang_transdate',exapi_lang('Quotation Date'));
	$t->set_var('lang_duedate',exapi_lang('Valid Until'));
	$t->set_var('lang_shipfrom',exapi_lang('Ship From'));
	$t->set_var('lang_notes',exapi_lang('Notes'));
	$t->set_var('lang_customer',exapi_lang('Customer'));
	$t->set_var('lang_taxstatus',exapi_lang('Unit Price Tax Status'));
	$t->set_var('lang_isocode',exapi_lang('Currency'));
	$t->set_var('lang_exrate',exapi_lang('Exchange Rate'));
	$t->set_var('lang_totalamt',exapi_lang('Total Quotation Amount'));
	$t->set_var('quotenumber',$dt[quotenumber]) ;
	$t->set_var('shipfrom',$dt[shipfrom]) ;
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('duedate',$dt[duedate]) ;
	$t->set_var('notes',$dt[notes]);

	$customer = $dt[customer] ;
	$t->set_var('customer',$customer) ;
	$t->set_var('customer_selectlist',selectlist('customer','name','',$customer,'id','name','id')) ;
	if ($tran=="quotent")	$tax_sl = "<OPTION value='e' selected>".exapi_lang("Tax Exempted")."</OPTION>" ;
	    else {
		$tax_sl = "<OPTION value='t'>".exapi_lang("Tax Included")."</OPTION>" ;
		$tax_sl.= "<OPTION value='f'>".exapi_lang("Tax Not Included")."</OPTION>" ;
		$tax_sl.= "<OPTION value='e'>".exapi_lang("Tax Exempted")."</OPTION>" ;
		$tax_sl = str_replace("'$taxstatus'","'$taxstatus' selected",$tax_sl) ;
		}
	$t->set_var('tax_selectlist',$tax_sl) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('so_id',$dt[so_id]) ;
	$t->set_var('isocode_selectlist',selectlist('currency','isocode','',$dt[isocode],'isocode','isocode','description')) ;
	$t->set_var('exrate',$dt[exrate]) ;

	$msg2 = exapi_lang("UC - Unit Cost, BTUP - Before Tax Unit Price, my std rate - my standard rate as a vendor.");
	$msg4 = exapi_lang("Non-numeric Unit Price and Tax will be converted to zero.");
	$msg5 = exapi_lang("If assembly/package is not to be exploded, choose it from the normal Product/Parts or Services sections of the item list.") ;
	$msg6 = exapi_lang("If Unit Price includes tax, discount is ignored.") ;
	$msg7 = exapi_lang("Posted (Tax Exempted) invoice will appear in the Invoice [no Tax] list.");
	$msg8 = exapi_lang("Manual tax input is allowed.");
	$msg9 = exapi_lang("However, inaccurate tax may be construed as an attempt to evade tax.");
	$t->set_var('message',"$msg2  <b>$msg4</b><br>$msg5<br>$msg6  $msg7<br><b>$msg8  $msg9</b>");

	$t->parse('out','report',True);
	}

//---- Reformat Quotation Array

    function quote_transform() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = exapi_lang('Row')." " ;
	$temp[id] = $dt[id] ;
	$temp[control] = $dt[control] ;
	$temp[customer] = $dt[customer] ;
	$temp[transdate] = $dt[transdate] ;
	$temp[duedate] = $dt[duedate] ;
	$temp[quotenumber] = $dt[quotenumber] ;
	$temp[ordnumber] = $dt[ordnumber] ;
	$temp[taxstatus] = $dt[taxstatus] ;
	$temp[shipfrom] = $dt[shipfrom] ;
	$temp[notes] = $dt[notes] ;
	$temp[isocode] = $dt[isocode] ;
	$temp[oldisocode] = $dt[oldisocode] ;
	$temp[exrate] = $dt[exrate] ;

	if (isset($delete)) {$delrowno = intval(str_replace($row_,"",$delete)); }
	$j = 1 ;
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		$itemid = $dt['itemid'.$i] ;
		if ($i==$delrowno) continue;
		if ($itemid<0)	{
			$itemid = -$itemid ;
			$qty = $dt['qty'.$i]==0 ? 1 : $dt['qty'.$i] ;
			$result = $adodb->query("SELECT * FROM ${pre}assembly WHERE assembly_id='$itemid'");
			While ($rs=$result->fetchRow()) {
				$temp['itemid'.$j] = $rs['item_id'] ;
				$temp['qty'.$j] = $rs['qty'] * $qty ;
				$j++ ;
				}
			continue ;
			}
		$temp['itemid'.$j]		=	$dt['itemid'.$i] ;
		$temp['itemtype'.$j]		=	$dt['itemtype'.$i] ;
		$temp['description'.$j]		=	$dt['description'.$i] ;
		$temp['qty'.$j]			=	$dt['qty'.$i] ;
		$temp['unit'.$j]		=	$dt['unit'.$i] ;
		$temp['price'.$j]		=	$dt['price'.$i] ;
		$temp['discount'.$j]		=	$dt['discount'.$i] ;
		$temp['tax1_pref'.$j]		=	$dt['tax1_pref'.$i] ;
		$temp['tax2_pref'.$j]		=	$dt['tax2_pref'.$i] ;
		$temp['tax1'.$j]		=	$dt['tax1'.$i] ;
		$temp['tax2'.$j]		=	$dt['tax2'.$i] ;
		$j++ ;
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=True ;
	if ($newrow)					$temp['itemid'.$j] = "" ;
	$dt = $temp ;
	unset($temp) ;
	}

//---- Write Quotation Detail

    function quote_detail_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$firstime = $ckapi[params_post][firstime] ;
	$op = $ckapi[params_post][op] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = exapi_lang('Row')." " ;
	$taxstatus = $dt[taxstatus] ;
	$tax_warning = exapi_lang("***** Choice Pending") ;
	if ($op=="view" or $op=="delete")	$posted = True ;
	if ($taxstatus<>'e') {
		$tax_pref_slist = "<OPTION value=''></OPTION>" ;
		$tax_pref_slist.= "<OPTION value='i'>".exapi_lang("apply item tax rate")."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='c'>".exapi_lang("apply customer rate")."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='s'>".exapi_lang("apply my std rate")."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='z'>".exapi_lang("tax rate = zero")."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='m'>".exapi_lang("manual tax input")."</OPTION>" ;
		$customer = ($dt[customer]=="") ? 0 : $dt[customer] ;
		$sql = "SELECT customer_id,rate from ${pre}customertax a, ${pre}tax b " ;
		$sql.= "WHERE customer_id='$customer' and a.tax_id=b.id and taxtype='1'" ;
		$result = $adodb->query($sql);
		$vtax1rate = $result->fields(rate) ;
		$sql = "SELECT customer_id,rate from ${pre}customertax a, ${pre}tax b " ;
		$sql.= "WHERE customer_id='$customer' and a.tax_id=b.id and taxtype='2'" ;
		$result = $adodb->query($sql);
		$vtax2rate = $result->fields(rate) ;
		$sql = "SELECT customer_id,rate from ${pre}customertax a, ${pre}tax b, ${pre}customer c " ;
		$sql.= "WHERE c.name='zzzzMyself' and customer_id=c.id and a.tax_id=b.id and taxtype='1'" ;
		$result = $adodb->query($sql);
		$stax1rate = $result->fields(rate) ;
		$sql = "SELECT customer_id,rate from ${pre}customertax a, ${pre}tax b, ${pre}customer c " ;
		$sql.= "WHERE c.name='zzzzMyself' and customer_id=c.id and a.tax_id=b.id and taxtype='2'" ;
		$result = $adodb->query($sql);
		$stax2rate = $result->fields(rate) ;
		}
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_number',exapi_lang('Item Code -- Id<br>(Inventory/Service)'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_qty',exapi_lang('Qty'));
	$t->set_var('lang_unit',exapi_lang('Unit'));
	$t->set_var('lang_btup',exapi_lang('BTUP'));
	$t->set_var('lang_discount',exapi_lang('Discount<br>$'));
	$t->set_var('lang_tax',exapi_lang('Tax'));
	$result = $adodb->query("SELECT artax1cap,artax2cap,artax1pref,artax2pref FROM ${pre}defaults");
	$t->set_var('lang_tax1',$result->fields(artax1cap));
	$t->set_var('lang_tax2',$result->fields(artax2cap));
	$tax1pref = $result->fields(artax1pref) ;
	$tax2pref = $result->fields(artax2pref) ;
	$t->set_var('lang_price',exapi_lang('Unit<br>Price'));
	$t->set_var('lang_itemtotal',exapi_lang('Item Total'));
	$t->set_var('lang_netamount',exapi_lang('Net of Tax'));
	$t->set_var('lang_accno',exapi_lang('Post to Account'));
	$t->set_var('lang_delete',exapi_lang('Delete<br>Button'));
	$t->set_var('lang_newrow',exapi_lang('Add New Row'));
	$item_sl = item_selectlist("",'') ;
	$sum_tax1 = $sum_tax2 = $sum_itemtotal = $sum_netamount = 0 ;
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		$t->set_var('itemid_fld','itemid'.$i) ;
		$t->set_var('itemtype_fld','itemtype'.$i) ;
		$t->set_var('description_fld','description'.$i);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('unit_fld','unit'.$i);
		$t->set_var('discount_fld','discount'.$i);
		$t->set_var('price_fld','price'.$i);
		$t->set_var('tax1_pref_fld','tax1_pref'.$i);
		$t->set_var('tax2_pref_fld','tax2_pref'.$i);
		$t->set_var('tax1_fld','tax1'.$i);
		$t->set_var('tax2_fld','tax2'.$i);
		$itemid = $dt['itemid'.$i] ;
		$t->set_var('itemid',$itemid) ;
		$t->set_var('item_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$item_sl));
		$itemtype = $dt['itemtype'.$i] ;
		$description = $dt['description'.$i] ;
		$unit = $dt['unit'.$i] ;
		$qty = ($itemid<>'' and $dt['qty'.$i]=='') ? 1 : $dt['qty'.$i] ;
		$discount = $dt['discount'.$i] ;
		$price = $dt['price'.$i] ;
		$tax1_pref = ($dt['tax1_pref'.$i] or $posted) ? $dt['tax1_pref'.$i] : $tax1pref ;
		$tax2_pref = ($dt['tax2_pref'.$i] or $posted) ? $dt['tax2_pref'.$i] : $tax2pref ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		if (($tax1_pref=="" or $tax1_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark1',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark1',"");
		if (($tax2_pref=="" or $tax2_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark2',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark2',"");
		$tax1 = $dt['tax1'.$i] ;
		$tax2 = $dt['tax2'.$i] ;
		$itemid = ($itemid=="") ? 0 : $itemid ;
		if (!$itemtype) {
			$result = $adodb->query("SELECT * FROM ${pre}service WHERE id='$itemid'");
			if ($result->RecordCount()>0)	$itemtype = "s" ;
			   else {
				$result = $adodb->query("SELECT * FROM ${pre}parts WHERE id='$itemid'");
				if ($result->RecordCount()>0)	$itemtype = "i" ;
				}
			$description = $description<>'' ? $description : $result->fields('description');
			$unit = $unit<>'' ? $unit : $result->fields('unit');
			$price = ($price<>'' or $itemid==0) ? $price : $result->fields('price')/$dt[exrate];
			$price = number_format($price,2,".",'') ;
			}
		$t->set_var('itemtype',$itemtype);
		$t->set_var('description',$description);
		$t->set_var('unit',$unit);
		$t->set_var('qty',$qty);
		$t->set_var('discount',$discount);
		if ($taxstatus=="t" or $posted)	$t->set_var('disc_readonly','readonly');
			else			$t->set_var('disc_readonly','');
		$price = number_format($price,2,".",'') ;
		$price = ($itemid==0) ? "" : $price ;
		$t->set_var('price',$price);
		switch ($tax1_pref) :
			case "c" :	$tax1rate = $ctax1rate ;	break ;
			case "s" :	$tax1rate = $stax1rate ;	break ;
			case "i" :
				$sql = "SELECT rate from ${pre}itemtax a, ${pre}tax b WHERE " ;
				$sql.= "item_id='$itemid' and tax_id=id and taxtype='1' and taxgroup='ar'";
				$result = $adodb->query($sql);
				$tax1rate = $result->fields(rate) ;
				break ;
			case "z" :	$tax1rate = 0 ;		break ;
			case "m" :	$tax1rate = 0 ;		break ;
			case " " :	$tax1rate = 0 ;		break ;
			case "" :	$tax1rate = 0 ;		break ;
			endswitch ;
		switch ($tax2_pref) :
			case "c" :	$tax2rate = $ctax2rate ;	break ;
			case "s" :	$tax2rate = $stax2rate ;	break ;
			case "i" :
				$sql = "SELECT rate from ${pre}itemtax a, ${pre}tax b WHERE " ;
				$sql.= "item_id='$itemid' and tax_id=id and taxtype='2' and taxgroup='ar'";
				$result = $adodb->query($sql);
				$tax2rate = $result->fields(rate) ;
				break ;
			case "z" :	$tax2rate = 0 ;		break ;
			case "m" :	$tax2rate = 0 ;		break ;
			case " " :	$tax2rate = 0 ;		break ;
			case "" :	$tax2rate = 0 ;		break ;
			endswitch ;
		switch ($taxstatus) :
			case "f" :
				$t->set_var('btup',$price);
				$netamount = number_format($qty*$price-$discount,2,".",'') ;
				$keeptax1=($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ");
				$keeptax2=($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ");
				$tax1 = ($keeptax1) ? $tax1 : $netamount*$tax1rate ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $netamount*$tax2rate ;
				$tax2 = number_format($tax2,2,".",'') ;
				$itemtotal = $netamount + $tax1 + $tax2 ;
				break ;
			case "t" :
				$t->set_var('btup','.');
				$t->set_var('discount','');
				$itemtotal = $taxbase = number_format($qty*$price,2,".",'') ;
				$keeptax1=($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ");
				$keeptax2=($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ");
				if ($keeptax1)		$taxbase -= $tax1 ;
				if ($keeptax2)		$taxbase -= $tax2 ;
				$tax1 = ($keeptax1) ? $tax1 : $taxbase*$tax1rate/(1+$tax1rate+$tax2rate) ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $taxbase*$tax2rate/(1+$tax1rate+$tax2rate) ;
				$tax2 = number_format($tax2,2,".",'') ;
				$netamount = $itemtotal - $tax1 - $tax2 ;
				break ;
			case "e" :
				$t->set_var('btup','.');
				$netamount = number_format($qty*$price-$discount,2,".",'') ;
				$itemtotal = $netamount ;
				$tax1rate = $tax2rate = 0 ;
				$tax1 = $tax2 = 0 ;
				break ;
			endswitch ;
		$sum_tax1 += $tax1 ;
		$sum_tax2 += $tax2 ;
		$sum_itemtotal += $itemtotal ;
		$sum_netamount += $netamount ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		$t->set_var('tax1',$tax1);
		$t->set_var('tax2',$tax2);
		$t->set_var('itemtotal',$itemtotal);
		$t->set_var('netamount',$netamount);
		if ($posted)	$t->set_var('rowno',"done") ;
			else	$t->set_var('rowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);

		$dt['itemid'.$i] = $itemid ;
		$dt['itemtype'.$i] = $itemtype ;
		$dt['description'.$i] = $description ;
		$dt['qty'.$i] = $qty ;
		$dt['price'.$i] = $price ;
		$dt['discount'.$i] = $discount ;
		$dt['unit'.$i] = $unit ;
		$dt['tax1'.$i] = $tax1 ;
		$dt['tax2'.$i] = $tax2 ;
		$dt['netamount'.$i] = $netamount ;
		}
	$dt[amount] = number_format($sum_itemtotal,2,".",'') ;
	$dt[netamount] = number_format($sum_netamount,2,".",'') ;
	$t->set_var('lang_totalnet',exapi_lang('Total Tax / Net Amount'));
	$t->set_var('lang_totalap',exapi_lang('Total Payable'));
	$t->set_var('sum_tax',number_format($sum_tax1+$sum_tax2,2,".",'')) ;
	$t->set_var('sum_netamount',$dt[netamount]) ;
	$t->set_var('sum_itemtotal',$dt[amount]) ;
	$t->set_var('oldisocode',$dt['isocode']);
	$t->parse('out','report',True);
	}

//---- Quotation Post Initialisation

    function quote_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;

	if ($dt[taxstatus]=="e")	{$dt[taxstatus] = "f" ;	$dt[netamount] = $dt[amount] ;	}
	$dt[taxincluded] = $dt[taxstatus] ;
	}

//---- Quotation Post - PreCommit Routine

    function quote_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$id = &$ckapi[params_post][id] ;
	$op = &$ckapi[params_post][op] ;

	if ($op<>'new')		$adodb->query("DELETE FROM ${pre}oitem WHERE trans_id=$id") ;
	if ($op<>'delete') {
		For ($i=1;isset($dt['itemid'.$i]);$i++) {
			$itemid		= $dt['itemid'.$i];
			$itemtype	= $dt['itemtype'.$i];
			$desc		= addslashes($dt['description'.$i]);
			$unit		= addslashes($dt['unit'.$i]);
			$qty		= $dt['qty'.$i];
			$price		= $dt['price'.$i];
			$discount	= $dt['discount'.$i];
			$tax1		= number_format($dt['tax1'.$i],2,".",'');
			$tax2		= number_format($dt['tax2'.$i],2,".",'');
			$sql = "INSERT INTO ${pre}oitem (trans_id,itemid,itemtype,description,qty,price,discount,tax1,tax2,unit) " ;
			$sql.= "VALUES ('$id','$itemid','$itemtype','$desc','$qty','$price','$discount','$tax1','$tax2','$unit')";
			$adodb->query($sql);
			}
		}
	}

    }

?>
