<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.attend.inc.php 0.13.1 2005/06/15 C K Wu

    class attend {

//---- Attendance List SQL Formation

    function attend_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$sql ="SELECT b.name,d.description as dept,transdate,time,a.type,c.description as reason,a.id as id ";
	$sql.=  "FROM ${pre}attendance a, ${pre}employee b, ${pre}category c, ${pre}department d " ;
	$sql.=  "WHERE contactid='$_GET[contactid]' and empid=b.id and b.dept=d.id " ;
	$sql.=  "and a.type=c.type and c.app='ck-hr' and a.reason=c.name $where " ;
	$sql.=  "ORDER BY $order $sort" ;
	return $sql ;
	}

//---- Attendance Read (for Sign-in and Sign-out)

    function attend_add_init() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;

	$result = $adodb->query("SELECT * FROM ${pre}employee WHERE contactid=$_GET[contactid]");
	$ckapi[params_post][dt][name] = $result->fields('name');
	$ckapi[params_post][dt][empid] = $result->fields('id');
	return ;
	}

//---- Attendance Detail Validation Checks

    function attend_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$err="";  $error = exapi_lang("Error:") ;
	if ($dt[type]==exapi_lang('sign-in') and $dt[signin]=='')	$err=exapi_lang("Sign in Reason Missing") ;
	if ($dt[type]==exapi_lang('sign-out') and $dt[signout]=='')	$err=exapi_lang("Sign out Reason Missing") ;
	if ($dt[signin]<>'' and $dt[signout]<>'')		$err=exapi_lang("Both Sign In & Out Reasons are active") ;
	$result = $adodb->query("SELECT * FROM ${pre}employee WHERE id='$dt[empid]' and contactid=$_GET[contactid]");
	if ($result->RecordCount()==0)				$err=exapi_lang("Invalid hidden employee id") ;
	
	if ($err)						$err = "<b>$error $err</b>" ;
	return $err ;
	}

//---- Write Attendance Detail

    function attend_write() {
	global $ckapi ;

//	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$lang_si = exapi_lang('sign-in') ;
	$lang_so = exapi_lang('sign-out') ;
	$blankopt = "<OPTION value=''></OPTION>" ;
	$type_sl = "<OPTION value='$lang_si'>$lang_si</OPTION>" ;
	$type_sl.= "<OPTION value='$lang_so'>$lang_so</OPTION>";
	$t->set_var('lang_type',exapi_lang('Action'));
	$t->set_var('lang_name',exapi_lang('Employee Name/#'));
	$t->set_var('lang_signin',exapi_lang('Sign In Reason'));
	$t->set_var('lang_signout',exapi_lang('Sign Out Reason'));
	$lang_signin = exapi_lang('sign-in') ;
	$lang_signout = exapi_lang('sign-out') ;

	$type_sl = str_replace("'$dt[type]'","'$dt[type]' selected",$type_sl) ;
	$t->set_var('type_selectlist',$type_sl);
	$t->set_var('name',$dt[name]);
	$t->set_var('empid',$dt[empid]);

$signin_sl = $blankopt.selectlist('category','name',"WHERE app='ck-hr' and type='$lang_signin'",'','name','name','substring(description,1,25)') ;
	$signin_sl = str_replace("'$dt[signin]'","'$dt[signin]' selected",$signin_sl) ;
	$t->set_var('signin_selectlist',$signin_sl);
$signout_sl = $blankopt.selectlist('category','name',"WHERE app='ck-hr' and type='$lang_signout'",'','name','name','substring(description,1,25)') ;
	$signout_sl = str_replace("'$dt[signout]'","'$dt[signout]' selected",$signout_sl) ;
	$t->set_var('signout_selectlist',$signout_sl);

	$t->parse('out','report',True);
	}

//---- Attendance Post Initialisation (Sign-in or Sign-out)

    function attend_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;

	$lang_si = exapi_lang('sign-in') ;
	$lang_so = exapi_lang('sign-out') ;
	$dt[reason] = ($dt[type]==$lang_si) ? $dt[signin] : $dt[signout] ;
	$dt[transdate] = date("Y-m-d") ;
	$dt[time] = date("H:i:s") ;

	}

//---- Attendance Post - PostCommit Routine

    function attend_post_postcommit() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;

	$ckapi[phrases]["reminder"] = "<br>$dt[name] $dt[type] - $dt[transdate]/$dt[time]" ;
	}

    }

?>
