<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.expenseapp.inc.php 0.13.1 2005/06/15 C K Wu

    class expenseapp {

//---- Expense/Allowance Claim List SQL Formation

    function expenseapp_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$user = $ckapi[hostsys][username];
	$sql =	"SELECT b.name as empname,c.name as pyrname,description," ;
	$sql.=	"a.qty,a.unit,a.unitamt,a.rate,a.amount,comment,approved_by,a.id " ;
	$sql.=	"FROM ${pre}pynr_trans a, ${pre}employee b, ${pre}pyrcode c " ;
	$sql.=	"WHERE contactid='$_GET[contactid]' and empid=b.id and pyrcodeid=c.id $where order by $order $sort" ;

	return $sql ;
	}

//---- Expense/Allowance Claim List Link Adjustement

    function expenseapp_list_adjust() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	if ($ckapi[params_list][dt][approved_by]<>'')
		$t->set_var(array(	'lang_edit'	=> '',
					'lang_delete'	=> '',
					'edit'		=> '',
					'delete'	=> ''	)) ;
	}

//---- Expense/Allowance Claim Read

    function expenseapp_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$sql =	"SELECT a.empid,salary,period,pyrcodeid as eaid,basis,a.qty,a.unit," ;
	$sql.=	"a.unitamt,a.rate,a.amount,comment,approved_by,a.id,a.control " ;
	$sql.=	"FROM ${pre}pynr_trans a, ${pre}payroll b, ${pre}pyrcode c " ;
	$sql.=	"WHERE a.id='$id' and a.empid=b.empid and pyrcodeid=c.id" ;
	$result = $adodb->query($sql);
	$dt = $result->fetchRow() ;
	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM ${pre}defaults" ;
	$result = $adodb->query($sql);
	switch ($dt[period]) :
		case "mn" :	$dt[daypay] = $dt[salary]/$result->fields('mndfactor') ;
				$dt[hourpay] = $dt[salary]/$result->fields('mnhfactor') ;	break ;
		case "sm" :	$dt[daypay] = $dt[salary]/$result->fields('smdfactor') ;
				$dt[hourpay] = $dt[salary]/$result->fields('smhfactor') ;	break ;
		case "wk" :	$dt[daypay] = $dt[salary]/$result->fields('wkdfactor') ;
				$dt[hourpay] = $dt[salary]/$result->fields('wkhfactor') ;	break ;
		case "dy" :	$dt[daypay] = $dt[salary] ;
				$dt[hourpay] = $dt[salary]/$result->fields('dyhfactor') ;	break ;
		case "hr" :	$dt[daypay] = $dt[salary] * $result->fields('dyhfactor') ;
				$dt[hourpay] = $dt[salary] ;				break ;
		endswitch ;
	$dt[daypay] = sprintf("%01.2f",$dt[daypay]) ;
	$dt[hourpay] = sprintf("%01.2f",$dt[hourpay]) ;
	return $dt ;
	}

//---- Expense/Allowance Claim Add Initialisation

    function expenseapp_add_init() {
	global $ckapi,$adodb ;

	foreach ($ckapi[buttons] as $key => $val)	$$key = ($_GET[$key]) ? $_GET[$key] : $_POST[$key] ;
	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$pre = $ckapi[params][pre] ;
	$result = $adodb->query("SELECT * FROM ${pre}employee WHERE contactid='$_GET[contactid]'");
	$dt[empid] = $result->fields('id');

	$dt[empid] = ($dt[empid]=="") ? 0 : $dt[empid] ;
	$result = $adodb->query("SELECT * from ${pre}payroll WHERE empid='$dt[empid]'");
	if ($result->RecordCount()==0 and (isset($post) or isset($refresh))) {
		$error = exapi_lang("Error") ;
		$err = exapi_lang("Employee Payroll Master Info missing") ;
		$t->set_var('message',"<b>$error:  $err</b>");
		$ckapi[params][nomaster] = True ;
		}
	$dt[salary] = $result->fields('salary') ;
	$dt[period] = $result->fields('period') ;

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM ${pre}defaults" ;
	$result = $adodb->query($sql);
	switch ($dt[period]) :
		case "mn" :	$dt[daypay] = $dt[salary]/$result->fields('mndfactor') ;
				$dt[hourpay] = $dt[salary]/$result->fields('mnhfactor') ;	break ;
		case "sm" :	$dt[daypay] = $dt[salary]/$result->fields('smdfactor') ;
				$dt[hourpay] = $dt[salary]/$result->fields('smhfactor') ;	break ;
		case "wk" :	$dt[daypay] = $dt[salary]/$result->fields('wkdfactor') ;
				$dt[hourpay] = $dt[salary]/$result->fields('wkhfactor') ;	break ;
		case "dy" :	$dt[daypay] = $dt[salary] ;
				$dt[hourpay] = $dt[salary]/$result->fields('dyhfactor') ;	break ;
		case "hr" :	$dt[daypay] = $dt[salary] * $result->fields('dyhfactor') ;
				$dt[hourpay] = $dt[salary] ;				break ;
		endswitch ;
	$dt[daypay] = sprintf("%01.2f",$dt[daypay]) ;
	$dt[hourpay] = sprintf("%01.2f",$dt[hourpay]) ;
	}

//---- Expense/Allowance Claim Validation Checks

    function expenseapp_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error = exapi_lang("Error") ;
	$eaid = $dt[eaid] ;
	$oldeaid = $dt[oldeaid] ;
	$qty = $dt[qty] ;
	$amt = $dt[amount] ;
	$result = $adodb->query("SELECT * from ${pre}pyrcode where id='$eaid'");
	if ($qty<$result->fields('minqty'))	$err=exapi_lang("Quantity too low");
	if ($qty>$result->fields('maxqty'))	$err=exapi_lang("Quantity too high");
	if ($amt<$result->fields('minamt'))	$err=exapi_lang("Amount too small");
	if ($amt>$result->fields('maxamt'))	$err=exapi_lang("Amount too large");
	if ($qty=="")				$err=exapi_lang("Quantity Missing");
	if ($qty<>"" and !is_numeric($qty))	$err=exapi_lang("Quantity must be numeric");
	if ($amt=="")				$err=exapi_lang("Amount Missing");
	if ($amt<>"" and !is_numeric($amt))	$err=exapi_lang("Amount must be numeric");
	if ($result->fields('single')=="y" and $eaid<>$oldeaid) {
		$sql = "SELECT * from ${pre}pyrc_trans a, ${pre}payroll b " ;
		$sql.= "WHERE a.pyroid=b.id and b.empid='$dt[empid]' and pyrcodeid='$eaid'" ;
		$result = $adodb->query($sql);
		if ($result->RecordCount()>0)  $err=exapi_lang("This Expense/Allowance (recurring) already exists");
		$sql = "SELECT * from ${pre}pynr_trans WHERE empid='$dt[empid]' and pyrcodeid='$eaid'" ;
		$result = $adodb->query($sql);
		if ($result->RecordCount()>0)	$err=exapi_lang("This Expense/Allowance (non-recurring) already exists") ;
		}
	if ($dt[eaid]<>$dt[lasteaid]) {
		$warn1 = exapi_lang("Expense/Allowance Type had just been updated.") ;
		$warn2 = exapi_lang("Ensure other data are appropriately adjusted and updated.") ;
		$warn3 = exapi_lang("Then re-click [Post ...] button")  ;
		$err = "$warn1<br>$warn2  $warn3" ;
		}

	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Expense/Allowance Claim Detail

    function expenseapp_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_empid',exapi_lang('Employee Name/#'));
	$t->set_var('lang_id',exapi_lang('ID#'));
	$t->set_var('lang_salary',exapi_lang('Basic Salary'));
	$t->set_var('lang_period',exapi_lang('Pay Period'));
	$t->set_var('lang_daypay',exapi_lang('Imputed Daily Pay'));
	$t->set_var('lang_hourpay',exapi_lang('Imputed Hourly Pay'));
	$t->set_var('lang_eaid',exapi_lang('Expense/Allowance Type'));
	$t->set_var('lang_basis',exapi_lang('Basis of Calculation'));
	$t->set_var('lang_qty',exapi_lang('Quantity'));
	$t->set_var('lang_unit',exapi_lang('Unit'));
	$t->set_var('lang_unitamt',exapi_lang('Unit Amount'));
	$t->set_var('lang_rate',exapi_lang('Pay Rate'));
	$t->set_var('lang_amount',exapi_lang('Amount'));
	$t->set_var('lang_comment',exapi_lang('Comment'));
	$t->set_var('lang_approved_by',exapi_lang('Approved By'));
	$user = $ckapi[hostsys][username];
	$empid = $dt[empid] ;
	$result = $adodb->query("SELECT * FROM ${pre}employee WHERE id='$empid' and contactid='$_GET[contactid]'");
	if ($result->RecordCount()==0)	die(exapi_lang("You are not authorised to access the requested information.")) ;
	$where = " WHERE id='$dt[empid]' " ;

	$t->set_var('empid_selectlist',selectlist('employee','name',$where,'','id','name','id')) ;
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('salary',$dt[salary]);
	$t->set_var('period',$dt[period]) ;
	$t->set_var('daypay',$dt[daypay]);
	$t->set_var('hourpay',$dt[hourpay]) ;
	$where = "WHERE allowssc='y'" ;
	$eaid = ($dt[eaid]=="") ? 0 : $dt[eaid] ;
	$t->set_var('eaid_selectlist',selectlist('pyrcode','name',$where,$eaid,'id','description')) ;
	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var("lasteaid",$eaid);

	$qty = 1 ;
	$result = $adodb->query("SELECT * from ${pre}pyrcode where id='$eaid'");
	$basis		=	$result->fields('basis') ;
	$unit		=	$result->fields('unit') ;
	$unitamt	=	(substr_count($basis,'pc')>0) ? $result->fields('unitamt') : 1 ;
	$rate		=	$result->fields('rate') ;
//	$chart_id	=	($dt[rate]==0) ? $result->fields('chart_id') : $dt[chart_id] ;
	$dt[chart_id]	=	$result->fields('chart_id') ;
	if (substr_count($basis,'qty')>0)	{$qty = $dt[qty]; $t->set_var('qty_readonly','');}
		else				$t->set_var('qty_readonly','readonly') ;
	if (substr_count($basis,'bs')>0)	$unitamt = $dt[salary] ;
	if (substr_count($basis,'hp')>0)	$unitamt = $dt[hourpay] ;
	if (substr_count($basis,'dp')>0)	$unitamt = $dt[daypay] ;
	$amount = sprintf("%01.2f",$qty*$unitamt*$rate) ;
	if (substr_count($basis,'amt')>0)	{$amount=$dt[amount]; $t->set_var('amt_readonly','');}
		else				$t->set_var('amt_readonly','readonly') ;
	$dt[qty] = $qty ;
	$dt[unit] = $unit ;
	$dt[unitamt] = $unitamt ;
	$dt[amount] = $amount ;
	$t->set_var('basis',$basis);
	$t->set_var('qty',$qty);
	$t->set_var('unit',$unit);
	$t->set_var('unitamt',$unitamt);
	$t->set_var('rate',$rate);
	$t->set_var('amount',$amount);
	$t->set_var('comment',$dt[comment]);
	$t->set_var('approved_by',$dt[approved_by]);
	$t->parse('out','report',True);
	}

//---- Expense/Allowance Claim Post Initialisation

    function expenseapp_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][pyrcodeid] = $ckapi[params_post][dt][eaid] ;
	$ckapi[params_post][dt][approved_by] = "" ;
	}

//---- Expense/Allowance Claim Post - PostCommit Routine

    function expenseapp_post_postcommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$actioned = $ckapi[phrases][actioned] ;

	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername,b.contactid as supercontactid " ;
	$sql.= "FROM ${pre}employee a, ${pre}employee b WHERE a.id='$dt[empid]' and a.supervisor=b.id" ;
	$result = $adodb->query($sql);
	$staffname = $result->fields('staffname');
	$superid = $result->fields('superid');
	$supername = $result->fields('supername');
	$supercontactid = $result->fields('supercontactid');
	$sql = "SELECT commdata FROM ${pre}comm WHERE contactid='$_GET[contactid]' and commcode='wemail'";
	$result = $adodb->query($sql);
	$staffemail = $result->fields('commdata') ;
	$sql = "SELECT commdata FROM ${pre}comm WHERE contactid='$supercontactid' and commcode='wemail'";
	$result = $adodb->query($sql);
	$superemail = $result->fields('commdata') ;
	$recipient = "$supername < $superemail >" ;
	$subject = exapi_lang("%1's Expense/Allowance Claim [id#%2] %3 => Please approve",$staffname,$id,$actioned);
	$message = '' ;
	$headers = "From: $staffname < $staffemail >\n" ;
	$charset = exapi_lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $staffname < $staffemail >\n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	$inform = exapi_lang("Please manually inform") ;
	if ($op=='delete') {
		$successmsg = exapi_lang("Email advising action on expense/allowance claim successfully queued for despatch to") ;
		$failuremsg=exapi_lang("Email advising action on expense/allowance claim fails to deliver.")."  $inform";
		}
	  else  {
		$successmsg = exapi_lang("Email requesting expense/allowance claim approval successfully queued for despatch to");
		$failuremsg=exapi_lang("Email requesting expense/allowance claim approval fails to deliver.")."  $inform";
		}
	if ($result)	$msg = "<br>$successmsg $supername." ;
		else	$msg = "<br>$failuremsg $supername." ;
	$ckapi[phrases]["reminder"] = $msg ;
	}

    }

?>
