<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// payrollfilter.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-sss' ;
	$tran = 'payroll' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "${tran}filter_validate.php"		) ;

	$title = exapi_lang("Choose Payroll Info to generate and to set Parameters :") ;
	$msg1 = exapi_lang('Please note that your payroll info will next be displayed on screen') ;
	$ckapi[phrases] = array('lang_title'	=> $title ,
				'lang_criteria'	=> exapi_lang("Info Generation Parameters") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Generate Past Period Payroll Info") ,
				'lang_add'	=> exapi_lang("Generate Current Period Payroll Info") ,
			'lang_search_message'	=> "<b>$msg1</b>"		);

	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$msg = exapi_lang('Payroll info falling within (from/to) date will be listed.') ;
	$ckapi[filter][] = array(criteria	=>	exapi_lang('Payroll Period From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	"$msg  $dateformat"		);

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Payroll Period To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	"$msg  $dateformat"		);

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>

