<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.vendor.inc.php 0.13.1 2005/06/15 C K Wu

    class vendor {

//---- Vendor List Link Adjustement

    function vendor_list_adjust() {
	global $ckapi ;

	$app = $ckapi[params][app] ;
	$tran = $ckapi[params][tran] ;
	$bulkcnt = &$ckapi[params][bulkcnt] ;
	
	foreach ($ckapi[params_list] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;

	$getstr = "order=$order&sort=$sort&id=$dt[id]&filter=$filter" ;
	$return = "/$app/${tran}list.php" ;
	$getstrc = "order=$order&sort=$sort&id=$dt[contactid]&filter=$filter&return=$return" ;
	if (substr_count($dt[name],'____')<=0) {
		$t->set_var('bulk_action',exapi_link("/$app/${tran}bulk.php",$getstr)) ;
		$t->set_var('disabled','') ;
		}
	}

//---- Vendor Read

    function vendor_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;
/*
	$result = $adodb->query("select * from ${pre}vendor where id='$id'");
	$dt = $result->fetchRow() ;
	$result = $adodb->query("select * from ${pre}org where id='$dt[contactid]'");
	if ($result->RecordCount()>0) {
		$dt[orgid] = $dt[contactid] ;
		$dt[note] = $result->fields('note') ;
		}
	  else	{
	  	$dt[prsid] = $dt[contactid] ;
		$result = $adodb->query("select * from ${pre}person where id='$dt[contactid]'");
		$dt[note] = $result->fields('note') ;
		}
*/
	$result = $adodb->query("select * from ${pre}vendor where id='$id'");
	$dt = $result->fetchRow() ;
	$result = $adodb->query("select * from ${pre}org where id='$dt[contactid]'");
	if ($result->RecordCount()>0)	$dt[orgid] = $dt[contactid] ;
		else			$dt[prsid] = $dt[contactid] ;
	
	$result = $adodb->query("select * from ${pre}vendortax where vendor_id = '$id' and taxtype=1");
	$dt[tax1] = $result->fields('tax_id') ;
	$result = $adodb->query("select * from ${pre}vendortax where vendor_id = '$id' and taxtype=2");
	$dt[tax2] = $result->fields('tax_id') ;
	if ($op=='copy')	$dt[creditlimit]=0;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- Vendor Detail Validation Checks

    function vendor_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error");
	if ($dt[orgid]<>"")	$dt[contactid] = $dt[orgid] ;
	if ($dt[prsid]<>"")	$dt[contactid] = $dt[prsid] ;
	if ($dt[contactid]<>$dt[oldcontactid]) {
		$result = $adodb->query("SELECT * from ${pre}vendor where contactid='$dt[contactid]'");
		if ($result->RecordCount()>0)		$err = exapi_lang("Org/Person belongs to an existing vendor") ;
		}
	if ($dt[orgid]=="" and $dt[prsid]=="")		$err=exapi_lang("Both Org and Person choices are blank");
	if ($dt[orgid]<>"" and $dt[prsid]<>"")		$err=exapi_lang("Vendor cannot be both Org and Person");
	if ($dt[terms] and !is_numeric($dt[terms]))	$err=exapi_lang("payment term must be numeric");
	if ($dt[terms]<0 or $dt[terms]>366)		$err=exapi_lang("payment term must be 0-366 days");
	
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Vendor Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$invoice = exapi_lang('invoice') ; $order = exapi_lang('purchase order');
	$errmsg1 = exapi_lang("This vendor is in use within an existing") ;
	$id = $dt[id] ;
	$result = $adodb->query("SELECT * from ${pre}ap WHERE vendor='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $invoice id#".$result->fields('id') ;
	$result = $adodb->query("SELECT * from ${pre}po WHERE vendor='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $order id#".$result->fields('id') ;
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Vendor Detail

    function vendor_write() {
	global $ckapi,$pre ;

	$app = $ckapi[params][app] ;
	$dt = &$ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',exapi_lang('Audit ID:'));
	$t->set_var('lang_org',exapi_lang('Organization'));
	$t->set_var('lang_prs',exapi_lang('Person'));
	$t->set_var('lang_catid',exapi_lang('Category'));
	$t->set_var('lang_terms',exapi_lang('Terms:Net'));
	$t->set_var('lang_day',exapi_lang('Days'));
	$t->set_var('lang_tax',exapi_lang('Tax Included'));
	$t->set_var('lang_taxnote',exapi_lang('Invoice Unit Price listed with Tax Included [Initial Default]'));
	$t->set_var('lang_tax1',exapi_lang('Primary Tax'));
	$t->set_var('lang_tax2',exapi_lang('Secondary Tax'));

	if ($op=='edit' and is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$name = 'substring(orgname,1,25)' ;
	$t->set_var('org_selectlist',"<OPTION value=''></OPTION>".selectlist('org','orgnumber','',$dt[orgid],'id','orgnumber',$name,'id'));
	$name = ($ckapi[hostsys][dbtype]=="mysql") ? "substring(concat(family,', ',given),1,25)" : "substring((family||', '||given),1,25)" ;
	$t->set_var('prs_selectlist',"<OPTION value=''></OPTION>".selectlist('person','prsnumber','',$dt[prsid],'id','prsnumber',$name,'id'));
	$lang_vend = strtolower(exapi_lang('Vendor')) ;
	$t->set_var('catid_selectlist',selectlist('category','type',"WHERE app='$app' and type='$lang_vend'",$dt[catid],'id','name','id'));
	$t->set_var('terms',$dt[terms]);
	if ($dt[taxincluded]=='t' or $dt[taxincluded]=='yes')		$t->set_var('checked',"checked");
	$notax = "<OPTION value=''>".exapi_lang('No Tax')."</OPTION>" ;
	$rate = ($ckapi[hostsys][dbtype]=="mysql") ? "concat(rate*100,'%')" : "(rate*100||'%')" ;
	$t->set_var('tax1_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='ap'",$dt[tax1],'id',$rate,'taxnumber','id'));
	$t->set_var('tax2_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='ap'",$dt[tax2],'id',$rate,'taxnumber','id'));
	$t->parse('out','report',True);
	}

//---- Vendor Post Initialisation

    function vendor_post_init() {
	global $ckapi,$pre,$adodb ;

	$dt = &$ckapi[params_post][dt] ;
	$dt[contactid] = ($dt[orgid]<>'') ? $dt[orgid] : $dt[prsid] ;
	if ($dt[orgid]<>'')	$result = $adodb->query("SELECT orgnumber as name FROM ${pre}org WHERE id=$dt[orgid]") ;
	if ($dt[prsid]<>'')	$result = $adodb->query("SELECT prsnumber as name FROM ${pre}person WHERE id=$dt[prsid]") ;
	$dt[name] = $result->fields('name') ;
	$dt[taxincluded] = ($dt[taxincluded]=='yes') ? "t" : "f" ;
	$dt[discount] = ($dt[discount]=="") ? 0 : $dt[discount] ;
	$dt[creditlimit] = ($dt[creditlimit]=="") ? 0 : $dt[creditlimit] ;
	$dt[terms] = ($dt[terms]=="") ? 0 : $dt[terms] ;
	}

//---- Vendor Post - PreCommit Routine

    function vendor_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = $ckapi[params_post][dt] ;
	$table = "${pre}vendortax" ;

	if ($op<>'new')		$adodb->query("DELETE FROM $table WHERE vendor_id=$id and (taxtype=1 or taxtype=2)") ;
	if ($op<>'delete') {
		$sql="INSERT INTO $table (vendor_id,tax_id,taxtype) " ;
		if ($dt[tax1]<>"")	$adodb->query("$sql VALUES ('$id','$dt[tax1]','1')");
		if ($dt[tax2]<>"")	$adodb->query("$sql VALUES ('$id','$dt[tax2]','2')");
		}
	}

    }
