<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// logfilter.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-admin' ;
	$tran = 'log' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> 'index.php'			) ;
	$msg1 = exapi_lang("Because of the immense size of the log table") ;
	$msg2 = exapi_lang("parameter should be added to shrink search result to a small number of records") ;
	$ckapi[phrases] = array('lang_title'	=> exapi_lang('Search and view selected log entries :') ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Done") ,
			'lang_search_message'	=> "$msg1,<br>$msg2." ,
				'message'	=> ""				);

	$oplistnew = exapi_lang('new -- new record inserted') ;
	$oplistedit = exapi_lang('edit -- old record edited') ;
	$oplistdelete = exapi_lang('delete -- old record deleted') ;
	$oplistclear = exapi_lang('clear -- old record cleared') ;
	$oplistmarker = exapi_lang('marker -- log location marker') ;
	$oplist =	"<OPTION value='ALL'></OPTION>".
			"<OPTION value='new'>$oplistnew</OPTION>" .
			"<OPTION value='edit'>$oplistedit</OPTION>" .
			"<OPTION value='delete'>$oplistdelete</OPTION>" .
			"<OPTION value='clear'>$oplistclear</OPTION>" .
			"<OPTION value='marker'>$oplistmarker</OPTION>" ;
	$dateformat = exapi_lang('Must be a valid date; format: YYYY-MM-DD') ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Operation') ,
				type		=>	'select' ,
				selectlist	=>	$oplist ,
				varname		=>	'op' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Select records of specific operation'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from_date' ,
				defval		=>	"" ,
				note		=>	$dateformat				) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to_date' ,
				defval		=>	"" ,
				note		=>	$dateformat				) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Transaction ID (from)') ,
				type		=>	'input' ,
				varname		=>	'from_id' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for record with transaction id starting from'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Transaction ID (to)') ,
				type		=>	'input' ,
				varname		=>	'to_id' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for record with transaction id ending at')) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Script') ,
				type		=>	'input' ,
				varname		=>	'script' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for target keyword in the script name field'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Log Table ID (from)') ,
				type		=>	'input' ,
				varname		=>	'from_logid' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for record with log table id starting from'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Log Table ID (to)') ,
				type		=>	'input' ,
				varname		=>	'to_logid' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for record with log table id ending at')) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('IP Address') ,
				type		=>	'input' ,
				varname		=>	'ip' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for target keyword in the IP address field'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('User ID') ,
				type		=>	'input' ,
				varname		=>	'userid' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for target keyword/# in the User ID field'));

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
