<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// functions.inc.php 0.13.1 2005/05/31 C K Wu


    function ckapi_tpl($app) {
	global $ckapi ;
	
	require_once('../ck-api/inc/class.ck_Template.inc.php') ;
	$tpl = new ck_Template("../$app/templates/default") ;
	return $tpl ;
	}

    function newobj($app,$class) {
	global $ckapi ;
	
	require_once('../'.$app.'/inc/class.'.$class.'.inc.php') ;
	$obj = new $class ;
	return $obj ;
	}

    function selectlist($table,$key,$filter='',$default='',$valfn='',$expr1='',$expr2='',$expr3='') {
	global $pre,$adodb ;

	$fields = "$valfn as vf,$expr1 as f1" ;
	if ($expr2<>'')		$fields .= ",$expr2 as f2" ;
	if ($expr3<>'')		$fields .= ",$expr3 as f3" ;
	$result = $adodb->query("SELECT $fields FROM ${pre}$table $filter ORDER BY $key");
	$selectlist="";
	While ($rs=$result->fetchRow()) {
		$val = $rs['vf'];
		$f1 = $rs['f1'];
		$f2 = $rs['f2'];
		$f3 = $rs['f3'] ;
		if ($expr2<>'' and $expr3<>'')	{$selectlist.="<OPTION value='$val'>$f1 -- $f2 -- $f3</OPTION>"; continue;}
		if ($expr2<>'')			{$selectlist.="<OPTION value='$val'>$f1 -- $f2</OPTION>"; continue;}
		$selectlist.="<OPTION value='$val'>$f1</OPTION>";
		}
	$selectlist = str_replace("'$default'","'$default'"." selected",$selectlist) ;
	return $selectlist ;
	}

    function item_selectlist($filter,$default) {
	global $pre,$adodb ;

	$selectlist .='<OPTION value=""></OPTION><OPTION value="">'.exapi_lang('Product/Parts :').'</OPTION>';
	$selectlist .= selectlist('parts','partnumber',$filter,'','id','partnumber','id') ;
	
	$selectlist .= '<OPTION value=""></OPTION><OPTION value="">'.exapi_lang('Services :').'</OPTION>';
	$selectlist .= selectlist('service','servicenumber',$filter,'','id','servicenumber','id') ;
	
	$selectlist .= '<OPTION value=""></OPTION>' ;
	$selectlist .= '<OPTION value="">'.exapi_lang('Assembly/Package').'</OPTION>' ;
	$selectlist .= '<OPTION value="">'.exapi_lang('(to explode):').'</OPTION>';
	$where = ($filter=='') ? 'WHERE a.assembly_id=b.id' : "WHERE a.assembly_id=b.id and $filter";
	$sl = selectlist("assembly a, ${pre}parts b",'partnumber',$where,'','distinct a.assembly_id','partnumber','a.assembly_id') ;
	$selectlist .= str_replace("value='","value='-",$sl) ;

	$where = ($filter=='') ? 'WHERE a.assembly_id=b.id' : "WHERE a.assembly_id=b.id and $filter";
	$sl = selectlist("assembly a, ${pre}service b",'servicenumber',$where,'','distinct a.assembly_id','servicenumber','a.assembly_id') ;
	$selectlist .= str_replace("value='","value='-",$sl) ;
	
	if ($default<>'')	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

    function input2date($idate) {

	$token= "-./ ";
	$p1 = strtok($idate,$token);
	$p2 = strtok($token);
	$p3 = strtok($token);
	$p4 = strtok($token);
	$date= ""; $y= ""; $m= ""; $d= "";

	if (($p1>0 && $p1<32) && ($p2>0 && $p2<13) && ($p3>32)) { $y=$p3; $m=$p2; $d=$p1; }				// check 'd.m.y'
	if ($y ==  "" && ($p1>32) && ($p2>0 && $p2<13) && ($p3>0 && $p3<32)) { $y=$p1; $m=$p2; $d=$p3; }		// check 'y.m.d'
	if ($y ==  "" && ($p3== "") && ($p2>0 && $p2<13) && ($p1>0 && $p1<32)) { $y=date( "Y"); $m=$p2; $d=$p1; }	// check 'd.m'
	if ($y ==  "" && ($p3== "") && ($p2== "") && ($p1>0 && $p1<32)) { $y=date( "Y"); $m=date( "m"); $d=$p1; }	// check 'd'
	if ($y!= "" && $y<=99) {											// add 1900 or 2000 to year
		if ($y>=70) $y = $y + 1900;
		if ($y<70) $y = $y + 2000;
		}

	if ($y!= "")	if (checkdate($m, $d, $y))	$date= "$y-$m-$d";

	return $date;
	}
	
//---- Set Up Year,Month,Week,Day Select Option List

    function ymwd_selectlist($filter,$default,$type) {

	switch ($type) :
		case "y" :	$start = 1951;	$end = 2050;	$format = '%04d';	break;
		case "m" :	$start = 1;	$end = 12;	$format = '%02d';	break;
		case "w" :	$start = 1;	$end = 53;	$format = '%02d';	break;
		case "d" :	$start = 1;	$end = 31;	$format = '%02d';	break;
		endswitch ;
	$selectlist = "" ;
	For ($i=$start;$i<=$end;$i++)	 {
		$j=sprintf($format,$i);
		$selectlist .= "<OPTION value='$j'>$j</OPTION>" ;
		}
	if ($default<>"") {
		$default = sprintf($format,$default);
		$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
		}
	return $selectlist ;
	}

?>