<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// connector.inc.php 0.13.1 2005/06/15 C K Wu
//
// (connector for running CK-ERP atop phpBB + LAMP)

	global $ckapi,$adodb,$template ;

	define('IN_PHPBB', true) ;
	define('PAGE_CKERP',99999) ;
	$phpbb_root_path = '../' ;
	require_once($phpbb_root_path.'extension.inc') ;
	require_once($phpbb_root_path.'common.'.$phpEx) ;
	$userdata = session_pagestart($user_ip, PAGE_CKERP) ;
	init_userprefs($userdata) ;

	require_once('../includes/db.php') ;
	class phpbb_db extends sql_db {
		function query($query='')	 			{parent::sql_query($query) ;	return $this ;	}
		function fetchRow($query_id=0)				{return parent::sql_fetchrow($query_id) ;	}
		function fields($field, $rownum=-1, $query_id=0)	{return parent::sql_fetchfield($field) ;	}
		function RecordCount($query_id=0)			{return parent::sql_numrows($query_id=0) ;	}
		}
	$ckapi[hostsys][dbtype] = $dbtype = $dbms ;
	if ($dbtype=='postgres')	$ckapi[hostsys][dbtype] = $dbtype = 'pgsql' ;
	$adodb = new phpbb_db($dbhost, $dbuser, $dbpasswd, $dbname, false) ;
	
	$ckapi[hostsys][username] = trim($userdata['username']);
	$ckapi[hostsys][dataarea] = $_SERVER["DOCUMENT_ROOT"].$board_config["script_path"].$board_config["avatar_path"] ;
	$ckapi[hostsys][th_bg] = $theme['th_color1'] ;
	$ckapi[hostsys][tr_color1] = $theme['tr_color1'] ;
	$ckapi[hostsys][tr_color2] = $theme['tr_color2'] ;
	$ckapi[hostsys][tr_color3] = $theme['tr_color3'] ;
	$ckapi[hostsys][tr_color4] = $theme['tr_color4'] ;

	if (!$noheader) {
		require_once('../ck-api/phpbb/page_header.'.$phpEx);
		require_once('../ck-api/phpbb/navbar.php') ;
		require_once("inc/header.inc.php") ;
		require_once("inc/headeraccess.inc.php") ;
		}

	if (!$userdata['session_logged_in'])	die(exapi_lang('You must be logged in to access CK-ERP'));

    function exapi_link($url,$getstr='') {
	if (strlen($getstr)<2)	return append_sid('..'.$url) ;
	  else			return append_sid('..'.$url).'?'.$getstr ;
	}
	
    function exapi_footer() {
	global $phpbb_root_path,$phpEx,$template,$db;	require_once($phpbb_root_path.'includes/page_tail.'.$phpEx) ;
	}

    function exapi_groups($user='') {
	global $adodb,$userdata ;
	
	$sql = "SELECT g.group_id, g.group_name as account_name, g.group_type, ug.user_pending " ;
	$sql.= "FROM " . GROUPS_TABLE . " g, " . USER_GROUP_TABLE . " ug " ;
	$sql.= "WHERE ug.user_id = '$userdata[user_id]' AND ug.group_id = g.group_id ORDER BY g.group_name, ug.user_id";
	$result = $adodb->query($sql);
	While ($rs=$result->fetchRow()) $groups[]=$rs	;
	return $groups ;
	}

    function exapi_is_group($name) {
	global $adodb ;
	
	$result = $adodb->query("SELECT * FROM " . GROUPS_TABLE . " WHERE group_name = '$name'");
	return $result->RecordCount()>0 ;
	}

    function exapi_lang($phrase,$z1='',$z2='',$z3='',$z4='') {
	if ($z2<>'')	{$search=array('%1','%2','%3','%4');$replace=array($z1,$z2,$z3,$z4);return str_replace($search,$replace,$phrase);}
	if ($z1<>'')	return str_replace('%1',$z1,$phrase) ;
	return $phrase;
	}

    function is_admin($user='') {
	global $userdata;		return $userdata['user_level'] == ADMIN ;
	}

?>