<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// importfilter.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-contact' ;
	$tran = 'import' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"			) ;
	$title = exapi_lang("Choose Parameters for Contact Data Import :") ;
	$msg1 = exapi_lang('Please plan your importing action carefully.') ;
	$msg2 = exapi_lang('Inadvertent repeat of the importing process will create duplicate entries.') ;
	$msg3 = exapi_lang('After the import, the fields [preferred, person code and organization code] still need to be added back manually.') ;
	$msg4 = exapi_lang('Errors in the prefix and suffix fields may need to be rectified.') ;
	$msg5 = exapi_lang('You should also check for different org/person records that happen to end up with the same shortname/#.');
	$msg6 = exapi_lang('Importing of Contact Data requires lengthy processing time.') ;
	$msg7 = exapi_lang('You should initiate import only during off-peak hours.') ;
	$ckapi[phrases] = array('lang_title'	=> $title ,
				'lang_criteria'	=> exapi_lang("Import Parameters") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Importing Action") ,
				'lang_add'	=> exapi_lang("Return to Index Page") ,
			'lang_search_message'	=> "<b>$msg1  $msg2  $msg3  $msg4  $msg5<br></b>$msg6  $msg7" ,
				'message'	=> ""				);

	$note0 = exapi_lang("Please follow the strict sequence of Step 1, then Step 2, then Step 3.") ;
	$note1 = exapi_lang("If wrong data set chosen, click (Import Contact Data) to restart.") ;
	$note1a = exapi_lang("Press (Start Importing Action) one more time to start.") ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$noteomask = exapi_lang('Import only those items that have an organization name with its 1st character being part of the mask.') ;
	$notefmask = exapi_lang('Import only those items that have a Family/Last name with its 1st character being part of the mask.') ;
	$notemask = exapi_lang('This is used to sectionalise the data import, if so desired.') ;
	$noteexp1 = exapi_lang('This will import Organisation=>Related Person and Person=>Associated Organization linkage information.') ;
	$noteexp2 = exapi_lang('Only previously unimported linkages will be imported.') ;
	$noteexp3 = exapi_lang('Linkages that had been overtaken by manually created organization<=>person links within ContactManagement will not be imported.') ;
	$ckapi[filter][] = array(criteria	=>	exapi_lang('Which contact data set to import') ,
				type		=>	'select' ,
				selectlist	=>	'' ,
				varname		=>	'actnum' ,
				defval		=>	'' ,
				note		=>	"$note0<br>$note1"			) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Organization Name') ,
				type		=>	'input' ,
				varname		=>	'oname' ,
				defval		=>	'' ,
				note		=>	exapi_lang('Search for target key word in the Contact Organization Name  field')) ;
	
	$ckapi[filter][] = array(criteria	=>	exapi_lang('[char1] Mask for Organization Name') ,
				type		=>	'input' ,
				varname		=>	'omask' ,
				defval		=>	'' ,
				note		=>	"$noteomask  $notemask"		);

	$ckapi[filter][] = array(criteria	=>	exapi_lang("Person_s Family/Last Name") ,
				type		=>	'input' ,
				varname		=>	'fname' ,
				defval		=>	'' ,
				note		=>	exapi_lang('Search for target key word in the Contact Person_s Family/Last Name  field')) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('[char1] Mask for Family/Last Name') ,
				type		=>	'input' ,
				varname		=>	'fmask' ,
				defval		=>	'' ,
				note		=>	"$notefmask  $notemask") ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Explanatory Message'),
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	exapi_lang('[No Input Required]') ,
				note		=>	"$noteexp1  $noteexp2  $noteexp3") ;

	$lang_reserved = exapi_lang('Reserved') ;
	$import1 = exapi_lang('Step 1 -- Organization Data') ;
	$import2 = exapi_lang('Step 2 -- Person Data') ;
	$import3 = exapi_lang('Step 3 -- Organization <=> Person Linkage Data') ;

	$ckapi[filter][actlist] = array (	1=>	"<OPTION value='1'>$import1</OPTION>",
						2=>	"<OPTION value='2'>$import2</OPTION>",
						3=>	"<OPTION value='3'>$import3</OPTION>",
						4=>	"<OPTION value='4'>$lang_reserved</OPTION>",
						5=>	"<OPTION value='5'>$lang_reserved</OPTION>"	) ;
	$ckapi[filter][actstring] = array(	"0",	/* initial entry	*/
						"012",	/* import 1	*/
						"034",	/* import 2	*/
						"05",	/* import 3	*/
						"0",	/* import 4	*/
						"0"	/* import 5	*/			) ;
	if ($_POST[actnum]<>"")	$ckapi[filter][0][note] = $note1a ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_filter() ;
	exapi_footer() ;

?>
