<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.comm.inc.php 0.13.1 2005/06/15 C K Wu

    class comm {

//---- Comm Data Read

    function comm_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$table = $ckapi[params][table] ;
	$id = $ckapi[params_post][id] ;
	$catid = ($_GET["catid"]) ? $_GET["catid"] : $_POST["catid"] ;

	$result = $adodb->query("SELECT * FROM $table WHERE id='$id'");
	$dt = $result->fetchRow() ;
	if ($table=="${pre}org")	$dt[name] = $dt[orgnumber] ;
	if ($table=="${pre}person")	$dt[name] = $dt[prsnumber] ;

	$result = $adodb->query("SELECT * FROM ${pre}category WHERE id='$catid'");
	$dt[description] = $result->fields('description') ;
	$dt[catid] = $catid ;
	
	$lang_comm = strtolower(exapi_lang('comm')) ;
	$sql = "SELECT a.* FROM ${pre}comm a, ${pre}category b, ${pre}category c " ;
	$sql.= "WHERE contactid='$id' and commcode=c.name and c.parent=b.id and b.id= '$catid' order by commcode" ;
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['preferred'.$i]	=	$rs['preferred'] ;
		$dt['commdata'.$i]	=	$rs['commdata'] ;
		$dt['commcode'.$i]	=	$rs['commcode'] ;
		}
	return $dt ;
	}

//---- comm Validation Checks

    function comm_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$result = $adodb->query("SELECT name FROM ${pre}category WHERE id='$dt[catid]'");
	$name = strtolower($result->fields('name')) ;
	if ($name==strtolower(exapi_lang('email')))						$emailaddr = True ;
	if ($name==exapi_lang('phone') or $name==exapi_lang('mphone') or $name==exapi_lang('fax'))	$phoneno = True ;
	$err=""; $error=exapi_lang("Error") ;
	$row = exapi_lang("Row") ;
	$pr = "" ;
	For ($i=1;isset($dt['commcode'.$i]);$i++) {
		$commdata = $dt['commdata'.$i] ;
		if ($commdata=='')			$err="[$row $i]".exapi_lang("Contact Communication Data Missing") ;
		if ($dt['preferred'.$i]=='y')
			if ($pr<>"")	$err="[$row $i]".exapi_lang("More than one [preferred] communication data");	else $pr="1";
		if ($phoneno and ereg('[^0-9+\-]',$commdata))	$err="[$row $i]".exapi_lang("Phone# like Communication Data can only contain [0-9,-,+]") ;
		if ($emailaddr and strpos($commdata,'@')=='')	$err="[$row $i]".exapi_lang("Email must contain [@] char") ;
		}
	
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Emergency Contact Header

    function comm_header_write() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_name',exapi_lang('Person Name/# :'));
	$t->set_var('lang_id',exapi_lang('Audit Id :'));
	$t->set_var('name',$dt[name]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('catid',$dt[catid]) ;
	$t->set_var('table',$ckapi[params][table]) ;
	$t->set_var('description',$dt[description]) ;
	$t->parse('out','report',True);
	}

//---- Write Emergency Contact Detail

    function comm_detail_write() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;

	$row_ = exapi_lang('Row')." " ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',exapi_lang('Insert<br>before'));
	$t->set_var('lang_preferred',exapi_lang("Preferred"));
	$t->set_var('lang_commdata',exapi_lang("Contact Communication Data")." - $dt[description]");
	$t->set_var('lang_commcode',exapi_lang("CommData Code -- Description") );
	$t->set_var('lang_delete',exapi_lang('Delete'));

	$lang_no = exapi_lang("no") ;
	$lang_yes = exapi_lang("yes") ;
	$preferred_sl = "<OPTION value='n'>n -- $lang_no</OPTION><OPTION value='y'>y -- $lang_yes</OPTION>" ;
	$where = "WHERE parent='$dt[catid]'" ;
	$commcode_sl = selectlist('category','name',$where,'','name','name','substring(description,1,25)') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['commcode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('preferred_fld','preferred'.$i) ;
			$t->set_var('commdata_fld','commdata'.$i) ;
			$t->set_var('commcode_fld','commcode'.$i) ;
			$t->set_var('preferred_selectlist',$preferred_sl) ;
			$t->set_var('commdata','') ;
			$t->set_var('commcode_selectlist',$commcode_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$preferred	=	$dt['preferred'.$i] ;
		$commcode	=	$dt['commcode'.$i] ;

		$t->set_var('preferred_fld','preferred'.$j) ;
		$t->set_var('commdata_fld','commdata'.$j) ;
		$t->set_var('commcode_fld','commcode'.$j) ;

		$t->set_var('preferred_selectlist',str_replace("'$preferred'","'$preferred' selected",$preferred_sl)) ;
		$t->set_var('commdata',$dt['commdata'.$i]) ;
		$t->set_var('commcode_selectlist',str_replace("'$commcode'","'$commcode' selected",$commcode_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('preferred_fld','preferred'.$i) ;
		$t->set_var('commdata_fld','commdata'.$i) ;
		$t->set_var('commcode_fld','commcode'.$i) ;
		$t->set_var('preferred_selectlist',$preferred_sl) ;
		$t->set_var('commdata','') ;
		$t->set_var('commcode_selectlist',$commcode_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

//---- Emergency Contact Post - PreCommit Routine

    function comm_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new') {
		$result = $adodb->query("SELECT b.name FROM ${pre}category a, ${pre}category b WHERE a.id='$dt[catid]' and b.parent=a.id");
		while ($rs=$result->fetchRow())		$mask.= ".$rs[name]." ;
		if ($ckapi[hostsys][dbtype]=='mysql')	$matched = "instr('$mask',commcode)>0" ;
			else				$matched = "strpos('$mask',commcode)>0" ;
		$adodb->query("DELETE FROM ${pre}comm where contactid='$id' and $matched");
		}
	if ($op<>'delete') {
		For ($i=1;isset($dt['commcode'.$i]);$i++) {
			$preferred = $dt['preferred'.$i] ;
			$commdata = $dt['commdata'.$i] ;
			$commcode = $dt['commcode'.$i] ;
			$sql = "INSERT INTO ${pre}comm (contactid,preferred,commdata,commcode) " ;
			$sql.= "VALUES ('$id','$preferred','$commdata','$commcode')" ;
			$adodb->query($sql);
			}
		}
	}

    }

?>

