<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// controlreport.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-crm' ;
	$tran = 'control' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$rdate = ($_GET["rdate"]) ? $_GET["rdate"] : $_POST["rdate"] ;

/*---------------------------------------------------------------------------------*/

	$t = ckapi_tpl($app);
	$t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('message',"");
	$t->set_var('lang_control_report', exapi_lang('Customer Relationship Audit Control Report'));
	$t->set_var('lang_requested_status', exapi_lang('REQUESTED STATUS'));
	$t->set_var('lang_system_status', exapi_lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_date', exapi_lang('Status Date'));
	$t->set_var('lang_system_date', exapi_lang('System Date'));
	$t->set_var('lang_customer', exapi_lang('Customer'));
	$t->set_var('lang_contract', exapi_lang('Contract'));
	$t->set_var('lang_helpcase', exapi_lang('Helpdesk cases'));
	$t->set_var('lang_helpcall', exapi_lang('Help calls'));
	$t->set_var('lang_salecase', exapi_lang('Sales cases'));
	$t->set_var('lang_salecall', exapi_lang('Sale calls'));
	$t->set_var('lang_category', exapi_lang('CRM category'));
	$t->set_var('lang_status_asof', exapi_lang('Status as of'));
	$t->set_var('lang_total_count', exapi_lang('Total Record Count'));
	$t->set_var('lang_latest_id', exapi_lang('Latest Audit Trail ID'));

/*-----------------Gather and Write Database Info---------------------------------*/

$na = exapi_lang("N/A") ;
$t->set_var('status_date',$rdate) ;
$t->set_var('customer_count',$na) ;
$t->set_var('latest_customer_id',$na) ;
$t->set_var('contract_count',$na) ;
$t->set_var('latest_contract_id',$na) ;
$t->set_var('category_count',$na) ;
$t->set_var('latest_category_id',$na) ;

$result = $adodb->query("SELECT count(id) as cnt, max(id) as max_id from ${pre}helpcase WHERE start<='$rdate'");
$t->set_var('helpcase_count',$result->fields('cnt')) ;
$t->set_var('latest_helpcase_id',$result->fields('max_id')) ;

$sql = "SELECT count(a.id) as cnt, max(a.id) as max_id from ${pre}helpcall a, ${pre}helpcase b ";
$sql.= "WHERE caseid=b.id and start<='$rdate'" ;
$result = $adodb->query($sql);
$t->set_var('helpcall_count',$result->fields('cnt')) ;
$t->set_var('latest_helpcall_id',$result->fields('max_id')) ;

$result = $adodb->query("SELECT count(id) as cnt, max(id) as max_id from ${pre}salecase WHERE start<='$rdate'");
$t->set_var('salecase_count',$result->fields('cnt')) ;
$t->set_var('latest_salecase_id',$result->fields('max_id')) ;

$sql = "SELECT count(a.id) as cnt, max(a.id) as max_id from ${pre}salecall a, ${pre}salecase b ";
$sql.= "WHERE caseid=b.id and start<='$rdate'" ;
$result = $adodb->query($sql);
$t->set_var('salecall_count',$result->fields('cnt')) ;
$t->set_var('latest_salecall_id',$result->fields('max_id')) ;


$t->set_var('system_date',date("Y-m-d",time())) ;

$result = $adodb->query("SELECT count(id) as cnt, max(id) as max_id from ${pre}customer");
$t->set_var('sys_customer_count',$result->fields('cnt')) ;
$t->set_var('sys_latest_customer_id',$result->fields('max_id')) ;

$result = $adodb->query("SELECT count(id) as cnt, max(id) as max_id from ${pre}scontract");
$t->set_var('sys_contract_count',$result->fields('cnt')) ;
$t->set_var('sys_latest_contract_id',$result->fields('max_id')) ;

$result = $adodb->query("SELECT count(id) as cnt, max(id) as max_id from ${pre}helpcase");
$t->set_var('sys_helpcase_count',$result->fields('cnt')) ;
$t->set_var('sys_latest_helpcase_id',$result->fields('max_id')) ;

$result = $adodb->query("SELECT count(id) as cnt, max(id) as max_id from ${pre}helpcall");
$t->set_var('sys_helpcall_count',$result->fields('cnt')) ;
$t->set_var('sys_latest_helpcall_id',$result->fields('max_id')) ;

$result = $adodb->query("SELECT count(id) as cnt, max(id) as max_id from ${pre}salecase");
$t->set_var('sys_salecase_count',$result->fields('cnt')) ;
$t->set_var('sys_latest_salecase_id',$result->fields('max_id')) ;

$result = $adodb->query("SELECT count(id) as cnt, max(id) as max_id from ${pre}salecall");
$t->set_var('sys_salecall_count',$result->fields('cnt')) ;
$t->set_var('sys_latest_salecall_id',$result->fields('max_id')) ;

$result = $adodb->query("SELECT count(id) as category_count, max(id) as max_id from ${pre}category WHERE app='$app'");
$t->set_var('sys_category_count',$result->fields('category_count')) ;
$t->set_var('sys_latest_category_id',$result->fields('max_id')) ;


/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report');
	exapi_footer() ;

?>
