<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// customerbulk.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-crm' ;
	$tran = 'customer' ;
	$noheader = $nonavbar = True ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$start = ($_GET["start"]) ? $_GET["start"] : $_POST["start"] ;
	$end = ($_GET["end"]) ? $_GET["end"] : $_POST["end"] ;
	$sdate = ($_GET["sdate"]) ? $_GET["sdate"] : $_POST["sdate"] ;
	$email = ($_GET["email"]) ? $_GET["email"] : $_POST["email"] ;
	$filter=stripslashes($filter);

	$t = ckapi_tpl($app);
	$t->set_file(array('report'		=> "${tran}statement.tpl",
 	                   'items'		=> "${tran}statement.tpl"));
	$t->set_block('items','item_row','item_section');
	$t->set_var('charset',exapi_lang('charset'));
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$logofile = $ckapi[hostsys][dataarea]."/images/logo.png" ;
	$t->set_var('logo',exapi_link("/ck-admin/logoview_image.php","imgfile=$logofile"));

	$err=""; $error=exapi_lang("Error") ;
	if (isset($start))	{
		if (input2date($start)=="")	$err=exapi_lang('Invalid Statement Start Date');
		$jdstart = mktime(0,0,0,intval(substr($start,5,2)),intval(substr($start,8,2)),intval(substr($start,0,4))) ;
		}
	if (isset($end))	{
		if (input2date($end)=="")	$err=exapi_lang('Invalid Statement End Date');
		$jdend = mktime(0,0,0,intval(substr($end,5,2)),intval(substr($end,8,2)),intval(substr($end,0,4))) ;
		}
	if (isset($sdate))	{
		if (input2date($sdate)=="")	$err=exapi_lang('Invalid Statement Date');
		$jdsdate = mktime(0,0,0,intval(substr($sdate,5,2)),intval(substr($sdate,8,2)),intval(substr($sdate,0,4))) ;
		}
	if ($jdstart>$jdend)			$err=exapi_lang('Statement Start later than Statement End');
	if ($jdsdate<$jdend)			$err=exapi_lang('Statement date earlier than Statement End');

	if ($err)	$err="<b>$error: $err</b>" ;

	$start = (!$start) ? date("Y-m-d",mktime(0,0,0,date("m")-1,1,date("Y"))) : $start ;
	$end = (!$end) ? date("Y-m-d",mktime(0,0,0,date("m"),0,date("Y"))) : $end ;
	$sdate = (!$sdate) ? date("Y-m-d") : $sdate ;

	if ($email==exapi_lang('Email Statement') and $err=="") {
		$getstring = "start=$start&end=$end&sdate=$sdate&" ;
		$getstring.= "order=$order&sort=$sort&filter=$filter" ;
		Header('Location: '.exapi_link("/$app/${tran}bulkemail.php",$getstring)) ;
		exit();
		}

/*------------- Write Statement Header to Screen Display ----------------------------*/

	$t->set_var('lang_statement',exapi_lang('*** STATEMENT ***'));
	$t->set_var('lang_start',exapi_lang('Statement Start'));
	$t->set_var('start',$start) ;
	$t->set_var('lang_end',exapi_lang('Statement End'));
	$t->set_var('end',$end) ;
	$t->set_var('lang_sdate',exapi_lang('Statement Date'));
	$t->set_var('sdate',$sdate) ;
	$t->set_var('lang_customer',exapi_lang('Customer:'));

	$t->set_var('lang_transdate',exapi_lang('Date'));
	$t->set_var('lang_duedate',exapi_lang('Due Date'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_isocode',exapi_lang('Currency'));
	$t->set_var('lang_invoice_amount',exapi_lang('Invoice<br>Amount'));
	$t->set_var('lang_payment_received',exapi_lang('Payment<br>Received'));
	$t->set_var('lang_balance',exapi_lang('Balance'));
	$t->set_var('lang_remark',exapi_lang('Remark'));

	$result = $adodb->query("SELECT * FROM ${pre}defaults");
	$company = $result->fields('company') ;
	$comemail = $result->fields('email') ;
	$inv_rmkid = $result->fields('inv_rmkid') ;

	$result = $adodb->query("SELECT * FROM ${pre}remark WHERE id='$inv_rmkid'");
	$footer = $result->fields('detail') ;

	$result = $adodb->query("SELECT * FROM ${pre}customer a, ${pre}org b WHERE a.id='$id' and contactid=b.id");
	if ($result->RecordCount()>0) {
		$custname = $result->fields('orgname') ;
		$emailname = exapi_lang('Accounts Department') ;
		$contactid = $result->fields('contactid') ;
		}
	  else	{
		$result = $adodb->query("SELECT * FROM ${pre}customer a,${pre}person b WHERE a.id='$id' and contactid=b.id");
		$custname = $emailname = strtoupper($result->fields('family'))." ".$result->fields('given') ;
		$contactid = $result->fields('contactid') ;
		}
	
	$t->set_var('name',$custname) ;
	$result = $adodb->query("SELECT * FROM ${pre}comm WHERE contactid='$contactid' and commcode='bemail'");
	$custemail = $result->fields('commdata') ;
	$result = $adodb->query("SELECT * FROM ${pre}address WHERE contactid='$contactid' and addresscode='billaddr'");
	$t->set_var('addr1',$result->fields('line1')) ;
	$t->set_var('addr2',$result->fields('line2')) ;
	$t->set_var('addr3',$result->fields('line3')) ;
	$t->set_var('addr4',$result->fields('line4')) ;
	$t->set_var('comment1',"") ;
	$t->set_var('comment2',"") ;
	$t->set_var('comment3',"") ;
	$t->set_var('comment4',exapi_lang("For Credit Balance, there is no need to pay/remit")) ;

/*---------------------------------------------------------------------------------*/

if ($err=="")	{
	$user = $ckapi[hostsys][username];
	$temp0 = "${pre}arst0".$user.time() ;
	$temp1 = "${pre}arst1".$user.time() ;
	$temp2 = "${pre}arst2".$user.time() ;

/*------------Collect all transactions related to this customer ($temp1)------------------*/
	$sql =	"CREATE TABLE $temp1 AS " ;
	$sql.=	"SELECT 'i' as flag,transdate,duedate,isocode,amount,invnumber as description " ;
	$sql.=	"FROM ${pre}ar WHERE customer='$id' and transdate<='$end'" ;
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 (flag,transdate,isocode,amount,description) " .
		"SELECT 'r',transdate, isocode, -amount, rptnumber FROM ${pre}receipt " .
		"WHERE customer='$id' and transdate<='$end'" ;
	$adodb->query($sql);

/*------------Create intra period detail transactions ($temp2)----------------------------*/

	$adodb->query("CREATE TABLE $temp2 AS SELECT * FROM $temp1 WHERE transdate>='$start' and transdate<='$end'");

/*------------Calculate and Print beginning balance-----------------------------------------*/

	$where = "WHERE customer=$id and transdate<'$start'" ;
	$adodb->query("CREATE TABLE $temp0 AS SELECT isocode,amount FROM ${pre}ar $where");
	$adodb->query("INSERT INTO $temp0 (isocode,amount) SELECT isocode, -amount FROM ${pre}receipt $where");
	$result = $adodb->query("SELECT isocode,sum(amount) as amount from $temp0 GROUP BY isocode");

	if ($result->RecordCount()==0) {
		$t->set_var(array('transdate'	=> $start,
				'duedate'	=> "",
				'description'	=> exapi_lang("Bal. Brought Forward"),
				'isocode'	=> "" ,
				'invamt'	=> "",
				'rptamt'	=> "",
				'balance'	=> 0 ,
	      	    		'remark'	=> "" ));
		$t->parse('item_section','item_row',true);
		}
	While ($rs=$result->fetchRow()) {
		$amount = $rs['amount'] ;
		$remark = ($amount<0) ? exapi_lang('[CR]') : "" ;
		$t->set_var(array('transdate'	=> $start,
				'duedate'	=> "",
				'description'	=> exapi_lang("Bal. Brought Forward"),
				'isocode'	=> $rs['isocode'] ,
				'invamt'	=> "",
				'payamt'	=> "",
				'balance'	=> $amount ,
	      	    		'remark'	=> $remark ));
		$t->parse('item_section','item_row',true);
		}
	$t->set_var(array('transdate'	=> "",
			'duedate'	=> "",
			'description'	=> "",
			'isocode'	=> "" ,
			'invamt'	=> "",
			'payamt'	=> "",
			'balance'	=> "" ,
      	    		'remark'	=> "" ));
	$t->parse('item_section','item_row',true);

/*------------Obtain and Print Intra-Period Transactions-----------------------------------------*/

	$result = $adodb->query("SELECT * FROM $temp2 ORDER BY transdate");
	While ($rs=$result->fetchRow()) {
		$remark = "" ;
		$flag = $rs['flag'] ;
		$transdate = $rs['transdate'] ;
		$duedate = ($flag=="i") ? $rs['duedate'] : "" ;
		$description = $rs['description'] ;
		$isocode = $rs['isocode'] ;
		$age = $rs['age'] ;
		$invamt = ($flag=="i") ? $rs['amount'] : "" ;
		$rptamt = ($flag=="r") ? -$rs['amount'] : "" ;
		$remark = ($flag=="r") ? exapi_lang("THANK YOU") : $remark ;
		$t->set_var(array(	'transdate'	=> $transdate,
					'duedate'	=> $duedate,
					'description'	=> $description,
					'isocode'	=> $isocode,
					'invamt'	=> $invamt,
					'rptamt'	=> $rptamt,
					'balance'	=> "",
	     	 	    		'remark'	=> $remark ));
		$t->parse('item_section','item_row',true);
		}
	$t->set_var(array('transdate'	=> "",
			'duedate'	=> "",
			'description'	=> "",
			'isocode'	=> "" ,
			'invamt'	=> "",
			'rptamt'	=> "",
			'balance'	=> "" ,
      	    		'remark'	=> "" ));
	$t->parse('item_section','item_row',true);

/*------------Calculate and Print Ending balance-----------------------------------------*/

	$adodb->query("DROP TABLE $temp0");
	$adodb->query("CREATE TABLE $temp0 AS SELECT isocode,amount FROM $temp1");
	$result = $adodb->query("SELECT isocode,sum(amount) as amount from $temp0 GROUP BY isocode");
	if ($result->RecordCount()==0) {
		$t->set_var(array('transdate'	=> $end,
				'duedate'	=> "",
				'description'	=> exapi_lang("Bal. Carried Forward"),
				'isocode'	=> "" ,
				'invamt'	=> "",
				'rptamt'	=> "",
				'balance'	=> 0 ,
	      	    		'remark'	=> "" ));
		$t->parse('item_section','item_row',true);
		}
	While ($rs=$result->fetchRow()) {
		$amount = $rs['amount'] ;
		$remark = ($amount<0) ? exapi_lang('[CR]') : "" ;
		$t->set_var(array('transdate'	=> $end,
				'duedate'	=> "",
				'description'	=> exapi_lang("Bal. Carried Forward"),
				'isocode'	=> $rs['isocode'] ,
				'invamt'	=> "",
				'rptamt'	=> "",
				'balance'	=> $amount ,
	      	    		'remark'	=> $remark ));
		$t->parse('item_section','item_row',true);
		}

/*-------------Print Others --------------------------------------------*/

	$t->set_var('lang_thank',exapi_lang("Thank you for your continuous patronage")) ;
	$t->set_var('lang_footer',$footer) ;

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title =exapi_lang('If the sample displayed is OK, press [Email ...] button to start bulk despatch');
	$t->set_var('lang_title',$title);
	$note1=exapi_lang('For email function to work, your email/DNS environment must be properly setup.');
	$t->set_var('lang_note1',$note1);
	$note2=exapi_lang('To generate statement of a different period, modify the appropriate statement field(s), then press regenerate.');
	$t->set_var('lang_note2',$note2);

	$adodb->query("DROP TABLE $temp0");
	$adodb->query("DROP TABLE $temp1");
	$adodb->query("DROP TABLE $temp2");

	}
else {
 	$t->set_var('lang_title',$err);
	$t->set_var('item_section',"") ;
	$t->set_var('lang_thank',"") ;
	$t->set_var('lang_footer',"") ;
	$t->set_var('lang_note1',"");
	$t->set_var('lang_note2',"");
	}

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('regenerate_action',exapi_link("/$app/${tran}bulk.php","id=$id&order=$order&sort=$sort&filter=$filter")) ;
	$t->set_var('lang_regenerate',exapi_lang('Regenerate Statement'));
	$t->set_var('lang_email',exapi_lang('Email Statement'));

	$t->set_var('done_action',exapi_link("/$app/${tran}list.php","order=$order&sort=$sort&filter=$filter"));
	$t->set_var('lang_done',exapi_lang('Done'));

	$t->pparse('out','items',report);
	exapi_footer() ;

?>
