<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.rights.inc.php 0.13.1 2005/06/15 C K Wu

    class rights {

//---- Rights List SQL Formation

    function rights_list_sql() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$result = $adodb->query("SELECT * from ${pre}defaults");
	$attrib1cap = $result->fields('attrib1cap') ;
	$attrib2cap = $result->fields('attrib2cap') ;
	$attrib3cap = $result->fields('attrib3cap') ;
	$attrib1tbl = $result->fields('attrib1tbl') ;
	$attrib2tbl = $result->fields('attrib2tbl') ;
	$attrib3tbl = $result->fields('attrib3tbl') ;
	$user = $ckapi[hostsys][username];
	$temp = "${pre}rl".$user.time() ;
	$adodb->query("CREATE TABLE $temp (caption text,rtable text)");
	$adodb->query("INSERT INTO $temp (caption,rtable) VALUES ('$attrib1cap', '$attrib1tbl')");
	$adodb->query("INSERT INTO $temp (caption,rtable) VALUES ('$attrib2cap', '$attrib2tbl')");
	$adodb->query("INSERT INTO $temp (caption,rtable) VALUES ('$attrib3cap', '$attrib3tbl')");
	$sql =  "SELECT a.*,caption as attribute FROM ${pre}rights a,$temp b " ;
	$sql.=	"WHERE $where AND module='ck-css' AND a.rtable=b.rtable ORDER BY $order $sort";
	$ckapi[params_sql][temp] = $temp ;
	return $sql ;
	}

//---- Rights Read

    function rights_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$uniqueflds = $ckapi[params][uniqueflds] ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$result = $adodb->query("SELECT * from ${pre}rights WHERE id='$id'");
	$dt = $result->fetchRow() ;
	$result = $adodb->query("SELECT * from ${pre}defaults");
	$attribarr = array (	$result->fields('attrib1tbl') => $result->fields('attrib1cap'),
				$result->fields('attrib2tbl') => $result->fields('attrib2cap'),
				$result->fields('attrib3tbl') => $result->fields('attrib3cap')	) ;
	$attribtbl = $dt[rtable] ;
	$dt[attribute] = $attribarr[$attribtbl] ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- Rights Detail Validation Checks

    function rights_validate() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;

	$result = $adodb->query("SELECT * from ${pre}defaults");
	$attrib1cap = $result->fields('attrib1cap') ;
	$attrib2cap = $result->fields('attrib2cap') ;
	$attrib3cap = $result->fields('attrib3cap') ;
	$attrib1tbl = $result->fields('attrib1tbl') ;
	$attrib2tbl = $result->fields('attrib2tbl') ;
	$attrib3tbl = $result->fields('attrib3tbl') ;
	$attrib1sdesc = $result->fields('attrib1sdesc') ;
	$attrib2sdesc = $result->fields('attrib2sdesc') ;
	$attrib3sdesc = $result->fields('attrib3sdesc') ;

	$attribarr = array (	"$attrib1cap" => "$attrib1tbl",
				"$attrib2cap" => "$attrib2tbl",
				"$attrib3cap" => "$attrib3tbl"	) ;
	$attribsdesc = array (	"$attrib1cap" => "$attrib1sdesc",
				"$attrib2cap" => "$attrib2sdesc",
				"$attrib3cap" => "$attrib3sdesc"	) ;

	$err="";  $error=exapi_lang("Error") ;
	if ($dt[rgroup]=="")				$err=exapi_lang("User Group Missing") ;
	if ($dt[attribute]=="")				$err=exapi_lang("Attribute Missing");
	if ($dt[rvalue]=="")				$err=exapi_lang("Attribute Value Missing");
	if (!exapi_is_group($dt[rgroup]))		$err=exapi_lang("No such Host System Group exists") ;
	$caplist = "$attrib1cap,$attrib2cap,$attrib3cap" ;
	if (substr_count($caplist,$dt[attribute])<=0)	$err=exapi_lang("No such Attribute exists") ;
	  else	{
		$attribtbl = $attribarr[$dt[attribute]] ;
		$sdesc = $attribsdesc[$dt[attribute]] ;
		$result = $adodb->query("SELECT * from $attribtbl where $sdesc='$dt[rvalue]'");
		if ($result->RecordCount()<=0)		$err=exapi_lang("No such Attribute Value exists") ;
		if ($dt[rgroup]<>$dt[oldrgroup] or $dt[attribute]<>$dt[oldattribute] or $dt[rvalue]<>$dt[oldrvalue]) {
			$sql = "SELECT * from $table " ;
			$sql.= "WHERE rgroup='$dt[rgroup]' and module='ck-css' and " ;
			$sql.=		"rtable='$attribtbl' and rfield='$sdesc' and rvalue='$dt[rvalue]'" ;
			$result = $adodb->query($sql);
			if ($result->RecordCount()>0)	$err=exapi_lang("Group/Attribute/Value combination already exists");
			}
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Delete Validation Checks

    function delete_validate() {
	global $ckapi ;
	}

//---- Write Rights Detail

    function rights_write() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',exapi_lang('Audit ID:')."  ");
	$t->set_var('lang_rgroup',exapi_lang('User Group'));
	$t->set_var('lang_attribute',exapi_lang('Attribute'));
	$t->set_var('lang_rvalue',exapi_lang('Attribute Value'));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val","old$val");
	$t->set_var('rgroup',$dt[rgroup]);
	$t->set_var('attribute',$dt[attribute]);
	$t->set_var('rvalue',$dt[rvalue]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->parse('out','report',True);
	}

//---- Rights Post Initialisation

    function rights_post_init() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$dt[module] = "ck-css" ;
	$result = $adodb->query("SELECT * from ${pre}defaults");
	$attribarr = array (	$result->fields('attrib1cap') => $result->fields('attrib1tbl'),
				$result->fields('attrib2cap') => $result->fields('attrib2tbl'),
				$result->fields('attrib3cap') => $result->fields('attrib3tbl')	) ;
	$attribsdesc = array (	$result->fields('attrib1cap') => $result->fields('attrib1sdesc'),
				$result->fields('attrib2cap') => $result->fields('attrib2sdesc'),
				$result->fields('attrib3cap') => $result->fields('attrib3sdesc')	) ;
	$dt[rtable] = $attribarr[$dt[attribute]] ;
	$dt[rfield] = $attribsdesc[$dt[attribute]] ;
	}

    }

?>
