<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.achieve.inc.php 0.13.1 2005/06/15 C K Wu

    class achieve {

//---- Achievement Code Detail Validation Checks

    function achieve_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	if ($dt[name]=="")		$err=exapi_lang('Achievement Code Name Missing');
	if ($dt[description]=="")	$err=exapi_lang('Achievement description Missing');
	if (!is_numeric($dt[min]))	$err=exapi_lang('Min Level must be numeric');
	if (!is_numeric($dt[max]))	$err=exapi_lang('Max Level must be numeric');
	if (!is_numeric($dt[rate]))	$err=exapi_lang('Rate must be numeric');
	if (isset($dt[min]) and isset($dt[max]) and $dt[min]>$dt[max])
					$err=exapi_lang('Min Level > Max Level') ;
	if ($dt[name]<>$dt[oldname]) {
		$result = $adodb->query("SELECT * from ${pre}achievement where name='$dt[name]'");
		if ($result->RecordCount()>0)	$err = exapi_lang("Achievement Name already exists") ;
		}
	if ($err)			$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Achievement Code Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$errmsg1 = exapi_lang("This achievement is in use within an existing") ;
	$timesheet = exapi_lang("timesheet") ;
	$id = $dt[id] ;
	$result = $adodb->query("SELECT * from ${pre}ts_trans where achieve='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $timesheet id#".$result->fields('trans_id') ;
	if ($dt[name]=='not_applicable')
		$err = exapi_lang("Achievement 'not_applicable' should not be deleted") ;
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Achievement Code Detail

    function achieve_write() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',exapi_lang('Audit ID:')."  ");
	$t->set_var('lang_name',exapi_lang('Achievement Code Name'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_min',exapi_lang('Minimum Level'));
	$t->set_var('lang_max',exapi_lang('Maximum Level'));
	$t->set_var('lang_rate',exapi_lang('Pay Rate'));
	$id = $dt[id] ;
	$t->set_var('id',$id);
	$t->set_var('control',$dt[control]);
	$t->set_var('name',$dt[name]);
	$t->set_var('oldname',$dt[oldname]);
	$t->set_var('description',$dt[description]);
	$t->set_var('min',$dt[min]);
	$t->set_var('max',$dt[max]);
	$t->set_var('rate',$dt[rate]);
	$t->parse('out','report',True);
	}

    }

?>
