<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.ec.inc.php 0.13.1 2005/06/15 C K Wu

    class ec {

//---- Emergency Contact Read

    function ec_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$result = $adodb->query("SELECT * FROM ${pre}empperson WHERE id='$id'");
	$dt = $result->fetchRow() ;

	$result = $adodb->query("SELECT * FROM ${pre}ec where contactid='$id' order by eccode");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['prefix'.$i]	=	$rs['prefix'] ;
		$dt['family'.$i]	=	$rs['family'] ;
		$dt['given'.$i]		=	$rs['given'] ;
		$dt['suffix'.$i]	=	$rs['suffix'] ;
		$dt['contact'.$i]	=	$rs['contact'] ;
		$dt['relation'.$i]	=	$rs['relation'] ;
		$dt['eccode'.$i]	=	$rs['eccode'] ;
		$dt['preferred'.$i]	=	$rs['preferred'] ;
		}
	return $dt ;
	}

//---- ec Validation Checks

    function ec_validate() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error") ;
	$row = exapi_lang("Row") ;
	$ec1=$ec2=$ec3=$nk = "" ;
	For ($i=1;isset($dt['eccode'.$i]);$i++) {
		$family = $dt['family'.$i] ;
		$given = $dt['given'.$i] ;
		$contact = $dt['contact'.$i] ;
		if ($family=="")			$err="[$row $i]".exapi_lang("Family Name Missing");
		if ($given=="")				$err="[$row $i]".exapi_lang("Given Name Missing");
		if ($contact=="")			$err="[$row $i]".exapi_lang("Contact Phone# Missing");
		if ($contact<>"" and !is_numeric($contact))	$err="[$row $i]".exapi_lang("Contact Phone# must be numeric");
		switch ($dt['eccode'.$i]) :
			case "EC1" :	if ($ec1<>"") $err="[$row $i]".exapi_lang("Duplicate EC1 Emergency Contact"); $ec1="EC1";	break;
			case "EC2" :	if ($ec2<>"") $err="[$row $i]".exapi_lang("Duplicate EC2 Emergency Contact"); $ec2="EC2";	break;
			case "EC3" :	if ($ec3<>"") $err="[$row $i]".exapi_lang("Duplicate EC3 Emergency Contact"); $ec3="EC3";	break;
			case "NK" :	if ($nk<>"") $err="[$row $i]".exapi_lang("Duplicate NK Emergency Contact") ;	$nk="NK";	break;
			endswitch ;
		}
	if ($i>1) {
		if ($ec1==""	)	$err = exapi_lang("Emergency Contact 1 missing") ;
		if ($nk=="")		$err = exapi_lang("Next of Kin Emergency Contact missing") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Emergency Contact Header

    function ec_header_write() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_prsnumber',exapi_lang('Personal Record Name/# :'));
	$t->set_var('lang_id',exapi_lang('Audit Id :'));
	$t->set_var('prsnumber',$dt[prsnumber]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('disabled','');
	$t->parse('out','report',True);
	}

//---- Write Emergency Contact Detail

    function ec_detail_write() {
	global $ckapi ;

	$app = $ckapi[params][app] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;

	$row_ = exapi_lang('Row')." " ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',exapi_lang('Insert<br>before'));
	$t->set_var('lang_preferred',exapi_lang('Preferred'));
	$t->set_var('lang_prefix',exapi_lang("Prefix"));
	$t->set_var('lang_family',exapi_lang("Family Name"));
	$t->set_var('lang_given',exapi_lang("Given Name"));
	$t->set_var('lang_suffix',exapi_lang("Suffix"));
	$t->set_var('lang_contact',exapi_lang("Contact Phone"));
	$t->set_var('lang_relation',exapi_lang("Relationship"));
	$t->set_var('lang_pointer',"=>");
	$t->set_var('lang_eccode',exapi_lang("EC Code -- Description") );
	$t->set_var('lang_delete',exapi_lang('Delete'));

	$blankopt = "<OPTION value=''></OPTION>" ;
	$lang_no = exapi_lang("no") ;
	$lang_yes = exapi_lang("yes") ;
	$preferred_sl = "<OPTION value='n'>n -- $lang_no</OPTION><OPTION value='y'>y -- $lang_yes</OPTION>" ;
	$lang_prefix = strtolower(exapi_lang('prefix')) ;
	$lang_suffix = strtolower(exapi_lang('suffix')) ;
	$lang_relation = strtolower(exapi_lang('relation')) ;
	$lang_ec = strtolower(exapi_lang('ec')) ;
	$prefix_sl = selectlist('category','name',"WHERE app='$app' and type='$lang_prefix'",'','name','name') ;
	$suffix_sl = $blankopt.selectlist('category','name',"WHERE app='$app' and type='$lang_suffix'",'','name','name') ;
	$relation_sl = selectlist('category','name',"WHERE app='$app' and type='$lang_relation'",'','name','name','substring(description,1,25)') ;
	$eccode_sl = selectlist('category','name',"WHERE app='$app' and type='$lang_ec'",'','name','name','substring(description,1,25)') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['eccode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('preferred_fld','preferred'.$i) ;
			$t->set_var('prefix_fld','prefix'.$i) ;
			$t->set_var('family_fld','family'.$i) ;
			$t->set_var('given_fld','given'.$i) ;
			$t->set_var('suffix_fld','suffix'.$i) ;
			$t->set_var('contact_fld','contact'.$i) ;
			$t->set_var('relation_fld','relation'.$i) ;
			$t->set_var('eccode_fld','eccode'.$i) ;
			$t->set_var('prefix_selectlist',$prefix_sl) ;
			$t->set_var('family','') ;
			$t->set_var('given','') ;
			$t->set_var('suffix_selectlist',$suffix_sl) ;
			$t->set_var('contact','') ;
			$t->set_var('relation_selectlist',$relation_sl) ;
			$t->set_var('eccode_selectlist',$eccode_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$preferred	=	$dt['preferred'.$i] ;
		$prefix		=	$dt['prefix'.$i] ;
		$suffix		=	$dt['suffix'.$i] ;
		$relation	=	$dt['relation'.$i] ;
		$eccode		=	$dt['eccode'.$i] ;

		$t->set_var('preferred_fld','preferred'.$j) ;
		$t->set_var('prefix_fld','prefix'.$j) ;
		$t->set_var('family_fld','family'.$j) ;
		$t->set_var('given_fld','given'.$j) ;
		$t->set_var('suffix_fld','suffix'.$j) ;
		$t->set_var('contact_fld','contact'.$j) ;
		$t->set_var('relation_fld','relation'.$j) ;
		$t->set_var('eccode_fld','eccode'.$j) ;

		$t->set_var('preferred_selectlist',str_replace("'$preferred'","'$preferred' selected",$preferred_sl)) ;
		$t->set_var('prefix_selectlist',str_replace("'$prefix'","'$prefix' selected",$prefix_sl)) ;
		$t->set_var('family',$dt['family'.$i]) ;
		$t->set_var('given',$dt['given'.$i]) ;
		$t->set_var('suffix_selectlist',str_replace("'$suffix'","'$suffix' selected",$suffix_sl)) ;
		$t->set_var('contact',$dt['contact'.$i]) ;
		$t->set_var('relation_selectlist',str_replace("'$relation'","'$relation' selected",$relation_sl)) ;
		$t->set_var('eccode_selectlist',str_replace("'$eccode'","'$eccode' selected",$eccode_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('preferred_fld','preferred'.$i) ;
		$t->set_var('prefix_fld','prefix'.$i) ;
		$t->set_var('family_fld','family'.$i) ;
		$t->set_var('given_fld','given'.$i) ;
		$t->set_var('suffix_fld','suffix'.$i) ;
		$t->set_var('contact_fld','contact'.$i) ;
		$t->set_var('relation_fld','relation'.$i) ;
		$t->set_var('eccode_fld','eccode'.$i) ;
		$t->set_var('preferred_selectlist',$preferred_sl) ;
		$t->set_var('prefix_selectlist',$prefix_sl) ;
		$t->set_var('family','') ;
		$t->set_var('given','') ;
		$t->set_var('suffix_selectlist',$suffix_sl) ;
		$t->set_var('contact','') ;
		$t->set_var('relation_selectlist',$relation_sl) ;
		$t->set_var('eccode_selectlist',$eccode_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

//---- Emergency Contact Post - PreCommit Routine

    function ec_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')		$adodb->query("DELETE FROM ${pre}ec where contactid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['eccode'.$i]);$i++) {
			$preferred = $dt['preferred'.$i] ;
			$prefix = $dt['prefix'.$i] ;
			$family = addslashes($dt['family'.$i]) ;
			$given = addslashes($dt['given'.$i]) ;
			$suffix = $dt['suffix'.$i] ;
			$contact = $dt['contact'.$i] ;
			$relation = $dt['relation'.$i] ;
			$eccode = $dt['eccode'.$i] ;
			$sql = "INSERT INTO ${pre}ec(contactid,preferred,prefix,family,given,suffix,contact,relation,eccode) " ;
			$sql.= "VALUES('$id','$preferred','$prefix','$family','$given','$suffix','$contact','$relation','$eccode')" ;
			$adodb->query($sql);
			}
		}
	}

    }

?>

