<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.ia.inc.php 0.13.1 2005/06/15 C K Wu

    class ia {

//---- Inventory Adjustment List SQL Formation

    function ia_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$sql =  "SELECT * from ${pre}il WHERE substring(source,1,2)='IA' $where order by ".$order." ".$sort;
	return $sql ;
	}

//---- Inventory Adjustment Read

    function ia_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$result = $adodb->query("SELECT * from ${pre}il where id=$id");
	$dt = $result->fetchRow() ;

	$result = $adodb->query("SELECT * from ${pre}inv_trans WHERE trans_id='$id'");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['part'.$i]	=	$rs['parts_id'] ;
		$dt['qty'.$i]	=	$rs['qty'] ;
		if ($op=="reverse")	$dt['qty'.$i] = -$rs['qty'] ;
		}
	if ($ckapi[params_post][op]=="view")	$dt[controltot] = exapi_lang("N/A") ;
	return $dt ;
	}

//---- Inventory Adjustment Add Initialisation

    function ia_add_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$dt['part1'] = $dt['qty1'] = "";
	}

//---- Inventory Adjustment Validation Checks

    function ia_validate() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error") ;
	$date=input2date( $dt[transdate] ) ;
	if ($date=="")				$err=exapi_lang("Invalid Inventory Adjustment Date");
	if ($dt["description"]=="")		$err=exapi_lang("IA Description Missing") ;
	$totalqty = $totalamt = 0 ;
	For ($i=1;isset($dt['part'.$i]);$i++) {
		$row = exapi_lang("Row") ; $rowi = "[$row $i]" ;
		if ($dt['qty'.$i] and !is_numeric($dt['qty'.$i]))
						$err=$rowi.exapi_lang("Invalid Qty, must be numeric");
		if ($dt['qty'.$i]==0)		$err=$rowi.exapi_lang("Invalid Qty, must be non-zero");
		$totalqty += $dt['qty'.$i] ;
		}
	if ($totalqty<>$dt[controltot])	$err=exapi_lang("Qty Total <> Inputted Control Total");
	if ($err)	$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Inventory Adjustment Header

    function ia_header_write() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_date',exapi_lang('Date :'));
	$t->set_var('lang_source',exapi_lang('Source :'));
	$t->set_var('lang_description',exapi_lang('Description :'));
	$t->set_var('lang_id',exapi_lang('Audit Id :'));
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('source',$dt[source]) ;
	$t->set_var('description',$dt[description]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->parse('out','report',True);
	}

//---- Write Inventory Adjustment Detail

    function ia_detail_write() {
	global $ckapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = exapi_lang('Row')." " ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_parts',exapi_lang('Part Number -- Description -- ID'));
	$t->set_var('lang_qty',exapi_lang('Quantity (+ve: increase stock, -ve: decrease stock)'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('lang_newrow',exapi_lang('Add New Row'));
	$part_list = selectlist('parts','partnumber','','','id','partnumber','description','id') ;
	if (isset($delete)) {$rowno = intval(str_replace($row_,"",$delete)); }
	For ($i=1;isset($dt['part'.$i]);$i++) {
		if ($i<>$rowno) {
			$part	=	$dt['part'.$i] ;
			$qty	=	$dt['qty'.$i];
			$j = ($delete and $i>$rowno) ? $i-1 : $i ;
			$t->set_var('part_fld','part'.$j) ;
			$t->set_var('qty_fld','qty'.$j);
			$t->set_var('parts_list',str_replace("'$part'","'$part' selected",$part_list));
			$t->set_var('qty',$qty) ;
			if ($posted)	$t->set_var('rowno',"done");	else	$t->set_var('rowno',$row_.$j);
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			}
		}
	if ($i==2 and $rowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('part_fld','part'.$i) ;
		$t->set_var('parts_list',$part_list);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('qty',"") ;
		$t->set_var('rowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('lang_controltot',exapi_lang('Quantity Control Total'));
	$t->set_var('controltot',$dt[controltot]) ;

	$t->parse('out','report',True);
	}

//---- Inventory Adjustment Post Initialisation

    function ia_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][source] = "IA" ;
	if ($ckapi[params_post][op]=="reverse")	$ckapi[params_post][op]="new" ;
	}

//---- Inventory Adjustment Post - PreCommit Routine

    function ia_post_precommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')		$adodb->query("DELETE from ${pre}inv_trans where trans_id='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['part'.$i]);$i++) {
			$part	= $dt['part'.$i];
			$qty	= $dt['qty'.$i];
			$sql = "INSERT INTO ${pre}inv_trans (trans_id,parts_id,qty,transdate)" ;
			$sql.= "VALUES ('$id','$part','$qty','$dt[transdate]')" ;
			$adodb->query($sql);
			}
		}
	}

//---- Inventory Adjustment Post - PostCommit Routine

    function ia_post_postcommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$lang_tran = $ckapi[phrases][lang_tran] ;
	$actioned = $ckapi[phrases][actioned] ;
	$acd = exapi_lang('ACD') ;
	$note = exapi_lang("Please carry out appropriate accounting adjustment") ;
	$inform = exapi_lang("Please manually inform") ;
	$from = exapi_lang("Inventory System") ;
	$noreply = exapi_lang("No-Reply-Address") ;

	$sql = "SELECT description,email FROM ${pre}department WHERE name='$acd'" ;
	$result = $adodb->query($sql);
	$deptdesc = $result->fields('description');
	$acdemail = $result->fields('email');
	$err = "" ;
	if (!$acdemail)					$err = exapi_lang("Accounts Department email missing") ;
	if ($acdemail and strpos($acdemail,'@')=='')	$err = exapi_lang("Invalid Accounts Department email") ; 

	if ($err) {
		$error=exapi_lang("Error") ; $noemail=exapi_lang("No email sent") ;
		$msg = "<br>$error: $err.  $noemail.  $inform $deptdesc." ;
		}
	  else	{	
		$recipient = "$deptdesc < $acdemail >" ;
		$subject = "$lang_tran [id#$id] $actioned.  $note." ;
		$message = '' ;
		$headers = "From: $from < $noreply >\n" ;
		$charset = exapi_lang('charset') ;
		$headers.= "Content-Type: text/html; charset=$charset \n" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = exapi_lang("Email advising inventory adjustment action successfully queued for despatch to") ;
		$failuremsg=exapi_lang("Email advising inventory adjustment action fails to deliver.")."  $inform";
		if ($result)	$msg = "<br>$successmsg $deptdesc." ;
			else	$msg = "<br>$failuremsg $deptdesc." ;
		}
	$ckapi[phrases]["reminder"] = $msg ;
	}

    }

?>