<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// attriblist.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-ledger' ;
	$tran = 'attrib' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$attrib = ($_GET["attrib"]) ? $_GET["attrib"] : $_POST["attrib"] ;
	$caption = ($_GET["caption"]) ? $_GET["caption"] : $_POST["caption"] ;
	$table = ($_GET["table"]) ? $_GET["table"] : $_POST["table"] ;
	$sdfld = ($_GET["sdfld"]) ? $_GET["sdfld"] : $_POST["sdfld"] ;
	$ldfld = ($_GET["ldfld"]) ? $_GET["ldfld"] : $_POST["ldfld"] ;
	$qfield = ($_GET["qfield"]) ? $_GET["qfield"] : $_POST["qfield"] ;
	$filter = urldecode(stripslashes($filter)) ;
	$where = decode_where($filter,$table,$attrib) ;
	$filter = urlencode($filter) ;

	$attrib = isset($attrib) ? $attrib : $qfield ;
	$qfield = $attrib ;

	$t = ckapi_tpl($app);
	$proc = newobj('ck-api','process') ;
	$t->set_file(array('report'=>"${tran}list.tpl", 'detail'=>"${tran}list.tpl"));
	$t->set_block('detail','detail_row','detail_section');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$msg1 = exapi_lang("This is for illustrative purpose only.") ;
	$msg2.= exapi_lang("Other modules will provide better facility to process these data.") ;
	$t->set_var('message',"$msg1  $msg2");

//---------------------------- list variable template-declarations -------------------------

	$result = $adodb->query("Select * from ${pre}defaults");
	switch ($attrib) :
		case "1" :	$sdfld=$result->fields('attrib1sdesc');
				$ldfld=$result->fields('attrib1ldesc');
				$caption=$result->fields('attrib1cap'); break ;
		case "2" :	$sdfld=$result->fields('attrib2sdesc');
				$ldfld=$result->fields('attrib2ldesc');
				$caption=$result->fields('attrib2cap'); break ;
		case "3" :	$sdfld=$result->fields('attrib3sdesc');
				$ldfld=$result->fields('attrib3ldesc');
				$caption=$result->fields('attrib3cap'); break ;
		endswitch ;
	$t->set_var('lang_title',exapi_lang("List of %1",$caption));
	$t->set_var('lang_sorthead',exapi_lang('[click column heading to re-sort table]'));
	$script = "/$app/${tran}list.php" ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var('sort_sdesc',$proc->sortlink($sdfld,$script,"$sdfld",$sort,$getstr));
	$t->set_var('sort_ldesc',$proc->sortlink($ldfld,$script,"$ldfld",$sort,$getstr));
	$t->set_var('sort_id',$proc->sortlink(exapi_lang('Audit Id'),$script,'id',$sort,$getstr));

	if (!$order) $order = $sdfld ;
	if (!$sort)  $sort = "ASC" ;
	$result = $adodb->query("SELECT * from $table WHERE 1=1 $where order by $order $sort");

// -------------------------------- end declaration -----------------------------------------

if ($result->RecordCount()==0) {
	$t->set_var(array(	'sdesc'		=> exapi_lang("No Matching Item Found"),
				'ldesc'		=> "",
				'id'		=> "",
				'lang_view'	=> "",
				'lang_edit'	=> "",
				'lang_copy'	=> "",
				'lang_delete'	=> "",
				'lang_log'	=> "" ));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail_row',True);
	}
While ($rs=$result->fetchRow()) {
	$id = $rs['id'] ;
	$getstr = "id=$id&attrib=$attrib&caption=$caption&" ;
	$getstr.= "table=$table&sdfld=$sdfld&ldfld=$ldfld&filter=$filter" ;
	$loggetstr = "return=/$app/${tran}list.php&$getstr" ;
	$t->set_var(array(	'sdesc'		=> $rs["$sdfld"],
				'ldesc'		=> $rs["$ldfld"],
				'id'		=> $id,
				'view'	=> exapi_link("/$app/${tran}view.php",$getstr),
				'edit'	=> exapi_link("/$app/${tran}edit.php",$getstr),
				'copy'	=> exapi_link("/$app/${tran}copy.php",$getstr),
				'delete'=> exapi_link("/$app/${tran}delete.php",$getstr),
				'log'	=> exapi_link('/ck-admin/loglist.php',$loggetstr)  ));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->set_var('lang_add',exapi_lang("Add New %1",$caption));
	$t->set_var('add_action',exapi_link("/$app/${tran}add.php",$getstr));
	$t->set_var('lang_edit',exapi_lang('Edit'));
	$t->set_var('lang_view',exapi_lang('View'));
	$t->set_var('lang_copy',exapi_lang('Copy/Modify'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('lang_log',exapi_lang('Log'));
	$t->pparse('out','detail','report');
	exapi_footer() ;



//---- Decode 'where' filter string

    function decode_where($filter,&$table,&$attrib) {
	global $ckapi,$exapi ;

	if (trim($filter)<>"") {
//		$markpri = $ckapi['params']['markpri'] ;
//		$marksec = $ckapi['params']['marksec'] ;
		$markpri = "zzAnDzz" ;
		$marksec = "z2z1z3z" ;
		$pieces = explode($markpri,$filter) ;
		foreach ($pieces as $piece) {
			list($str1,$str2) = explode($marksec,$piece) ;
			$type = substr($str1,0,1) ;
			$str1 = substr($str1,1) ;
			if (strlen($str1)>15 or strlen($str2)>15) {
				echo "Please inform System Admin: Possible injected SQL attack -$piece==<br>";
				exit() ;
				}
			switch ($type) :
				case "x" :	$$str1 = $str2 ;			break ;
				case "0" :	$where .= "$str1 $str2" ;		break ;
				case "1" :	$where .= " AND $str1 = '$str2' " ;	break ;
				case "2" :	$where .= " AND $str1 >= '$str2' ";	break ;
				case "3" :	$where .= " AND $str1 > '$str2' ";	break ;
				case "4" :	$where .= " AND $str1 <= '$str2' ";	break ;
				case "5" :	$where .= " AND $str1 < '$str2' ";	break ;
				case "6" :	$where .= " AND lower($str1) like lower('%$str2%') ";  break;
				case "7" :	$where .= " AND OPEN " ;		break ;
//				case "8" :						break ;
				endswitch ;
			}
		}
	return $where ;
	}

?>
