<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// trialbalance.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-ledger' ;
	$tran = 'trialbalance' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$report_date = ($_GET["report_date"]) ? $_GET["report_date"] : $_POST["report_date"] ;
	$attrib1 = ($_GET["attrib1"]) ? $_GET["attrib1"] : $_POST["attrib1"] ;
	$attrib2 = ($_GET["attrib2"]) ? $_GET["attrib2"] : $_POST["attrib2"] ;
	$attrib3 = ($_GET["attrib3"]) ? $_GET["attrib3"] : $_POST["attrib3"] ;

	$t = ckapi_tpl($app);
	$t->set_file('report','trialbalance.tpl');
	$t->set_block('report','account_row','account_section');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_trial_balance', exapi_lang('TRIAL BALANCE'));
	
	if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
		$result = $adodb->query("Select * from ${pre}defaults");
		$a1cap = $result->fields('attrib1cap');	$a1tbl = $result->fields('attrib1tbl');	$a1ldf = $result->fields('attrib1ldesc');
		$a2cap = $result->fields('attrib2cap');	$a2tbl = $result->fields('attrib2tbl');	$a2ldf = $result->fields('attrib2ldesc');
		$a3cap = $result->fields('attrib3cap');	$a3tbl = $result->fields('attrib3tbl');	$a3ldf = $result->fields('attrib3ldesc');
		if ($attrib1<>'') {
			$result = $adodb->query("Select * from $a1tbl where id=$attrib1");
			$ldesc = $result->fields($a1ldf) ;
			$t->set_var('attrib1line',"$a1cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib1line',"");
		if ($attrib2<>'') {
			$result = $adodb->query("Select * from $a2tbl where id=$attrib2");
			$ldesc = $result->fields($a2ldf) ;
			$t->set_var('attrib2line',"$a2cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib2line',"");
		if ($attrib3<>'') {
			$result = $adodb->query("Select * from $a3tbl where id=$attrib3");
			$ldesc = $result->fields($a3ldf) ;
			$t->set_var('attrib3line',"$a3cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib3line',"");
		}
	   else {
		$t->set_var('attrib1line',"");
		$t->set_var('attrib2line',"");
		$t->set_var('attrib3line',"");
		}
	$t->set_var('lang_notes', exapi_lang('Click [Detail] to review journal history'));
	$t->set_var('lang_account_desc', exapi_lang('ACCOUNT NUMBER AND DESCRIPTION'));
	$t->set_var('lang_dr', exapi_lang('DEBIT'));
	$t->set_var('lang_cr', exapi_lang('CREDIT'));
	$t->set_var('lang_total', exapi_lang('TOTAL'));
	$t->set_var('lang_detail', exapi_lang('DETAIL'));

	$user = $ckapi[hostsys][username];
	$temp1 = "${pre}gl1".$user.time() ;
	$temp2 = "${pre}gl2".$user.time() ;

/*-----------------Write Account List and Balances---------------------------------*/

$sql =	"CREATE TABLE $temp2 AS " ;
$sql.=	"SELECT chart_id, 0.00 as dr, sum(amount) as cr FROM ${pre}acc_trans " ;
$sql.=	"WHERE transdate<='$report_date' " ;
if ($attrib1<>'')	$sql .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$sql .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$sql .= " and attrib3=$attrib3 " ;
$sql.=	"GROUP BY chart_id ORDER BY chart_id" ;
$adodb->query($sql);
$adodb->query("UPDATE $temp2 SET dr = -cr, cr = 0 WHERE cr < 0");
$sql =  "CREATE TABLE $temp1 AS " .
	"SELECT accno,description,dr,cr,chart_id FROM $temp2,${pre}chart WHERE chart_id=id order by accno" ;
$adodb->query($sql);
$result= $adodb->query("SELECT * from $temp1");
if ($result->RecordCount()==0) {
	$t->set_var('account_number','') ;
	$t->set_var('account_desc','');
	$t->set_var('dr_amount','-') ;
	$t->set_var('cr_amount','-') ;
	$t->parse('account_section','account_row',True);
	}
$dr_total = 0;
$cr_total = 0;
while ($res = $result->fetchRow()) {
	
	$accno			=	$res['accno'] ;
	$desc			=	$res['description'] ;
	$dr_amount		=	sprintf("%01.2f",$res['dr']);
	$cr_amount		=	sprintf("%01.2f",$res['cr']);
	$chart_id		=	$res['chart_id'] ;
	if ($dr_amount==0)		$dr_amount='-' ;
	if ($cr_amount==0)		$cr_amount='-' ;
	$dr_total		+=	$dr_amount ;
	$cr_total		+=	$cr_amount ;
	
	$markpri = "zzAnDzz" ;
	$filter = "${markpri}0id=$chart_id";
	$end = $report_date ;
	$getstr = "id=$chart_id&filter=$filter&attrib1=$attrib1&" ;
	$getstr.= "attrib2=$attrib2&attrib3=$attrib3&end=$end" ;
	$detail = exapi_link('/ck-ledger/accounthist.php',$getstr);
	$t->set_var('account_number',$accno) ;
	$t->set_var('account_desc',$desc);
	$t->set_var('dr_amount',$dr_amount) ;
	$t->set_var('cr_amount',$cr_amount) ;
	$t->set_var('detail',$detail) ;
	$t->parse('account_section','account_row', True);
	}

$t->set_var('total_dr',sprintf("%01.2f",$dr_total)) ;
$t->set_var('total_cr',sprintf("%01.2f",$cr_total)) ;

$adodb->query("DROP TABLE $temp1");
$adodb->query("DROP TABLE $temp2");

/*--------------------Write bottom Section------------------------------------------*/

    $t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
    $t->set_var('lang_done',exapi_lang('Done'));
    $t->pparse('out','report');
	exapi_footer() ;

?>
