<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// csntfilter.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-pos-c' ;
	$tran = 'csnt' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("Search among posted Cash Sales [no Tax] :"),
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Cash Sale [no Tax]") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);
	$dateformat = exapi_lang('Must be a valid date [format: YYYY-MM-DD]') ;
	$ckapi[filter][] = array(criteria	=>	exapi_lang('Customer') ,
				type		=>	'select' ,
				selectlist	=>	"<OPTION value='ALL'></OPTION>".selectlist('customer','name','','','id','name','id'),
				varname		=>	'customer' ,
				defval		=>	"ALL" ,
				note		=>	exapi_lang('Select the appropriate customer'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Cashier') ,
				type		=>	'input' ,
				varname		=>	'cashier' ,
				defval		=>	"" ,
				note		=>exapi_lang('Search for target key word in the cashier field'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Cash Sale Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>	$dateformat			);

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Cash Sale Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>	$dateformat			);

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Cash Sale Number') ,
				type		=>	'input' ,
				varname		=>	'posnumber' ,
				defval		=>	"" ,
			note=>exapi_lang('Search for target key word/number in the cash sale number field') );

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
