<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// cswtmemo.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-pos-c' ;
	$tran = 'cswtmemo' ;
	$noheader = $nonavbar = True ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=stripslashes($filter);

	$t = ckapi_tpl($app);
	$t->set_file('report',"$tran.tpl") ;
	$t->set_block('report','item','item_section');
	$t->set_block('report','addon','addon_section');
	$t->set_block('report','qcash','qcash_section');

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title=exapi_lang('Sales Memo Image (Use browser to print the Sales Memo shown above)');
	$t->set_var('lang_title',$title);
	$notes=exapi_lang('[This is a sample subject to tailoring per individual printer & Sales Memo format]');
	$t->set_var('lang_notes',$notes);
	$t->set_var('charset',exapi_lang('charset'));
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$logofile = $ckapi[hostsys][dataarea]."/images/logo.png" ;
	$t->set_var('logo',exapi_link("/ck-admin/logoview_image.php","imgfile=$logofile"));

/*------------- Write Payment to Screen Display ----------------------------*/

	$result = $adodb->query("SELECT * FROM ${pre}defaults");
	$company = $result->fields('company') ;
	$currency = $result->fields('nativecurr') ;
	$tax1cap = $result->fields('postax1cap') ;
	$tax2cap = $result->fields('postax2cap') ;
	$sm_rmkid = $result->fields('sm_rmkid') ;
	$result = $adodb->query("SELECT * FROM ${pre}remark where id='$sm_rmkid'");
	$remark = $result->fields('detail') ;

	$result = $adodb->query("SELECT * FROM ${pre}pos WHERE id='$id'");
	$transdate = $result->fields('transdate') ;
	$posnumber = $result->fields('posnumber') ;
	$transdate = date("Y-m-d",strtotime($transdate)) ;

	$t->set_var('lang_memo',exapi_lang('*** SALE MEMO ***'));
	$t->set_var('lang_transdate',exapi_lang('Date'));
	$t->set_var('lang_posnumber',exapi_lang('Ref. Number'));
	$t->set_var('lang_itemid',exapi_lang('Item ID'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_qty',exapi_lang('Qty'));
	$t->set_var('lang_price',exapi_lang('Price'));
	$t->set_var('lang_discount',exapi_lang('Discount'));
	$t->set_var('lang_amount',exapi_lang('Gross Amount'));
	$t->set_var('lang_netamount',exapi_lang('Net Amount').'<br>'.exapi_lang('(net of tax)'));
	$t->set_var('lang_tax1',$tax1cap.'<br>'.exapi_lang('(Rate)'));
	$t->set_var('lang_tax2',$tax2cap.'<br>'.exapi_lang('(Rate)'));

	$t->set_var('transdate',$transdate) ;
	$t->set_var('posnumber',$posnumber) ;

// ---------------------------- Begin list items -----------------------------------------

	$user = $ckapi[hostsys][username];
	$temp = "${pre}memo".$user.time() ;

	$result = $adodb->query("SELECT * FROM ${pre}pos WHERE id='$id'") ;
	$taxincluded = $result->fields('taxincluded') ;

	$total = $totnet = $tottax1 = $tottax2 = 0 ;
	$sql =	"CREATE TABLE $temp AS " ;
	$sql.=	"SELECT a.id as id,itemid,description,qty,a.price,discount,tax1,tax2 " ;
	$sql.=	"FROM ${pre}positem a, ${pre}parts b " ;
	$sql.=	"WHERE trans_id='$id' and itemtype='i' and itemid=b.id " ;
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp (id,itemid,description,qty,price,discount,tax1,tax2) " ;
	$sql.=	"SELECT a.id as id,itemid,description,qty,a.price,discount,tax1,tax2 " ;
	$sql.=	"FROM ${pre}positem a, ${pre}service b " ;
	$sql.=	"WHERE trans_id='$id' and itemtype='s' and itemid=b.id " ;
	$adodb->query($sql);
	$sql = "SELECT * FROM $temp ORDER BY id" ;
	$result = $adodb->query($sql) ;
	While ($rs=$result->fetchRow()) {
		$itemid = $rs['itemid'] ;
		$qty = $rs['qty'] ;
		$price = $rs['price'] ;
		$discount = $rs['discount'] ;
		$tax1 = number_format($rs['tax1'],2,".",'') ;
		$tax2 = number_format($rs['tax2'],2,".",'') ;
		$amount = ($taxincluded=='t') ? number_format($qty*$price-$discount,2,".",'') : number_format($qty*$price-$discount+$tax1+$tax2,2,".",'') ;
		$netamount = number_format($amount-$tax1-$tax2,2,".",'') ;
		$tax1rate = number_format($tax1/$netamount*100,2,".",'') ;
		$tax2rate = number_format($tax2/$netamount*100,2,".",'') ;
		$tax1str = "$tax1 ($tax1rate%)" ;
		$tax2str = "$tax2 ($tax2rate%)" ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'description'	=> $rs['description'],
					'qty'		=> $qty,
					'price'		=> $price,
					'discount'	=> $discount ,
					'amount'	=> $amount ,
					'netamount'	=> $netamount ,
					'tax1'		=> $tax1str ,
					'tax2'		=> $tax2str ));
		$t->parse('item_section','item',true);
		$total+= $amount ;
		$totnet += $netamount ;
		$tottax1 += $tax1 ;
		$tottax2 += $tax2 ;
		}
	$t->set_var('lang_total',exapi_lang("Total Purchase (Currency:")." $currency)") ;
	$t->set_var('total_amount',$total) ;
	$t->set_var('total_netamount',$totnet) ;
	$t->set_var('total_tax1',$tottax1) ;
	$t->set_var('total_tax2',$tottax2) ;
	$t->set_var('lang_addon',exapi_lang("Add-on Charges/Discounts:")) ;

	$totalp = $total ;
	$totaotax1 = $totaotax2 = 0 ;
	$sql = "SELECT itemid,name,value,a.factor as factor,tax1,tax2 FROM ${pre}positem a, ${pre}addon b " ;
	$sql.=	"WHERE trans_id='$id' and itemtype='a' and itemid=b.id " ;
	$result = $adodb->query($sql) ;
	if ($result->RecordCount()<=0)			$t->set_var('addon_section',"") ;
	While ($rs=$result->fetchRow()) {
		$itemid = $rs['itemid'] ;
		$value = $rs['value'] ;
		$factor = $rs['factor'] ;
		$basis = ($value == $totnet) ? " ".exapi_lang('Net Amount') : " ".exapi_lang('Gross Amount') ;
		$amount = $value * $factor ;
		$tax1 = number_format($rs['tax1'],2,".",'') ;
		$tax2 = number_format($rs['tax2'],2,".",'') ;
		$tax1rate = number_format($tax1/$amount*100,2,".",'') ;
		$tax2rate = number_format($tax2/$amount*100,2,".",'') ;
		$tax1str = "$tax1 ($tax1rate%)" ;
		$tax2str = "$tax2 ($tax2rate%)" ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'name'		=> $rs['name'],
					'factor'	=> $factor*100,
					'basis'		=> $basis ,
					'amount'	=> $amount ,
					'netamount'	=> '' ,
					'tax1'		=> $tax1str ,
					'tax2'		=> $tax2str ));
		$t->parse('addon_section','addon',true);
		$totalp+= $amount ;
		$totaotax1 += $tax1 ;
		$totaotax2 += $tax2 ;
		}
	$t->set_var('lang_totalt',exapi_lang("Total Tax on Addon's")) ;
	$t->set_var('total_addontax',$totaotax1+$totaotax2) ;
	$t->set_var('total_aotax1',$totaotax1) ;
	$t->set_var('total_aotax2',$totaotax2) ;
	$t->set_var('lang_totalp',exapi_lang("Total Payable (Currency:")." $currency)") ;
	$t->set_var('total_pamount',$totalp+$totaotax1+$totaotax2) ;
	$t->set_var('total_aotax1',$totaotax1) ;
	$t->set_var('total_aotax2',$totaotax2) ;
	$t->set_var('lang_qcash',exapi_lang("Customer Payments:")) ;

	$sql = "SELECT itemid,name,qty,a.value as value FROM ${pre}positem a, ${pre}qcash b " ;
	$sql.=	"WHERE trans_id='$id' and itemtype='q' and itemid=b.id " ;
	$result = $adodb->query($sql) ;
	While ($rs=$result->fetchRow()) {
		$itemid = $rs['itemid'] ;
		$qty = $rs['qty'] ;
		$value = $rs['value'] ;
		$amount = $qty * $value ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'name'		=> $rs['name'],
					'qty'		=> $qty,
					'value'		=> $value,
					'amount'	=> $amount ));
		$t->parse('qcash_section','qcash',true);
		}
	$t->set_var('lang_totalc',exapi_lang("Total Change (Currency:")." $currency)") ;
	$result = $adodb->query("SELECT value FROM ${pre}positem WHERE trans_id='$id' and itemtype='c'") ;
	$change = $result->fields('value') ? $result->fields('value') : 0 ;
	$t->set_var('total_camount',$change) ;

	$t->set_var('lang_thank',exapi_lang('Thank you for shopping with us!')) ;
	$t->set_var('lang_remark',$remark) ;

	$adodb->query("DROP TABLE $temp");

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',exapi_link("/$app/cswtlist.php","filter=$filter"));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report',True);
	exapi_footer() ;

?>


