<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// controlreport.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-pos-m' ;
	$tran = 'controlreport' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$repdate = ($_GET["repdate"]) ? $_GET["repdate"] : $_POST["repdate"] ;

	$t = ckapi_tpl($app);
	$t->set_file('report',"$tran.tpl");

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_control_report', exapi_lang('Point of Sale Audit Control Report'));
	$t->set_var('lang_detail', exapi_lang('Detail'));
	$t->set_var('lang_date', exapi_lang('Date'));
	$t->set_var('lang_sprice', exapi_lang('Special Price'));
	$t->set_var('lang_addon', exapi_lang('Add On'));
	$t->set_var('lang_qcash', exapi_lang('Quasi Cash'));
	$t->set_var('lang_tax', exapi_lang('Tax Type'));
	$t->set_var('lang_pos', exapi_lang('Header Record'));
	$t->set_var('lang_positem', exapi_lang('Detail Record'));
	$t->set_var('lang_receipt', exapi_lang('Receipt'));
	$t->set_var('lang_requested_status', exapi_lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', exapi_lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_asof', exapi_lang('Status as of'));
	$t->set_var('lang_print_date', exapi_lang('Date Report Printed'));
	$t->set_var('lang_status_note', " ".exapi_lang('(note the effect of postdated journals)'));
	$t->set_var('lang_total_amount', exapi_lang('Total Amount'));
	$t->set_var('lang_total_netamount', exapi_lang('Total Amount (Net of Tax)'));
	$t->set_var('lang_total_addontax', exapi_lang('Tax charged as Add-On'));
	$t->set_var('lang_total_tax', exapi_lang('Total Tax'));
	$t->set_var('lang_total_count', exapi_lang('Total Record Count'));
	$t->set_var('lang_latest_id', exapi_lang('Latest Audit Trail ID'));

/*-----------------Gather and Write Status Date Info---------------------------------*/

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount, count(id) as count, max(id) as id " ;
$sql.=	"FROM ${pre}pos WHERE transdate <= '$repdate'" ;
$result = $adodb->query($sql);
$pos_amount = $result->fields('amount') ;
$pos_netamount = $result->fields('netamount') ;
$pos_count = $result->fields('count') ;
$pos_id = $result->fields('id') ;
$sql =	"SELECT sum(qty*price-discount-tax1-tax2) as positem_netamount from ${pre}positem a,${pre}pos b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='t' and (itemtype='i' or itemtype='s')";
$result = $adodb->query($sql);
$positem_netamount = $result->fields('positem_netamount') ;
$sql =	"SELECT sum(qty*price-discount) as positem_netamount from ${pre}positem a,${pre}pos b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id and (b.taxincluded='f' or b.taxincluded='e') and ".
	" (itemtype='i' or itemtype='s')" ;
$result = $adodb->query($sql);
$positem_netamount+= $result->fields('positem_netamount') ;
$sql =	"SELECT sum(value*factor) as positem_netamount from ${pre}positem a,${pre}pos b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id and itemtype='a'" ;
$result = $adodb->query($sql);
$positem_netamount+= $result->fields('positem_netamount') ;
$sql =	"SELECT sum(value*factor) as addon_tax from ${pre}positem a,${pre}pos b,${pre}tax c " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id and itemtype='a' and " ;
$sql.=	"chart_id=incacc_id and taxgroup='cs'" ;
$result = $adodb->query($sql);
$addon_tax = $result->fields('addon_tax') ;
$positem_netamount-= $addon_tax ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from ${pre}positem a,${pre}pos b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$result = $adodb->query($sql);
$positem_tax = $result->fields('tax1')+$result->fields('tax2') + $addon_tax ;

$sql =	"SELECT count(a.id) as count, max(a.id) as id from ${pre}positem a,${pre}pos b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$result = $adodb->query($sql);
$positem_count = $result->fields('count') ;
$positem_id = $result->fields('id') ;

$t->set_var('status_date',$repdate) ;
$t->set_var('pos_amount',sprintf("%01.2f",$pos_amount)) ;
$t->set_var('pos_netamount',sprintf("%01.2f",$pos_netamount)) ;
$t->set_var('positem_addontax',sprintf("%01.2f",$addon_tax)) ;
$t->set_var('positem_nettax',sprintf("%01.2f",$positem_netamount)) ;
$t->set_var('positem_tax',sprintf("%01.2f",$positem_tax)) ;
$t->set_var('receipt_amount',sprintf("%01.2f",$receipt_amount)) ;
$t->set_var('pos_count',$pos_count) ;
$t->set_var('positem_count',$positem_count) ;
$t->set_var('receipt_count',$receipt_count) ;
$t->set_var('pos_id',$pos_id) ;
$t->set_var('positem_id',$positem_id) ;
$t->set_var('receipt_id',$receipt_id) ;

/*-----------------Gather and Write Total System Info-----------------------------*/

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount, count(id) as count, max(id) as id from ${pre}pos ";
$result = $adodb->query($sql);
$pos_amount = $result->fields('amount') ;
$pos_netamount = $result->fields('netamount') ;
$pos_count = $result->fields('count') ;
$pos_id = $result->fields('id') ;

$sql =	"SELECT sum(qty*price-discount-tax1-tax2) as positem_netamount from ${pre}positem a,${pre}pos b " .
	"WHERE a.trans_id=b.id and b.taxincluded='t' and (itemtype='i' or itemtype='s')" ;
$result = $adodb->query($sql);
$positem_netamount = $result->fields('positem_netamount') ;
$sql =	"SELECT sum(qty*price-discount) as positem_netamount from ${pre}positem a,${pre}pos b " .
	"WHERE a.trans_id=b.id and (b.taxincluded='f' or b.taxincluded='e') and (itemtype='i' or itemtype='s')";
$result = $adodb->query($sql);
$positem_netamount+= $result->fields('positem_netamount') ;
$sql =	"SELECT sum(value*factor) as positem_netamount from ${pre}positem a,${pre}pos b ";
$sql.=	"WHERE a.trans_id=b.id and itemtype='a'" ;
$result = $adodb->query($sql);
$positem_netamount+= $result->fields('positem_netamount') ;
$sql =	"SELECT sum(value*factor) as addon_tax from ${pre}positem a,${pre}pos b,${pre}tax c " ;
$sql.=	"WHERE a.trans_id=b.id and itemtype='a' and chart_id=incacc_id and taxgroup='cs'" ;
$result = $adodb->query($sql);
$addon_tax = $result->fields('addon_tax') ;
$positem_netamount-= $addon_tax ;

$result = $adodb->query("SELECT sum(tax1) as tax1, sum(tax2) as tax2 from ${pre}positem a,${pre}pos b WHERE a.trans_id=b.id");
$positem_tax = $result->fields('tax1')+$result->fields('tax2') + $addon_tax ;

$result = $adodb->query("SELECT count(a.id) as count, max(a.id) as id from ${pre}positem a,${pre}pos b WHERE a.trans_id=b.id");
$positem_count = $result->fields('count') ;
$positem_id = $result->fields('id') ;

$result = $adodb->query("SELECT max(id) as id,count(id) as count FROM ${pre}sprice");
$sprice_id = $result->fields('id') ;
$sprice_count = $result->fields('count') ;

$result = $adodb->query("SELECT max(id) as id,count(id) as count FROM ${pre}addon");
$addon_id = $result->fields('id') ;
$addon_count = $result->fields('count') ;

$result = $adodb->query("SELECT max(id) as id,count(id) as count FROM ${pre}qcash");
$qcash_id = $result->fields('id') ;
$qcash_count = $result->fields('count') ;

$result = $adodb->query("SELECT max(id) as id,count(id) as count FROM ${pre}tax WHERE taxgroup='cs'");
$tax_id = $result->fields('id') ;
$tax_count = $result->fields('count') ;


$t->set_var('print_date',date("Y-m-d")) ;
$t->set_var('sys_pos_amount',sprintf("%01.2f",$pos_amount)) ;
$t->set_var('sys_pos_netamount',sprintf("%01.2f",$pos_netamount)) ;
$t->set_var('sys_positem_addontax',sprintf("%01.2f",$addon_tax)) ;
$t->set_var('sys_positem_nettax',sprintf("%01.2f",$positem_netamount)) ;
$t->set_var('sys_positem_tax',sprintf("%01.2f",$positem_tax)) ;
$t->set_var('sys_sprice_count',$sprice_count) ;
$t->set_var('sys_addon_count',$addon_count) ;
$t->set_var('sys_qcash_count',$qcash_count) ;
$t->set_var('sys_tax_count',$tax_count) ;
$t->set_var('sys_pos_count',$pos_count) ;
$t->set_var('sys_positem_count',$positem_count) ;
$t->set_var('sys_sprice_id',$sprice_id) ;
$t->set_var('sys_addon_id',$addon_id) ;
$t->set_var('sys_qcash_id',$qcash_id) ;
$t->set_var('sys_tax_id',$tax_id) ;
$t->set_var('sys_pos_id',$pos_id) ;
$t->set_var('sys_positem_id',$positem_id) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report');
	exapi_footer() ;

?>
