<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// controlreport.php 0.13.1 2005/06/15 C K Wu

	$app = 'ck-quote' ;
	$tran = 'controlreport' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$repdate = ($_GET["repdate"]) ? $_GET["repdate"] : $_POST["repdate"] ;

	$t = ckapi_tpl($app);
	$t->set_file('report',"$tran.tpl");
	$t->set_block('report','block1','block1_section');
	$t->set_block('report','block2','block2_section');

/*---------------------------------------------------------------------------------*/

	$note1 = exapi_lang('Note 1') ;
	$t->set_var('lang_control_report', exapi_lang('Quotation Audit Control Report'));
	$t->set_var('lang_detail', exapi_lang('Detail'));
	$t->set_var('lang_note', exapi_lang('Note'));
	$t->set_var('lang_date', exapi_lang('Date'));
	$t->set_var('lang_customer', exapi_lang('Customer'));
	$t->set_var('lang_tax', exapi_lang('Tax Type'));
	$t->set_var('lang_quote', exapi_lang('Quotation'));
	$t->set_var('lang_oitem', exapi_lang('Order Item'));
	$t->set_var('lang_requested_status', exapi_lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', exapi_lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_asof', exapi_lang('Status as of'));
	$t->set_var('lang_print_date', exapi_lang('Date Report Printed'));
	$t->set_var('lang_status_note'," ".exapi_lang('(note the effect of postdated Quotations)'));
	$t->set_var('lang_note1',$note1);
	$t->set_var('lang_total_amount', exapi_lang('Total Amount'));
	$t->set_var('lang_total_netamount', exapi_lang('Total Amount (Net of Tax)'));
	$t->set_var('lang_total_tax', exapi_lang('Total Tax'));
	$t->set_var('lang_total_count', exapi_lang('Total Record Count'));
	$t->set_var('lang_latest_id', exapi_lang('Latest Audit Trail ID'));
	$note1a = exapi_lang('These lines are for control reconciliation purpose only') ;
	$note1b = exapi_lang('The figures represent an amalgamation of different currency amounts') ;
	$t->set_var('note1',"$note1 - $note1a. $note1b.");

/*-----------------Gather and Write Status Date Info---------------------------------*/

$sql =	"SELECT isocode,sum(amount) as curr_amount FROM ${pre}quote " ;
$sql.=	"WHERE transdate <= '$repdate' GROUP BY isocode ORDER BY isocode" ;
$result = $adodb->query($sql);
if ($result->RecordCount()==0)	$t->set_var('block1_section',"");

While ($rs=$result->fetchRow()) {
	$t->set_var(array('isocode'	=> $rs['isocode'],
			'curr_amount'	=> $rs['curr_amount']  ));
	$t->parse('block1_section','block1',true);
	}

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount from ${pre}quote WHERE transdate <= '$repdate'" ;
$result = $adodb->query($sql);
$quote_amount = $result->fields('amount') ;
$quote_netamount = $result->fields('netamount') ;

$sql =	"SELECT sum(qty*price-discount-tax1-tax2) as oitem_amount from ${pre}oitem a,${pre}quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='t'" ;
$result = $adodb->query($sql);
$oitem_netamount = $result->fields('oitem_amount') ;
$sql =	"SELECT sum(qty*price-discount) as oitem_amount from ${pre}oitem a,${pre}quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='f'" ;
$result = $adodb->query($sql);
$oitem_netamount += $result->fields('oitem_amount') ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from ${pre}oitem a,${pre}quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$result = $adodb->query($sql);
$oitem_tax = $result->fields('tax1')+$result->fields('tax2') ;

$sql =	"SELECT count(id) as count from ${pre}quote WHERE transdate <= '$repdate'" ;
$result = $adodb->query($sql);
$quote_count = $result->fields('count') ;

$sql =	"SELECT count(a.id) as count from ${pre}oitem a,${pre}quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$result = $adodb->query($sql);
$oitem_count = $result->fields('count') ;

$sql =	"SELECT max(id) as id from ${pre}quote WHERE transdate <= '$repdate'" ;
$result = $adodb->query($sql);
$quote_id = $result->fields('id') ;

$sql =	"SELECT max(a.id) as id from ${pre}oitem a,${pre}quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$result = $adodb->query($sql);
$oitem_id = $result->fields('id') ;

$t->set_var('status_date',$repdate) ;
$t->set_var('quote_amount',sprintf("%01.2f",$quote_amount)) ;
$t->set_var('quote_netamount',sprintf("%01.2f",$quote_netamount)) ;
$t->set_var('oitem_netamount',sprintf("%01.2f",$oitem_netamount)) ;
$t->set_var('oitem_tax',sprintf("%01.2f",$oitem_tax)) ;
$t->set_var('payment_amount',sprintf("%01.2f",$payment_amount)) ;
$t->set_var('quote_count',$quote_count) ;
$t->set_var('oitem_count',$oitem_count) ;
$t->set_var('payment_count',$payment_count) ;
$t->set_var('quote_id',$quote_id) ;
$t->set_var('oitem_id',$oitem_id) ;

/*-----------------Gather and Write Total System Info-----------------------------*/

$sql =	"SELECT isocode,sum(amount) as curr_amount FROM ${pre}quote " ;
$sql.=	"GROUP BY isocode ORDER BY isocode" ;
$result = $adodb->query($sql);
if ($result->RecordCount()==0)	$t->set_var('block2_section',"");

While ($rs=$result->fetchRow()) {
	$t->set_var(array('isocode'	=> $rs['isocode'],
			'curr_amount'	=> $rs['curr_amount']  ));
	$t->parse('block2_section','block2',true);
	}

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount from ${pre}quote " ;
$result = $adodb->query($sql);
$quote_amount = $result->fields('amount') ;
$quote_netamount = $result->fields('netamount') ;

$sql =	"SELECT sum(qty*price-discount-tax1-tax2) as oitem_amount from ${pre}oitem a,${pre}quote b " .
	"WHERE a.trans_id=b.id and b.taxincluded='t'" ;
$result = $adodb->query($sql);
$oitem_netamount = $result->fields('oitem_amount') ;
$sql =	"SELECT sum(qty*price-discount) as oitem_amount from ${pre}oitem a,${pre}quote b " .
	"WHERE a.trans_id=b.id and b.taxincluded='f'" ;
$result = $adodb->query($sql);
$oitem_netamount += $result->fields('oitem_amount') ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from ${pre}oitem a,${pre}quote b WHERE a.trans_id=b.id" ;
$result = $adodb->query($sql);
$oitem_tax = $result->fields('tax1')+$result->fields('tax2') ;

$sql =	"SELECT count(id) as count FROM ${pre}customer" ;
$result = $adodb->query($sql);
$customer_count = $result->fields('count') ;

$sql =	"SELECT count(id) as count FROM ${pre}tax WHERE taxgroup='ar'" ;
$result = $adodb->query($sql);
$tax_count = $result->fields('count') ;

$sql =	"SELECT count(id) as count FROM ${pre}quote" ;
$result = $adodb->query($sql);
$quote_count = $result->fields('count') ;

$sql =	"SELECT count(a.id) as count FROM ${pre}oitem a,${pre}quote b WHERE a.trans_id=b.id" ;
$result = $adodb->query($sql);
$oitem_count = $result->fields('count') ;

$sql =	"SELECT max(id) as id FROM ${pre}customer" ;
$result = $adodb->query($sql);
$customer_id = $result->fields('id') ;

$sql =	"SELECT max(id) as id FROM ${pre}tax WHERE taxgroup='ar'" ;
$result = $adodb->query($sql);
$tax_id = $result->fields('id') ;

$sql =	"SELECT max(id) as id FROM ${pre}quote" ;
$result = $adodb->query($sql);
$quote_id = $result->fields('id') ;

$sql =	"SELECT max(a.id) as id FROM ${pre}oitem a,${pre}quote b WHERE a.trans_id=b.id" ;
$result = $adodb->query($sql);
$oitem_id = $result->fields('id') ;

$t->set_var('print_date',date("Y-m-d")) ;
$t->set_var('sys_quote_amount',sprintf("%01.2f",$quote_amount)) ;
$t->set_var('sys_quote_netamount',sprintf("%01.2f",$quote_netamount)) ;
$t->set_var('sys_oitem_netamount',sprintf("%01.2f",$oitem_netamount)) ;
$t->set_var('sys_oitem_tax',sprintf("%01.2f",$oitem_tax)) ;
$t->set_var('sys_customer_count',$customer_count) ;
$t->set_var('sys_tax_count',$tax_count) ;
$t->set_var('sys_quote_count',$quote_count) ;
$t->set_var('sys_oitem_count',$oitem_count) ;
$t->set_var('sys_payment_count',$payment_count) ;
$t->set_var('sys_customer_id',$customer_id) ;
$t->set_var('sys_tax_id',$tax_id) ;
$t->set_var('sys_quote_id',$quote_id) ;
$t->set_var('sys_oitem_id',$oitem_id) ;


/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report');
	exapi_footer() ;

?>
