<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.la.inc.php 0.13.1 2005/06/15 C K Wu

    class la {

//---- LA List SQL Formation

    function la_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$where = str_replace("approved_by=''","(approved_by='' or approved_by is NULL)",$where) ;
	$lang_leave = strtolower(exapi_lang('leave')) ;
	if (!$order) {$order = "staff,leavefrom,leaveto" ; }
	if (!$sort)  {$sort = "ASC" ; }
	$sql =  "SELECT b.name as staff,a.*,description " ;
	$sql.=  "FROM ${pre}leaveapp a, ${pre}employee b, ${pre}category c " ;
	$sql.=  "WHERE $where and empid=b.id and leavecode=c.name and c.type='$lang_leave' and app='ck-hr' " ;
	$sql.=	"order by $order $sort" ;
	return $sql ;
	}

//---- LA List Link Adjustement

    function la_list_adjust() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	if ($ckapi[params_list][dt][approved_by]=='')
		$t->set_var(array(	'lang_cancel'	=> '',
					'cancel'	=> ''	)) ;
	  else	$t->set_var(array(	'lang_approve'	=> '',
					'lang_reject'	=> '',
					'approve'	=> '',
					'reject'	=> ''	)) ;
	}

//---- LA Read

    function la_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$result = $adodb->query("select * from ${pre}leaveapp WHERE id='$id'");
	return $result->fetchRow() ;
	}

//---- LA Validation Checks

    function la_validate() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;
	$err="";
	$error = exapi_lang("Error") ;
	if ($dt[reason]=="")	$err=exapi_lang("Cancel/Reject Reason Missing") ;

	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write LA Detail

    function la_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_empid',exapi_lang('Employee Name/#'));
	$t->set_var('lang_id',exapi_lang('ID#'));
	$t->set_var('lang_leavefrom',exapi_lang('Leave From'));
	$t->set_var('lang_leaveto',exapi_lang('Leave To'));
	$t->set_var('lang_duration',exapi_lang('Duration in Workdays'));
	$t->set_var('lang_leavecode',exapi_lang('Leave Code -- Description'));
	$t->set_var('lang_approved_by',exapi_lang('Approved By'));
	$lang_leave = exapi_lang('leave') ;
	$user = $ckapi[hostsys][username];
	$empid = $dt[empid] ;
	$sql = "SELECT * FROM ${pre}employee a, ${pre}employee b " ;
	$sql.= "WHERE a.id='$empid' and a.supervisor=b.id and b.contactid='$_GET[contactid]'";
	$result = $adodb->query($sql);
	if ($result->RecordCount()==0)	die(exapi_lang("You are not authorised to access the requested information.")) ;
	$where = " WHERE id='$dt[empid]' " ;

	$t->set_var('empid_selectlist',selectlist('employee','name',$where,$dt[empid],'id','name','id')) ;
	$t->set_var('staff',$dt[staff]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('leavefrom',$dt[leavefrom]);
	$t->set_var('leaveto',$dt[leaveto]);
	$t->set_var('duration',$dt[duration]);
	$where = "WHERE app='ck-hr' and type='$lang_leave' and name<>'SL' and name<>'UA'" ;
	$leavecode_sl = selectlist('category','name',$where,$dt[leavecode],'name','name','substring(description,1,25)');
	$t->set_var('leavecode_selectlist',$leavecode_sl);
	$t->set_var('approved_by',$dt[approved_by]);
	$t->set_var('reason',$dt[reason]);
	$t->parse('out','report',True);
	}

//---- LA Post Initialisation

    function la_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][approved_by] = "" ;
	}

//---- LA Post - PostCommit Routine

    function la_post_postcommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$lang_tran = $ckapi[phrases][lang_tran] ;
	$actioned = $ckapi[phrases][actioned] ;

	$lang_from = exapi_lang("FROM") ;
	$lang_to = exapi_lang("TO") ;
	$lang_approval = exapi_lang("Approval") ;
	$lang_reason = exapi_lang("Reason") ;
	$inform = exapi_lang("Please manually inform") ;
	$leavefrom = $dt[leavefrom] ;
	$leaveto = $dt[leaveto] ;

	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername,a.contactid as empcontactid,b.contactid as supercontactid ";
	$sql.= "FROM ${pre}employee a, ${pre}employee b WHERE a.id='$dt[empid]' and a.supervisor=b.id" ;
	$result = $adodb->query($sql);
	$staffname = $result->fields('staffname');
	$superid = $result->fields('superid');
	$supername = $result->fields('supername');
	$empcontactid = $result->fields('empcontactid');
	$supercontactid = $result->fields('supercontactid');
	$sql = "SELECT commdata FROM ${pre}comm WHERE contactid='$empcontactid' and commcode='wemail'";
	$result = $adodb->query($sql);
	$staffemail = $result->fields('commdata') ;
	$sql = "SELECT commdata FROM ${pre}comm WHERE contactid='$supercontactid' and commcode='wemail'";
	$result = $adodb->query($sql);
	$superemail = $result->fields('commdata') ;
	$recipient = "$staffname < $staffemail >" ;
	$message = '' ;
	$headers = "From: $supername < $superemail >\n" ;
	$charset = exapi_lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $supername < $superemail >\n" ;

	switch ($op) :
	    case "approve" :
		$subject = "[$staffname] $lang_tran [$lang_from:$leavefrom $lang_to:$leaveto] $actioned." ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = exapi_lang("Email approving leave application successfully queued for despatch to") ;
		$failuremsg = exapi_lang("Email approving leave application fails to deliver.")."  $inform" ;
		break ;
	    case "cancel" :
		$subject = "[$staffname] $lang_tran [$lang_from:$leavefrom $lang_to:$leaveto] " ;
		$subject.= "$lang_approval $actioned.  $lang_reason: $dt[reason]" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg =exapi_lang("Email advising approval cancellation successfully queued for despatch to");
		$failuremsg =exapi_lang("Email advising approval cancellation fails to deliver.")."  $inform" ;
		break ;
	    case "reject" :
		$subject = "[$staffname] $lang_tran [$lang_from:$leavefrom $lang_to:$leaveto] $actioned.  " ;
		$subject.= "$lang_reason: $dt[reason]" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = exapi_lang("Email rejecting leave application successfully queued for despatch to") ;
		$failuremsg = exapi_lang("Email rejecting leave application fails to deliver.")."  $inform" ;
		break ;
	    endswitch ;

	if ($result)	$msg = "<br>$successmsg $staffname." ;
		else	$msg = "<br>$failuremsg $staffname." ;
	$ckapi[phrases]["reminder"] = $msg ;
	}

    }

?>

