<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.ts.inc.php 0.13.1 2005/06/15 C K Wu

    class ts {

//---- TS List SQL Formation

    function ts_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$where = str_replace("approved_by=''","(approved_by='' or approved_by is NULL)",$where) ;
	if (!$order) {$order = "name,year,week" ; }
	if (!$sort)  {$sort = "ASC" ; }
	$sql = "SELECT name,year,week,hour_ttl,day_ttl,approved_by,a.id " ;
	$sql.= "FROM ${pre}timesheet a, ${pre}employee b  " ;
	$sql.= "WHERE $where and empid=b.id ORDER BY ".$order." ".$sort ;
	return $sql ;
	}

//---- TS List Link Adjustement

    function ts_list_adjust() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	if ($ckapi[params_list][dt][approved_by]=='')
		$t->set_var(array(	'lang_cancel'	=> '',
					'cancel'	=> ''	)) ;
	  else	$t->set_var(array(	'lang_approve'	=> '',
					'lang_reject'	=> '',
					'approve'	=> '',
					'reject'	=> ''	)) ;
	}

//---- TS Read

    function ts_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$sql = "SELECT a.id,empid,name,year,week,hour_ttl,day_ttl,a.control " ;
	$sql.= "FROM ${pre}timesheet a,${pre}employee b " ;
	$sql.= "WHERE a.id=$id and empid=b.id";
	$result = $adodb->query($sql);
	$dt = $result->fetchRow() ;

	$sql = "SELECT a.*,b.* FROM ${pre}ts_trans a, ${pre}timesheet b " ;
	$sql.= "WHERE trans_id='$id' and a.trans_id=b.id ORDER BY a.id";
	$result = $adodb->query($sql);
	$dt[tsyear0] = date("Y") ;
	$dt[tsmonth0] = date("m") ;
	$dt[tsday0] = date("d") ;
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$transdate		=	$rs['transdate'] ;
		$dt['tsyear'.$i]	=	substr($transdate,0,4) ;
		$dt['tsmonth'.$i]	=	substr($transdate,5,2) ;
		$dt['tsday'.$i]		=	substr($transdate,8,2) ;
		$dt['project'.$i]	=	$rs['project'] ;
		$dt['activity'.$i]	=	$rs['activity'] ;
		$dt['hour'.$i]		=	$rs['hour'] ;
		$dt['day'.$i]		=	$rs['day'] ;
		$dt['achieve'.$i]	=	$rs['achieve'] ;
		$dt['achival'.$i]	=	$rs['achival'] ;
		$dt['achiunit'.$i]	=	$rs['achiunit'] ;
		}
	return $dt ;
	}

//---- TS Validation Checks

    function ts_validate() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;
	$err="";
	$error = exapi_lang("Error") ;
	if ($dt[reason]=="")	$err=exapi_lang("Cancel/Reject Reason Missing") ;

	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write ts Header

    function ts_header_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_empid',exapi_lang('Employee'));
	$t->set_var('lang_id',exapi_lang('Audit Id :'));
	$t->set_var('lang_year',exapi_lang('Year'));
	$t->set_var('lang_week',exapi_lang('Week'));
	$t->set_var('lang_approved_by',exapi_lang('Approved By'));
	$user = $ckapi[hostsys][username];
	$empid = $dt[empid] ;
	$sql = "SELECT * FROM ${pre}employee a, ${pre}employee b " ;
	$sql.= "WHERE a.id='$empid' and a.supervisor=b.id and b.contactid='$_GET[contactid]'";
	$result = $adodb->query($sql);
	if ($result->RecordCount()==0)	die(exapi_lang("You are not authorised to access the requested information.")) ;
	$where = "WHERE id='$empid'" ;
	$t->set_var('empid_selectlist',selectlist('employee','name',$where,'','id','name','id')) ;
	$t->set_var('year_selectlist',ymwd_selectlist('',$dt[year],'y')) ;
	$t->set_var('week_selectlist',ymwd_selectlist('',$dt[week],'w')) ;
	$t->set_var('approved_by',$dt[approved_by]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->parse('out','report',True);
	}

//---- Write ts Detail

    function ts_detail_write() {
	global $ckapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = exapi_lang('Row')." " ;
	$lang_activity = exapi_lang('activity') ;
	$lang_leave = exapi_lang('leave') ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_transdate',exapi_lang('Date'));
	$t->set_var('lang_pah',exapi_lang('Project---Activity/Leave---Hours---Days'));
	$t->set_var('lang_achievement',exapi_lang('Result Achieved'));
	$t->set_var('lang_insert',exapi_lang('Insert<br>before'));
	$t->set_var('lang_tsyear',exapi_lang('Year'));
	$t->set_var('lang_tsmonth',exapi_lang('Month'));
	$t->set_var('lang_tsday',exapi_lang('Day'));
	$t->set_var('lang_project',exapi_lang('Project'));
	$t->set_var('lang_activity',exapi_lang('Activity/Leave'));
	$t->set_var('lang_hour',exapi_lang('Hour Worked'));
	$t->set_var('lang_day',exapi_lang('Days On Leave'));
	$t->set_var('lang_achieve',exapi_lang('Achievement'));
	$t->set_var('lang_achival',exapi_lang('Value'));
	$t->set_var('lang_achiunit',exapi_lang('Unit'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('tsyear0_selectlist',ymwd_selectlist('',$dt[tsyear0],'y')) ;
	$t->set_var('tsmonth0_selectlist',ymwd_selectlist('',$dt[tsmonth0],'m')) ;
	$t->set_var('tsday0_selectlist',ymwd_selectlist('',$dt[tsday0],'d')) ;

	$nullopt = "<OPTION value=''></OPTION>" ;
	$act_sl = selectlist('category','name',"WHERE app='ck-hr' and type='$lang_activity'",'','name','name','substring(description,1,25)') ;
	$act_sl.= $nullopt ;
	$act_sl.= "<OPTION value=''>".exapi_lang('On Leave (Pls enter -0- as hours worked)')."</OPTION>" ;
	$act_sl.= selectlist('category','name',"WHERE app='ck-hr' and type='$lang_leave'",'','name','name','substring(description,1,25)') ;
	$lang_day = exapi_lang('day') ;
	$day_sl = $nullopt."<OPTION value='1'>1 $lang_day</OPTION><OPTION value='0.5'>0.5 $lang_day</OPTION>" ;
	$hour_ttl = 0;
	For ($i=1;isset($dt['tsyear'.$i]);$i++) {
		$t->set_var('tsyear_fld','tsyear'.$i) ;
		$t->set_var('tsmonth_fld','tsmonth'.$i) ;
		$t->set_var('tsday_fld','tsday'.$i) ;
		$t->set_var('project_fld','project'.$i) ;
		$t->set_var('activity_fld','activity'.$i) ;
		$t->set_var('hour_fld','hour'.$i) ;
		$t->set_var('day_fld','day'.$i) ;
		$t->set_var('achieve_fld','achieve'.$i);
		$t->set_var('achival_fld','achival'.$i);
		$t->set_var('achiunit_fld','achiunit'.$i);
		$t->set_var('tsyear_selectlist',ymwd_selectlist('',$dt['tsyear'.$i],'y')) ;
		$t->set_var('tsmonth_selectlist',ymwd_selectlist('',$dt['tsmonth'.$i],'m')) ;
		$t->set_var('tsday_selectlist',ymwd_selectlist('',$dt['tsday'.$i],'d')) ;
		$t->set_var('project_selectlist',$nullopt.selectlist('project','name','',$dt['project'.$i],'id','name')) ;
		$default = $dt['activity'.$i] ;
		$t->set_var('activity_selectlist',str_replace("'$default'","'$default' selected",$act_sl)) ;
		$t->set_var('hour',$dt['hour'.$i]) ;
		$default = $dt['day'.$i] ;
		$t->set_var('day_selectlist',str_replace("'$default'","'$default' selected",$day_sl)) ;
		$t->set_var('achieve_selectlist',selectlist('achievement','name','',$dt['achieve'.$i],'id','name')) ;
		$t->set_var('achival',$dt['achival'.$i]) ;
		$t->set_var('achiunit',$dt['achiunit'.$i]) ;
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}

	$t->set_var('lang_total',exapi_lang('Total'));
	$t->set_var('hour_ttl',$dt[hour_ttl]) ;
	$t->set_var('day_ttl',$dt[day_ttl]) ;
	$t->set_var('reason',$dt[reason]) ;

	$t->parse('out','report',True);
	}

//---- TS Post - PreCommit Routine

    function ts_post_precommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	$empid = $dt[empid] ;
	if ($op=='approve') {
		For ($i=1;isset($dt['tsyear'.$i]);$i++) {
			if ($dt['day'.$i]==0)	continue ;
			$transdate= $dt['tsyear'.$i]."-".$dt['tsmonth'.$i]."-".$dt['tsday'.$i];
			$leavecode	= $dt['activity'.$i] ;
			$duration	= $dt['day'.$i] ;
			$sql ="INSERT INTO ${pre}leave(empid,trans_id,leavefrom,leaveto,leavecode,duration) ";
			$sql.= "VALUES ('$empid','$id','$transdate','$transdate','$leavecode','$duration')";
			$adodb->query($sql);
			}
		}
	if ($op=='cancel')	$adodb->query("DELETE from ${pre}leave where trans_id = '$id'");
	}

//---- ts Post - PostCommit Routine

    function ts_post_postcommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key=>$val)	$ckapi[buttons][$key]=($_GET[$key])? $_GET[$key]:$_POST[$key];
	$lang_tran = $ckapi[phrases][lang_tran] ;
	$actioned = $ckapi[phrases][actioned] ;

	$lang_year = exapi_lang("YEAR") ;
	$lang_week = exapi_lang("WEEK") ;
	$lang_approval = exapi_lang("Approval") ;
	$lang_reason = exapi_lang("Reason") ;
	$inform = exapi_lang("Please manually inform") ;
	$year = $dt[year] ;
	$week = $dt[week] ;
	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername,a.contactid as empcontactid,b.contactid as supercontactid ";
	$sql.= "FROM ${pre}employee a, ${pre}employee b WHERE a.id='$dt[empid]' and a.supervisor=b.id" ;
	$result = $adodb->query($sql);
	$staffname = $result->fields('staffname');
	$superid = $result->fields('superid');
	$supername = $result->fields('supername');
	$empcontactid = $result->fields('empcontactid');
	$supercontactid = $result->fields('supercontactid');
	$sql = "SELECT commdata FROM ${pre}comm WHERE contactid='$empcontactid' and commcode='wemail'";
	$result = $adodb->query($sql);
	$staffemail = $result->fields('commdata') ;
	$sql = "SELECT commdata FROM ${pre}comm WHERE contactid='$supercontactid' and commcode='wemail'";
	$result = $adodb->query($sql);
	$superemail = $result->fields('commdata') ;
	$recipient = "$staffname < $staffemail >" ;
	$message = '' ;
	$headers = "From: $supername < $superemail >\n" ;
	$charset = exapi_lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $supername < $superemail >\n" ;

	switch ($op) :
	    case "approve" :
		$subject = "[$staffname] $lang_tran [$lang_year:$year $lang_week:$week] $actioned." ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = exapi_lang("Email approving timesheet successfully queued for despatch to") ;
		$failuremsg = exapi_lang("Email approving timesheet fails to deliver.")."  $inform" ;
		break ;
	    case "cancel" :
		$subject = "[$staffname] $lang_tran [$lang_year:$year $lang_week:$week] " ;
		$subject.= "$lang_approval $actioned.  $lang_reason: $dt[reason]" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg =exapi_lang("Email advising approval cancellation successfully queued for despatch to");
		$failuremsg =exapi_lang("Email advising approval cancellation fails to deliver.")."  $inform" ;
		break ;
	    case "reject" :
		$subject = "[$staffname] $lang_tran [$lang_year:$year $lang_week:$week] $actioned.  " ;
		$subject.= "$lang_reason: $dt[reason]" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = exapi_lang("Email rejecting timesheet successfully queued for despatch to") ;
		$failuremsg = exapi_lang("Email rejecting timesheet fails to deliver.")."  $inform" ;
		break ;
	    endswitch ;

	if ($result)	$msg = "<br>$successmsg $staffname." ;
		else	$msg = "<br>$failuremsg $staffname." ;
	$ckapi[phrases]["reminder"] = $msg ;
	}

    }

?>
